#include "stdafx.h"
#include <mmsystem.h>
#include <io.h>

#include "mainfrm.h"
#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#ifdef GRAPH_DA //////////////////////////////////////////////
void msg_cycle( char *txt, int* gz, int MAX_2);

extern char *IDS_NODES_INVALID;

static int r_height=0, r_width=0, DLTX_GRP=0, DLTY_GRP=0;
extern int resol, rx0,ry0;

///////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CGraphView, CFormView)

CGraphView::CGraphView() : CFormView(CGraphView::IDD)
{
    //{{AFX_DATA_INIT(CGraphView)
	m_strData = "";
    m_strAmpl = "3";
    m_randStarts = _T("");
    in_comparing = 0;
    cycle_flag = 0;
    hArrowCur = LoadCursor(0, IDC_ARROW);
    hWaitCur  = LoadCursor(0, IDC_WAIT);
    //}}AFX_DATA_INIT
}

CGraphView::~CGraphView() {}

void CGraphView::OnInitialUpdate()
{
    CMainDoc* pD = GetDocument();

    pD->tsp.tsp_who = GRAPH_TEMP;
    pD->tsp.parent = this;
    pD->misc_init( GRAPH_TEMP, 8 );
//..........
    if( pD->m_ReadOK==TRUE )  m_strAmpl = pD->m_strAmpl;
    else                      pD->m_strAmpl = m_strAmpl;

    pD->tsp.ampl = atoi(m_strAmpl);  //in maindoc ampl=100

    if( pD->m_ReadOK==FALSE )  OnResetNet();

//??OnUpdate(this,0,NULL);

    int alr = pD->m_already;
    if( pD->m_ReadOK==TRUE )
    {
      m_cycle0 = pD->cycle_str(pD->tsp.initGZ);
      m_cycle_save = m_cycle0;
      if( alr )
        pD->ShowTime2( &FullTimeStr() );
    }
    else
      ShowCycle( 1 );

    pD->m_already = alr;
    if( pD->m_already )  ShowCycle( 0 );

    OnUpdate(this,0,NULL);
//////////////////
    CSplitterWnd *w = (CSplitterWnd*)GetParentFrame();

    if(resol!=1)  {
      if( !r_width )  {
        RECT r;  w->GetWindowRect(&r);
        if( !rx0 )  { rx0=r.left;  ry0=r.top; }
        else {
          DLTX_GRP = r.left-rx0;
          DLTY_GRP = r.top-ry0;
        }
        Cycle0Str().GetWindowRect(&r);
        r_width  = r.right+30-DLTX_GRP;
        r_height = r.bottom-16-DLTY_GRP;
      }
      w->SetWindowPos(NULL, 0,0, r_width, r_height, SWP_DRAWFRAME|SWP_NOMOVE);
    }
    else  w->ShowWindow(SW_SHOWMAXIMIZED);

    CFormView::OnInitialUpdate();
}

void CGraphView::OnUpdate(CView*, LPARAM, CObject*)
{
    CMainDoc* pD = GetDocument();

    m_strData = pD->m_strData;
    m_strAmpl = pD->m_strAmpl;
    m_randStarts = pD->m_randStarts;

    UpdateData(FALSE);  // set the data into the controls
}


void CGraphView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CGraphView)
    DDX_Text(pDX, IDC_NODES, m_strData);
	DDX_Text(pDX, IDC_AMPL, m_strAmpl);
	DDV_MaxChars(pDX, m_strAmpl, 5);
    DDX_Text(pDX, IDC_RAND_STARTS, m_randStarts);
    DDX_Text(pDX, IDC_INITIAL_CYCLE, m_cycle0);
    DDV_MaxChars(pDX, m_cycle0, 5000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGraphView, CFormView)
    //{{AFX_MSG_MAP(CGraphView)
    ON_EN_KILLFOCUS(IDC_NODES, OnDataChange)
	ON_BN_CLICKED(IDC_NET_EDITOR, OnNetEditor)
    ON_BN_CLICKED(IDC_IMPORT, OnImport)
	ON_BN_CLICKED(IDC_CM_TIME, OnGetFullTime)
	ON_BN_CLICKED(IDC_byIIG, OnGo)
	ON_BN_CLICKED(IDC_byCOMMON, OnCommon)
    ON_BN_CLICKED(IDC_MIN_INIT, OnMinInitial)
    ON_BN_CLICKED(IDC_RESET_NET, OnResetNet)
#ifdef SUPER_USER2
    ON_BN_CLICKED(IDC_NEW_RESET, OnResetNet2)
#endif
    ON_BN_CLICKED(IDC_TOGETHER, OnTogether)
	ON_BN_CLICKED(IDC_RAND_CYCLE0, OnRandCycle0)
	ON_BN_CLICKED(IDC_CONTINUOUS, OnContinuous)
	ON_BN_CLICKED(IDC_IF_ELSE, OnIfElse)
	ON_EN_KILLFOCUS(IDC_AMPL, OnDataChange)
    ON_EN_KILLFOCUS(IDC_RAND_STARTS, OnDataChange)   //???
	ON_BN_CLICKED(IDC_SHOW_STAT, OnShowStat)
    ON_EN_KILLFOCUS(IDC_INITIAL_CYCLE, OnDataChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////
void CGraphView::OnResetNet()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    pD->ResetNet();
    ShowCycle( 1 );    //->m_already=0;
}

void CGraphView::OnDataChange()
{
    if (!UpdateData())  return;
    CMainDoc* pD = GetDocument();

///////////////////
    if( pD->tsp.working ) {
      m_strData = pD->m_strData;
      m_strAmpl = pD->m_strAmpl;
      m_randStarts = pD->m_randStarts;
      UpdateData(FALSE);
      return;
    }
///////////////////

	BOOL bUpdate = FALSE;

    if (m_strData != pD->m_strData)
	{
        //check new MAX_2
        int newMAX_2 = atoi(m_strData);
        if( newMAX_2<4 || newMAX_2>=MAX2_LIMIT_G )
        {
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			char s[80];
            sprintf( s, IDS_NODES_INVALID, MAX2_LIMIT_G-1);
            MessageBox( s, "Error", MB_ICONEXCLAMATION | MB_OK);
            return;
        }

        if( !pD->tsp.ReAllocate( newMAX_2 ) )
		{
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			warn_me( IDS_USA_NO_MEMORY );

			pD->tsp.ReAllocate( atoi(m_strData) );
		}

        pD->m_strData = m_strData;
        OnResetNet();
        FullTimeStr().SetWindowText( "" ); //???
pD->m_already=0;

        bUpdate = TRUE;
    }

    if (m_strAmpl != pD->m_strAmpl)
	{
        int newAmpl = atoi(m_strAmpl);
        if( newAmpl<0/*1*/ || newAmpl>pD->tsp.MAX_2-1 )
        {
            m_strAmpl = pD->m_strAmpl;
            UpdateData(FALSE);
            warn_me( IDS_DEGREE_INVALID );
            return;
        }
        pD->m_strAmpl = m_strAmpl;
        pD->tsp.ampl = newAmpl;
        OnResetNet();
pD->m_already=0;

        bUpdate = TRUE;
	}

    if( m_cycle0 != m_cycle_save )
    {
       cycle_flag = 0;
       CheckCycle();
       if( cycle_flag )  {
         m_cycle0 = m_cycle_save;
         UpdateData(FALSE);
         cycle_flag = 0;
       }
       else   {
         pD->m_already = 0;
         m_cycle_save = m_cycle0;
       }
    }

    if (m_randStarts != pD->m_randStarts)
	{
        int tmp = atoi(m_randStarts);
        if( tmp<1 || tmp>SHRT_MAX )
        {
            m_randStarts = pD->m_randStarts;
            UpdateData(FALSE);
            return;
        }
        pD->m_randStarts = m_randStarts;
pD->m_already=0;
	}

    if (bUpdate)   {
//      pD->SetModifiedFlag();
        pD->UpdateAllViews(this);
    }
}

void CGraphView::OnGetFullTime()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

//#ifndef SUPER_USER
    pD->m_already = 0;

    pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );

    char s[80], s2[80];
    FullTimeStr().GetWindowText( s, 79 );
    if( pD->tsp.MAX_2<172 )
      sprintf(s2,"<= %s", s);
    else
      sprintf(s2,"> %s", s);
    FullTimeStr().SetWindowText( s2 );
/*
#else
    CSuper dlg;
    char str[80];
    sprintf(str, "%d", tirNUM);  dlg.m_tir = str;
    sprintf(str, "%d", perNUM);  dlg.m_per = str;
    sprintf(str, "%.3f",fstNUM); dlg.m_fst = str;
    sprintf(str, "%.3f",scdNUM); dlg.m_scd = str;

    if( dlg.DoModal() != IDOK )  return;

    tirNUM = atoi(dlg.m_tir);
    perNUM = atoi(dlg.m_per);
    fstNUM = atof(dlg.m_fst);
    scdNUM = atof(dlg.m_scd);
#endif
*/
}

void CGraphView::show_stat()
{
    GetDocument()->show_stat();
}

void CGraphView::OnNetEditor()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
//  if( pD->ShowEditor() )  ShowCycle( 1 ); //->m_already=0;
////////////////
    for(int i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.netDC[i][j] = pD->tsp.net[i][j];

    CMtxEditor dlg(pD->tsp.netDC, pD->tsp.MAX_2, GRAPH_TEMP);
    if( dlg.DoModal() != IDOK )  return;

    for(i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.net[i][j] = pD->tsp.netDC[i][j];

	ShowCycle( 1 ); //->m_already=0;
////////////////
}

void CGraphView::OnImport()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    pD->Import2();
	ShowCycle( 1 ); //->m_already=0;
}

////////////////////////////////////////////////////////////////////
void CGraphView::DoPolin()
{
    cycle_flag = 0;
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    CMainDoc* pD = GetDocument();
    pD->polyn_go( &FullTimeStr(), &CycleMinStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    ShowCycle( 0 );

    if( (pD->m_already==1 || pD->m_already==3)
       && pD->tsp.cycle_length( pD->tsp.GZ )!=0 )
      CycleMinStr().SetWindowText("Cycle in the graph does not exist.");
}


void CGraphView::OnGo()
{
#ifdef DEBUG
    int fout=_lcreat("result.",0); _lclose(fout);
#endif

    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int i, randStarts = atoi(pD->m_randStarts);
    int saveGZinit[MAX_1];
    int saveGZlast[MAX_1];

    DWORD save_polyn_time = 0;
    pD->all_time = timeGetTime();

    if( !pD->tsp.in_contin )  pD->test_cnt = pD->bad_cnt = pD->graph_cnt = 0;
//???
    int ne_was0 = 1;

	if(randStarts==1 || in_comparing)  {
      pD->tsp.Form_Cycle0( 0 );  //return initial cycle
int alr=pD->m_already;
ShowCycle( 1 );
pD->m_already=alr;
      DoPolin();
    }
    else
    {
      pD->m_already = 0;
      result = 1;

      DWORD the_start = timeGetTime();

      for(i=1; i<=randStarts; i++)
      {
        pD->tsp.Form_Cycle0( 1, TRUE );
        ShowCycle( 1/*initOK*/ );

        DoPolin();
        save_polyn_time += pD->pol_time;

        if( pD->m_already!=1 )  break;

        if(i==1)  {
          pD->tsp.save_min_cycle( 0/*save*/ );
          for(int k=1; k<=pD->tsp.MAX_2; k++)
            saveGZinit[k] = pD->tsp.initGZ[k];
          for(k=1; k<=pD->tsp.MAX_2; k++)
            saveGZlast[k] = pD->tsp.GZmin[k];
//!!!!
          ne_was0 = pD->tsp.cycle_length( pD->tsp.GZmin );
        }
        else if( !pD->tsp.save_min_cycle( 1/*compare*/ ) )
		{
          int sum2 = pD->tsp.cycle_length( pD->tsp.GZmin );
          int sum1 = pD->tsp.cycle_length( pD->tsp.saveGZmin );
          if( sum2<sum1 )
          {
            for(int k=1; k<=pD->tsp.MAX_2; k++)
              pD->tsp.initGZ[k] = saveGZinit[k];
            for(k=1; k<=pD->tsp.MAX_2; k++)
              pD->tsp.GZmin[k] = saveGZlast[k];
          }
//...........
          pD->bad_cnt++;
          result=0;
          break;
        }
      } //end FOR

      pD->pol_time = save_polyn_time;
      pD->ShowRealTime( /*the_start*/pD->all_time, &FullTimeStr() );
    }

    if( pD->bad_cnt && result==0 )
      warn_me( IDS_MISMATCH_ERR );

    if( pD->m_already!=1 && pD->m_already!=3 &&
        !in_comparing && !pD->tsp.in_contin )
    {
      warn_me(IDS_USER_ABORT);
      CycleMinStr().SetWindowText("Testing aborted by user.");
    }
    int sum1 = pD->tsp.cycle_length( pD->tsp.GZmin );
    if( !sum1 )  pD->graph_cnt++;

    if( pD->m_already!=1 && ne_was0==0 )  pD->graph_cnt++;

    if( !pD->tsp.in_contin && !in_comparing
      && m_bShowStat && pD->test_cnt )   show_stat( );
}

void CGraphView::OnCommon()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int res = pD->init_exp( &FullTimeStr(), &CycleMinStr(), in_comparing );
    if( !res )  return;
    exp_time = timeGetTime();

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );


    cycle_flag = 0;

    get_time_text( pD->tsp.exp_time, pD->get_time_in_sec()); //!!!

pD->tsp.Form_Cycle0( 0 );  //return initial cycle
ShowCycle( 1 );

    int ret_val;
    pD->tsp.lookALL_2( 0, &ret_val );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    if( !ret_val )  pD->m_already += 2;

    if( !pD->tsp.in_contin && pD->m_already)
    {
      pD->test_cnt=1;
      exp_time = pD->ShowRealTime( exp_time, &FullTimeStr() );
      ShowCycle( 0 );
    }

    if( pD->m_already>=2 && pD->tsp.cycle_length( pD->tsp.GZ )!=0 )
      CycleMinStr().SetWindowText("Cycle in the graph does not exist.");

if( pD->m_already<2 && !in_comparing)  {
  warn_me(IDS_USER_ABORT); //???
  CycleMinStr().SetWindowText("Testing aborted by user.");
}
}

void CGraphView::ShowCycle(int initOK)
{
  CMainDoc* pD = GetDocument();

  if( initOK )
  {
    m_cycle0 = pD->cycle_str(pD->tsp.GZ);
    m_cycle_save = m_cycle0;
//??Cycle0Str().SetWindowText( pD->cycle_str(pD->tsp.GZ) );
    CycleMinStr().SetWindowText("");
    if( pD->tsp.in_contin && pD->test_cnt ) ;
    else
      FullTimeStr().SetWindowText("");
    pD->m_already = 0;  //!!!
  }
  else if( pD->m_already )
  {
    if( pD->tsp.cycle_length(pD->tsp.GZ)==0 )
      CycleMinStr().SetWindowText( pD->cycle_str(pD->tsp.GZ) );
    else
      CycleMinStr().SetWindowText("Cycle in the graph does not exist.");
  }

  UpdateData(FALSE);
  pD->UpdateAllViews(this);
}

void CGraphView::OnMinInitial()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    if( !(pD->m_already) )  {  warn_me( IDS_MIN_CYCLE_UNKNOWN );  return; }
    for(int i=0; i<=pD->tsp.MAX_2; i++)  pD->tsp.initGZ[i] = pD->tsp.GZ[i];
    ShowCycle( 1/*initOK*/ );
}

void CGraphView::OnRandCycle0()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    pD->tsp.Form_Cycle0( 1, TRUE );
    ShowCycle( 1/*initOK*/ );
}

void CGraphView::OnTogether()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int save_bad = pD->bad_cnt;
    int save_test= pD->test_cnt;
    int save_graph=pD->graph_cnt;
    pD->bad_cnt = pD->test_cnt = pD->graph_cnt = 0;

    in_comparing = 1;
    switch( pD->m_already )
    {
        case 0: //untested net
                OnCommon();
                if( pD->m_already!=2 )  goto THE_END;

                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();

                pD->ShowRealTime( pD->pol_time+exp_time, &FullTimeStr(), pD->pol_time );
                break;

        case 1: //IIG alg. test was completed. Common is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnCommon();
                if( pD->m_already!=3 )  goto THE_END;
                break;

        case 2: //Common alg. test was completed. IIG is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();
                break;

        case 3: info_me( IDS_ALREADY_COMPARED );
                pD->bad_cnt = save_bad;
                pD->test_cnt= save_test;
                pD->graph_cnt= save_graph;
                in_comparing = 0;
                return;
    }
THE_END:
    in_comparing = 0;

    if( pD->m_already!=3 )
    {
       FullTimeStr().SetWindowText("");
       CycleMinStr().SetWindowText("");
       warn_me( IDS_USER_ABORT );
    }
    else  {
       int sum1 = pD->tsp.cycle_length( pD->tsp.GZmin );
       int sum2 = pD->tsp.cycle_length( pD->tsp.saveGZmin );

       if( sum1==0 && sum2==0 )
         info_me( IDS_BOTH_FIND_ZERO );
       else if( sum1!=0 && sum2==0 )
       {
         pD->bad_cnt++;
         info_me( IDS_POLYN_GRAPH_ERROR );
       }
       else
         info_me( IDS_BOTH_FIND_NOT );
    }
}

void CGraphView::OnContinuous()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int randStarts = atoi(pD->m_randStarts);

    if( randStarts==1 )
    {
      int cnt =  pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );
      if( cnt>1 && MessageBox( time_msg[cnt], "Warning", MB_ICONQUESTION | MB_YESNO)!=IDYES )
        return;
	}

    DWORD the_start=timeGetTime(), total_pol_time=0;

    pD->test_cnt = pD->bad_cnt = pD->graph_cnt = 0;
    pD->m_already = 0;
    pD->cont_time = the_start;

    while( pD->test_cnt<INT_MAX )
    {
#ifdef SUPER_USER2
       OnResetNet2();  //m_alre=0
#else
       OnResetNet();  //m_alre=0
#endif
       if( randStarts==1)   {
         pD->tsp.in_contin = 1;
         OnCommon();
         pD->tsp.in_contin = 0;
         if( pD->m_already!=2 )  break;
         pD->tsp.save_min_cycle( 0/*save*/ );
       }

       pD->tsp.in_contin = 1;   //not default save in continious
       OnGo();
       pD->tsp.in_contin = 0;
       total_pol_time += pD->pol_time;

       if( (pD->m_already!=3 && randStarts==1) ||
           (pD->m_already!=1 && randStarts> 1) )  break;

       if( !result && randStarts>1 )  break;

       int sum1 = pD->tsp.cycle_length( pD->tsp.GZmin );
//???  if( !sum1 )  pD->graph_cnt++;

       if(randStarts!=1)   continue;

       int sum2 = pD->tsp.cycle_length( pD->tsp.saveGZmin );

       if( sum1!=0 && sum2==0 ) {
         pD->bad_cnt++;
         info_me( IDS_POLYN_GRAPH_ERROR );
         break;
       }
    } //main contin cycle (WHILE)

    pD->pol_time = total_pol_time;
    pD->show_final_time( the_start, &FullTimeStr());

    if( pD->test_cnt ) {
      if( !pD->m_already )        pD->m_already=1;
      else if( pD->m_already==2 ) pD->m_already=3;
    }

    if( pD->test_cnt>1 && randStarts==1 ) {
      char s[80];
      sprintf(s,"%d graphs were succesfully tested.",
                pD->test_cnt - pD->bad_cnt );
      if( pD->bad_cnt )
        strcat(s,"\nThere was 1 error (different solution).");
      MessageBox(s, "Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
    }

    if( m_bShowStat && pD->test_cnt)    show_stat( );

    if(pD->test_cnt==0) {
       FullTimeStr().SetWindowText("");
    }
    CycleMinStr().SetWindowText("");
}

/////////////////////////////////////////////////////////////////////////////
// CSplitterFrame2
IMPLEMENT_DYNCREATE(CSplitterFrame2, CMDIChildWnd)

CSplitterFrame2::CSplitterFrame2()  {}
CSplitterFrame2::~CSplitterFrame2() {}

BOOL CSplitterFrame2::OnCreateClient(LPCREATESTRUCT,
	 CCreateContext* pContext)
{
    m_wndSplitter.CreateStatic(this,1,2); //splitter (1 row, 2 col)
    m_wndSplitter.CreateView(0,0, pContext->m_pNewViewClass, CSize( 130, 0), pContext);
    m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CGraphView), CSize(0,0), pContext);
    m_wndSplitter.SetColumnInfo( 0, 232, 50);

    SetActiveView((CView*)m_wndSplitter.GetPane(0,1));

    ((CGraphView*)(m_wndSplitter.GetPane(0,1)))->graph =
       (CView*)m_wndSplitter.GetPane(0,0);

	return TRUE;
}

BEGIN_MESSAGE_MAP(CSplitterFrame2, CMDIChildWnd)
    //{{AFX_MSG_MAP(CSplitterFrame2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////
void msg_cycle( char *txt, int* gz, int MAX_2);

void CGraphView::OnIfElse()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    in_comparing = 1; //!!!
    if(!pD->m_already || pD->m_already==2)  {
      pD->polyn_go( &FullTimeStr(), &CycleMinStr(), 1/*only init*/ );
      OnGo(); //initial start
    }
    in_comparing = 0;

    if( pD->tsp.sumGZ!=0 )  { pD->m_already=0; return; }

    if(!pD->m_already || pD->m_already==2) {
      FullTimeStr().SetWindowText("");
      CycleMinStr().SetWindowText("");
      warn_me(IDS_USER_ABORT);
      return;
    }

    OnMinInitial();
    pD->tsp.save_min_cycle( 0 );  //save

    BOOL tmp = m_bShowStat;
    m_bShowStat = FALSE;

//++++++++++++++++++++++++++++++++++++++++++++++
    pD->tsp.flag000 = 1;
    pD->tsp.sum000 = pD->tsp.sumGZ;
    for(int i=1; i<=pD->tsp.MAX_2; i++)
      pD->tsp.gz000[i] = pD->tsp.GZmin[i];

////OnGo(); ////////////////////////////////////
    pD->test_cnt = pD->bad_cnt=0;
    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    //DoPolin(); //............................
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    pD->polyn_go( &FullTimeStr(), &CycleMinStr(), 1/*only init*/ );
    int res = pD->tsp.TSPMain(1,1);
    if( !res )  {  pD->m_already += 1;  pD->test_cnt++;  }

    pD->pol_time = pD->ShowRealTime( pD->pol_time, &FullTimeStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );
////////////////////////////////////////////////
    pD->tsp.flag000 = 0;
//++++++++++++++++++++++++++
    m_bShowStat = tmp;

    if( res )  {
      CycleMinStr().SetWindowText("");
      warn_me(IDS_USER_ABORT);
      return;
    }

    int else_one=0;
    for(i=1; i<=pD->tsp.MAX_2; i++)
      if( pD->tsp.gz000/*saveGZmin*/[i] != pD->tsp.GZmin[i] )
      {
        else_one = 1;
        break;
      }
    pD->m_already = 1/*0*/;
    if(!else_one)
      info_me( IDS_ONE_GRAPH );
    else  {
      CycleMinStr().SetWindowText( pD->cycle_str(pD->tsp.GZ) );
      msg_cycle("The graph has the second cycle:", pD->tsp.GZ, pD->tsp.MAX_2);
    }
}

void CGraphView::OnShowStat()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    if( pD->m_already==1 || pD->m_already==3 )  show_stat();
}

void CGraphView::CheckCycle()
{
    CMainDoc* pD = GetDocument();

    char s[5000];
	strcpy( s, m_cycle0);
    cycle_flag = pD->CheckInitial(s);

    if( cycle_flag )  return;

    ShowCycle( 1/*initOK*/ );
}

//////////////////////////////////////////////////////////////
#ifdef SUPER_USER2
void CGraphView::OnResetNet2()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    InitRandom2( atoi(m_strAmpl) );
    ShowCycle( 1 );    //->m_already=0;
}

#define G_INDEX int
#define G_VALUE int
// N - ࠧ୮ 
// nMaxDeg - . ⥯ 設
// 㭪 SetBitValue(m,n, true) ᢠ 1 ॡ m-n

void CGraphView::InitRandom2(G_INDEX nMaxDeg)
{
    CMainDoc* pD = GetDocument();

    G_INDEX N=pD->tsp.MAX_2; //m_dim;
    G_VALUE rval;
    G_INDEX *Degrees = new G_INDEX[N];
    memset(Degrees, NULL, N*sizeof(G_INDEX));

    srand( (unsigned)time(NULL) );
    for(G_INDEX m=1; m < N; m++)
    for(G_INDEX n=m+1; n <= N; n++)
    {
      rval = (G_VALUE)(random(2));
      if( rval==0 && Degrees[m-1] < nMaxDeg && Degrees[n-1] < nMaxDeg)
      {
        pD->tsp.net[m][n]=0; //SetBitValue(m,n,false);
        Degrees[m-1]++;
        Degrees[n-1]++;
      }
      else
      {
        pD->tsp.net[m][n]=1; //SetBitValue(m,n,true);
      }
    }

    delete [] Degrees;
}
#endif //super_user2
#endif

