#include "stdafx.h"         // MFC core and standard components
#include "mainfrm.h"
#include "g_lib.h"

COLORREF Colors[16] = {
  0x00000000l, 0x00800000l, 0x00008000l, 0x00808000l,
  0x00f000ffl, 0x00800088l, 0x00800080l, 0x00c0c0c0l,   //7
  0x00808080l, 0x00FF0000l, 0x0000FF00l, 0x00FFFF00l,   //11
  0x000000FFl, 0x00FF00FFl, 0x0000FFFFl, 0x00ffffffl };

char *time_msg[] = {
	"", "",  //<1 sec or <1 min
    "A test may take a few minutes. Continue ?",
    "A test may take a few hours. Continue ?",
    "Are you sure that you are going to wait\nfor a few days ? Continue ?",
    "Are you serious? It may take a few months !\nContinue ?",
	"You are crazy! It may take years !!!\nContinue ?"
};

/////////////////////////////////////////////////////////////////
#ifdef DEBUG
void msg(char *fmt ...)
{
  char S[256];
  va_list a;  va_start(a,fmt);  vsprintf( S,fmt,a);
  int fout=_lopen("result.", OF_WRITE);

  if(fout==HFILE_ERROR)  fout=_lcreat("result.",0);

 _llseek(fout,0L,2);
 _lwrite(fout, S, strlen(S));
 _lclose(fout);
}
#endif

void msgbox(char *fmt ...)
{
  char S[256];
  va_list a;  va_start(a,fmt);  vsprintf( S,fmt,a);
  MessageBox( NULL, S, NULL, MB_OK);
/*
  int fout=_lopen("result.", OF_WRITE);

  if(fout==HFILE_ERROR)  fout=_lcreat("result.",0);

 _llseek(fout,0L,2);
 _lwrite(fout, S, strlen(S));
 _lclose(fout);
*/
}

//////////////////////////////////////////////////////
void warn_me( UINT nID )
{
    CString s;
    s.LoadString( nID );
    ::MessageBox( NULL, s, "Warning", MB_OK | MB_ICONEXCLAMATION | MB_TASKMODAL);
}

void info_me( UINT nID )
{
    CString s;
    s.LoadString( nID );
    ::MessageBox( NULL, s, "Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
}

BOOL one_legend(CDC* dc, int num, int x,int y, COLORREF clr)
{
    char s[80];

	dc->SetBkMode( TRANSPARENT);

	CPen pen;
	if ( !pen.CreatePen( PS_SOLID, 0, Colors[0]) )
		return FALSE;

    CPen* pOldPen  = dc->SelectObject(&pen);

	CBrush brush;
    if ( !brush.CreateSolidBrush( clr ) )
	{
		DeleteObject( dc->SelectObject( pOldPen ));
		return FALSE;
	}
	CBrush* pOldBrush= dc->SelectObject(&brush);

    //calc text extensions
    sprintf( s, "%d", num);
	CSize size = dc->GetTextExtent( s, strlen(s) );
    int cx = size.cx/2+4; 
    int cy = size.cy/2+2; 
    int dlt= 0;
    if(cy>cx)
    {
      dlt = (cy-cx)/2;
      cx = cy;
    }
	dc->Ellipse( x-cx, y-cy, x+cx, y+cy);

	DeleteObject( dc->SelectObject( pOldPen ));
	DeleteObject( dc->SelectObject( pOldBrush));

    dc->TextOut( x-cx+4+dlt, y-(cy-2), s, strlen(s) );

	dc->SetBkMode( OPAQUE );

	return TRUE;
}

/////////////////////////////////////////////////
int get_time_text( char *s, double full_time_sec)
{
    double full_time_min = full_time_sec/60.;           //to minits
	double full_time_hours = full_time_min/60.;			//to hours
	double full_time_days = full_time_hours/24.;		//to days
	double full_time_months = full_time_days/30.;		//to months
	double full_time_years = full_time_sec/31556925.9747;  //to years

    int  mode = 0;

    if( full_time_sec<1. )        sprintf( s, "%.3f sec", full_time_sec );
    else if( full_time_sec<10. )  sprintf( s, "%.2f sec", full_time_sec );
    else if( full_time_min<1.)    sprintf( s, "%.1f sec", full_time_sec );
    else if( full_time_hours<1.)
    {
        sprintf( s, "%.2f min", full_time_min );
        mode = 2;
    }
    else if( full_time_days<1.)
    {
        sprintf( s, "%.2f hours", full_time_hours );
        mode = 3;
    }
	else if( full_time_months<1.)
    {
        sprintf( s, "%.1f days", full_time_days );
        mode = 4;
    }
	else if( full_time_years<1.)
    {
        sprintf( s, "%.1f months", full_time_months );
        mode = 5;
    }
	else
	{ 
		if( full_time_years<1.e+5 ) 
  			sprintf( s, "%.1f years", full_time_years );
		else
  			sprintf( s, "%.4E years", full_time_years );
        mode = 6;
	}
    return mode;
}

//////////////////////////////////////////////////////////////////
int do_alloc(int ***imbuf, int size)
{
  for(int y=0; y<size; y++)
  {
    if ((imbuf[y]=(int **)calloc( size, sizeof(int*)) )==NULL)
    {
      if(y)  free(imbuf[y-1]);
      msgbox("ERROR(1): Not enough memory...");
      return 0;
    }
    for(int x=0; x<size; x++)
      if((imbuf[y][x]=(int *)calloc( size, sizeof(int)))==NULL)
      {
        if(x)
          free(imbuf[y-1][x-1]);
        msgbox("\r\nERROR(2): Not enough memory...");
        return 0;
      }
  }
  return 1;
}

void do_delete(int ***imbuf, int size)
{
  for(int y=0; y<size; y++)
  {
    for(int x=0; x<size; x++)  free(imbuf[y][x]);
    free(imbuf[y]);
  }
  free(imbuf);
}

int do_alloc2(int **matr, int size)
{
  for(int k=0; k<size; k++)
    if((matr[k]=(int*)calloc( size, sizeof(int)) )==NULL)   return 0;
  return 1;
}

void do_delete2(int **matr, int size)
{
  for(int k=0; k<size; k++)
  {
    if(matr[k])  free(matr[k]);
    matr[k]=0;
  }
  if(matr)  free(matr);
}

#ifdef GRAPH_DA
int do_allocG(char ***imbuf, int size)
{
  for(int y=0; y<size; y++)
  {
    if ((imbuf[y]=(char **)calloc( size, sizeof(char*)) )==NULL)
    {
      if(y)  free(imbuf[y-1]);
      msgbox("ERROR(1): Not enough memory...");
      return 0;
    }

    for(int x=0; x<size; x++)
      if((imbuf[y][x]=(char *)calloc( size, sizeof(char)))==NULL)
      {
        if(x) free(imbuf[y-1][x-1]);
        msgbox("\r\nERROR(2): Not enough memory...");
        return 0;
      }
  }
  return 1;
}

void do_deleteG(char ***imbuf, int size)
{
  for(int y=0; y<size; y++)
  {
    for(int x=0; x<size; x++)  free(imbuf[y][x]);
    free(imbuf[y]);
  }
  free(imbuf);
}
#else
int  do_allocG(char ***imbuf, int size)  { return 1; }
void do_deleteG(char ***imbuf, int size) {}
#endif

