#include "stdafx.h"
#include "mainfrm.h"

#include "g_lib.h"

void LoadTextFile(FILE* fout, int MAX_2, int** net, int _who);

UINT IDX;
int  x_ed, y_ed;
int  x_dl, y_dl;

/////////////////////////////////////////////////////////////////////////////
CNumEdit::CNumEdit()
{
    value = v0 = 0;
    read_only = 0;
}

BEGIN_MESSAGE_MAP(CNumEdit, CEdit)
    //{{AFX_MSG_MAP(CNumEdit)
	ON_WM_CHAR()
	ON_WM_KEYDOWN()
	ON_WM_KILLFOCUS()
    ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Aliasing on top of an existing Edit control

BOOL CNumEdit::SubclassEdit(UINT nID, CWnd* pParent, int _step,
               int _v, int _type, int _lim1, int _lim2)
{
    value = v0 = _v;

	idx = nID;
    lim1 = _lim1;
    lim2 = _lim2;
    type = _type;
    step = _step;

	return SubclassDlgItem(nID, pParent);
}

/////////////////////////////////////////////////////////////////////////////
// Input character filter

void CNumEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
    if (IsCharAlphaNumeric((TCHAR)nChar) && !IsCharAlpha((TCHAR)nChar))
		CEdit::OnChar(nChar, nRepCnt, nFlags);  // permitted
    else if( (TCHAR)nChar=='-' ) {
        char txt[81];  GetWindowText(txt,40);
        strcpy(s,txt); value = atoi(s);
        if( value>0 ) {
          value *= -1;
          mk_text();
        }
    }
    else
		// illegal character - inform parent
		OnBadInput();
}

/////////////////////////////////////////////////////////////////////////////
// default bad input handler, beep (unless parent notification
//    returns -1.  Most parent dialogs will return 0 or 1 for command
//    handlers (i.e. Beep is the default)
void CNumEdit::OnBadInput()
{
	if (GetParent()->SendMessage(WM_COMMAND,
		MAKELONG(GetDlgCtrlID(), PEN_ILLEGALCHAR), (LPARAM)m_hWnd) != -1)
	{
		MessageBeep((UINT)-1);
	}
}

/////////////////////////////////////////////////////////////////////////////

void CNumEdit::mk_text()
{
  sprintf( s,"%d", value);
  SetWindowText(s);
}

void CNumEdit::assign(int v)
{
  value = v0 = v;
  mk_text();
}

void go_down(HWND hWnd, int where, int qnt)
{
    HWND prev = ::GetFocus();
	HWND h = ::GetNextDlgTabItem( hWnd, prev, where);

    for(int i=0; i<qnt-1; i++)
    {
      prev=h;
      h = ::GetNextDlgTabItem( hWnd, prev, where);
    }

    if( h )  ::SetFocus(h);
}

void CNumEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    CWnd* w=GetParent();
    int   max2_ed = ((CMtxEditor*)w)->max2;

    switch( nChar )  
	{
      case VK_UP:
            if( type==NO_UP || type==NO_UP_LE || type==NO_UP_RI )
            {
              if( x_ed>1 )  {
                x_ed--;
                ((CMtxEditor*)w)->reload();
              }
              return;
            }

            go_down( GetParent()->m_hWnd, 1, step);
            x_dl--;
            return;

      case VK_DOWN:
            if( type==NO_DOWN || type==NO_DN_LE || type==NO_DN_RI )
            {
              if( x_ed+x_dl<=max2_ed )  {
                x_ed++;
                ((CMtxEditor*)w)->reload();
              }
              return;
            }
            go_down( GetParent()->m_hWnd, 0, step);
            x_dl++;
//msg("x_dl=%d(%d)", x_dl, y_dl);
            return;

      case VK_LEFT:
            if( type==NO_LEFT || type==NO_DN_LE || type==NO_UP_LE )
            {
              if( y_ed>1 )  {
                y_ed--;
                ((CMtxEditor*)w)->reload();
              }
              return;
            }

            go_down( GetParent()->m_hWnd, 1, 1);
            y_dl--;
            return;

      case VK_RIGHT:
            if( type==NO_RIGHT || type==NO_DN_RI || type==NO_UP_RI )
            {
              if( y_ed+y_dl<=max2_ed )  {
                y_ed++;
                ((CMtxEditor*)w)->reload();
              }
              return;
            }

            go_down( GetParent()->m_hWnd, 0, 1);
            y_dl++;
//msg("y_dl=%d(%d)", y_dl, x_dl);
            return;

	  case VK_DELETE:
	        if(read_only) {
     			  MessageBeep((UINT)-1);
		     	  return;
          }
    }
	
	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CNumEdit::OnKillFocus(CWnd* pNewWnd) 
{
    if( flush() )   CEdit::OnKillFocus(pNewWnd);
}

int CNumEdit::flush()
{
  char txt[81];       GetWindowText(txt,40);
  strcpy( s, txt);
  value = atoi(s);

  if( value<lim1 || value>lim2 ) {
    value = v0;
    mk_text();
    sprintf(txt, "Invalid value. The valid range is %d...%d", lim1, lim2);
    ::MessageBox( NULL, txt, "Error", MB_OK | MB_ICONEXCLAMATION | MB_TASKMODAL);
    return 0;
  }

  IDX = 0;
  if( value != v0 )  IDX = idx;
  v0 = value;

  mk_text();

  return 1;
}

//////////////////////////////////////////////////////////////////////
CMtxEditor::CMtxEditor(int** _net, int _max2, int _who, CWnd* pParent) : CDialog(CMtxEditor::IDD, pParent)
{
    //{{AFX_DATA_INIT(CMtxEditor)
    net = _net;
    max2= _max2;
    who = _who;
    x_ed = y_ed = 1;
    x_dl = y_dl = 1;
    //}}AFX_DATA_INIT
}

void CMtxEditor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CMtxEditor)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMtxEditor, CDialog)
    //{{AFX_MSG_MAP(CMtxEditor)
    ON_EN_KILLFOCUS(IDC_1, OnDataChange)
    ON_EN_KILLFOCUS(IDC_2, OnDataChange)
    ON_EN_KILLFOCUS(IDC_3, OnDataChange)
    ON_EN_KILLFOCUS(IDC_4, OnDataChange)
    ON_EN_KILLFOCUS(IDC_5, OnDataChange)
    ON_EN_KILLFOCUS(IDC_6, OnDataChange)
    ON_EN_KILLFOCUS(IDC_7, OnDataChange)
    ON_EN_KILLFOCUS(IDC_8, OnDataChange)
    ON_EN_KILLFOCUS(IDC_9, OnDataChange)
    ON_EN_KILLFOCUS(IDC_10, OnDataChange)
    ON_EN_KILLFOCUS(IDC_11, OnDataChange)
    ON_EN_KILLFOCUS(IDC_12, OnDataChange)
    ON_EN_KILLFOCUS(IDC_13, OnDataChange)
    ON_EN_KILLFOCUS(IDC_14, OnDataChange)
    ON_EN_KILLFOCUS(IDC_15, OnDataChange)
    ON_EN_KILLFOCUS(IDC_16, OnDataChange)
    ON_EN_KILLFOCUS(IDC_17, OnDataChange)
    ON_EN_KILLFOCUS(IDC_18, OnDataChange)
    ON_EN_KILLFOCUS(IDC_19, OnDataChange)
    ON_EN_KILLFOCUS(IDC_20, OnDataChange)
    ON_EN_KILLFOCUS(IDC_21, OnDataChange)
    ON_EN_KILLFOCUS(IDC_22, OnDataChange)
    ON_EN_KILLFOCUS(IDC_23, OnDataChange)
    ON_EN_KILLFOCUS(IDC_24, OnDataChange)
    ON_EN_KILLFOCUS(IDC_25, OnDataChange)
    ON_EN_KILLFOCUS(IDC_26, OnDataChange)
    ON_EN_KILLFOCUS(IDC_27, OnDataChange)
    ON_EN_KILLFOCUS(IDC_28, OnDataChange)
    ON_EN_KILLFOCUS(IDC_29, OnDataChange)
    ON_EN_KILLFOCUS(IDC_30, OnDataChange)
    ON_EN_KILLFOCUS(IDC_31, OnDataChange)
    ON_EN_KILLFOCUS(IDC_32, OnDataChange)
    ON_EN_KILLFOCUS(IDC_33, OnDataChange)
    ON_EN_KILLFOCUS(IDC_34, OnDataChange)
    ON_EN_KILLFOCUS(IDC_35, OnDataChange)
    ON_EN_KILLFOCUS(IDC_36, OnDataChange)
    ON_EN_KILLFOCUS(IDC_37, OnDataChange)
    ON_EN_KILLFOCUS(IDC_38, OnDataChange)
    ON_EN_KILLFOCUS(IDC_39, OnDataChange)
    ON_EN_KILLFOCUS(IDC_40, OnDataChange)
    ON_EN_KILLFOCUS(IDC_41, OnDataChange)
    ON_EN_KILLFOCUS(IDC_42, OnDataChange)
    ON_EN_KILLFOCUS(IDC_43, OnDataChange)
    ON_EN_KILLFOCUS(IDC_44, OnDataChange)
    ON_EN_KILLFOCUS(IDC_45, OnDataChange)
    ON_EN_KILLFOCUS(IDC_46, OnDataChange)
    ON_EN_KILLFOCUS(IDC_47, OnDataChange)
    ON_EN_KILLFOCUS(IDC_48, OnDataChange)
    ON_EN_KILLFOCUS(IDC_49 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_50 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_51 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_52 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_53 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_54 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_55 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_56 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_57 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_58 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_59 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_60 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_61 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_62 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_63 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_64 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_65 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_66 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_67 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_68 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_69 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_70 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_71 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_72 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_73 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_74 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_75 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_76 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_77 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_78 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_79 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_80 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_81 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_82 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_83 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_84 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_85 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_86 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_87 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_88 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_89 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_90 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_91 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_92 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_93 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_94 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_95 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_96 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_97 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_98 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_99 , OnDataChange)
    ON_EN_KILLFOCUS(IDC_100, OnDataChange)
    ON_EN_KILLFOCUS(IDC_101, OnDataChange)
    ON_EN_KILLFOCUS(IDC_102, OnDataChange)
    ON_EN_KILLFOCUS(IDC_103, OnDataChange)
    ON_EN_KILLFOCUS(IDC_104, OnDataChange)
    ON_EN_KILLFOCUS(IDC_105, OnDataChange)
    ON_EN_KILLFOCUS(IDC_106, OnDataChange)
    ON_EN_KILLFOCUS(IDC_107, OnDataChange)
    ON_EN_KILLFOCUS(IDC_108, OnDataChange)
    ON_BN_CLICKED(IDC_LOAD_TXT, OnLoadTxt)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CMtxEditor::OnInitDialog()
{
    CDialog::OnInitDialog(); // let the base class do the default work
    UpdateData(TRUE);        // bring the information from the dialog.

    int j_lim=12, i_lim=9;

	if(j_lim>max2) j_lim=max2;
	if(i_lim>max2) i_lim=max2;

    for(int j=0; j<j_lim; j++)
    for(int i=0; i<i_lim; i++)
    {
      int mode=0;
      if     ( i==0 && j==0) mode=NO_UP_LE;
      else if( i==0 && j==j_lim-1) mode=NO_DN_LE;
      else if( i==0 )        mode=NO_LEFT;
      else if( i==i_lim-1 && j==0) mode=NO_UP_RI;
      else if( i==i_lim-1 && j==j_lim-1) mode=NO_DN_RI;
      else if( i==i_lim-1 )        mode=NO_RIGHT;
      else if( j==0 )        mode=NO_UP;
      else if( j==j_lim-1 )        mode=NO_DOWN;

      int lim1=0, lim2=1;
      if(who!=GRAPH_TEMP)  { lim1=-MAX_AMPL;  lim2=MAX_AMPL; }

      e[i][j].SubclassEdit(IDC_1+i+j*9, this, 9, net[x_ed+j][y_ed+i], mode, lim1, lim2);
      e[i][j].mk_text();
    }

	CWnd* w = GetDlgItem( IDC_1 );
	w->SetFocus();

    SetLabels();

    return FALSE;  // there is no change in any control focus stuff here.
}

void CMtxEditor::OnDataChange()
{
    if (!UpdateData() || !IDX)  return;

    net[x_ed+x_dl-1][y_ed+y_dl-1] = e[y_dl-1][x_dl-1].value;
}

void CMtxEditor::SetLabels()
{
    char s[20];

    for(int i=0; i<9; i++)  {
      CWnd* w = GetDlgItem(IDC_r1+i);
      sprintf(s,"%d", y_ed+i);
      w->SetWindowText(s);
      if(i+1==max2) break;
    }

    for(i=0; i<12; i++)  {
      CWnd* w = GetDlgItem(IDC_l1+i);
      sprintf(s,"%d", x_ed+i);
      w->SetWindowText(s);
      if(i+1==max2) break;
    }
}

void CMtxEditor::reload()
{
    for(int j=0; j<12; j++)
    for(int i=0; i<9; i++)
    {
      if(i+1==max2 || j+1==max2) break;
      e[i][j].assign(net[x_ed+j][y_ed+i]);
    }

    SetLabels();
}

void CMtxEditor::OnLoadTxt()
{
    CFileDialog *dlg = new CFileDialog( TRUE, "txt", "*.txt");

    if( dlg->DoModal()==IDOK )
    {
        FILE* fout = fopen( dlg->GetPathName(), "rt");
        LoadTextFile( fout, max2, net, who);
        fclose(fout);

        x_ed = y_ed = 1;
        x_dl = y_dl = 1;
        reload();

        CWnd* w = GetDlgItem( IDC_1 );
        w->SetFocus();
    }
}

//////////////////////////////////////////////////////////////
void CNumEdit::OnLButtonDown( UINT nFlags, CPoint p)
{
//  CNumEdit* w=(CNumEdit*)GetFocus();
//  y_dl = (idx+1-IDC_1)%9;
    y_dl = (idx-IDC_1)%9+1;
//  x_dl = (idx+1-IDC_1)/9 + 1;
    x_dl = (idx-IDC_1)/9 + 1;
msg/*box*/("\r\nx,y=%d,%d", x_dl, y_dl);
    CEdit::OnLButtonDown( nFlags, p);
}

//void CMtxEditor::OnMouse()
//{
//    CNumEdit* w=(CNumEdit*)GetFocus();
//msgbox("%d", w->idx);
//  CDialog::OnLButtonDown( nFlags, p);
//}

