#include "stdafx.h"
#include "mainfrm.h"
#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern char* copyr;

/////////////////////////////////////////////////////////////////////////////
// CMtxDlg dialog

CMtxDlg::CMtxDlg(TSP_random* _tsp, CWnd* pParent /*=NULL*/)
	: CDialog(CMtxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMtxDlg)
    tsp = _tsp;
	//}}AFX_DATA_INIT
}

void CMtxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMtxDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMtxDlg, CDialog)
	//{{AFX_MSG_MAP(CMtxDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMtxDlg message handlers

BOOL CMtxDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    TCHAR buf[512], s[10];
    int i,j,x,y,l;

	sprintf(buf,"%-31s", "   Capital (State)");

    for(i=1; i<MAX_USA; i++)
        if( tsp->active_state[i] )
		{
        	sprintf( s," %4d", tsp->active_state[i]);
			strcat(	buf, s);
		}
    TextStr().ReplaceSel( buf);

    for(i=1,x=1; x<=tsp->MAX_2,i<MAX_USA; i++)
	{
        if( !tsp->active_state[i] )  continue;

        sprintf( buf,"\r\n%2d:%s (%s) ", tsp->active_state[i],
                                     arr_states[i].capital,
                                     arr_states[i].usa_state);
        l = strlen(buf)-1;

        for(j=l; j<32; j++)
			strcat(buf, " ");

        for(j=1,y=1; y<=tsp->MAX_2,j<MAX_USA; j++)
        {
            if( !tsp->active_state[j] ) continue;

            sprintf(s," %4d", tsp->net[ min(x,y) ][ max(x,y) ]);
            strcat( buf, s);
            y++;
        }
        TextStr().ReplaceSel( buf);
        x++;
	}
    return TRUE;
}

//////////////////////////////////////////////////////////////////
#ifdef TSMP_DA

CTest2Dlg:: CTest2Dlg(TSP_random* _tsp, CWnd* pParent)
          : CDialog(CTest2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest2Dlg)
	m_text = _T("");
    tsp = _tsp;
    nodes = tsp->MAX_2; //_nodes;
    //}}AFX_DATA_INIT
}

void CTest2Dlg::DoDataExchange(CDataExchange* pDX)  {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CTest2Dlg)
    //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTest2Dlg, CDialog)
	//{{AFX_MSG_MAP(CTest2Dlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest2Dlg message handlers

BOOL CTest2Dlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
    TextStr().ReplaceSel( "No    Edges    Values\r\n" );

    if( tsp->maxCycle )
      ListTitle().SetWindowText("maximum cycle and may be decreased without affecting it");

    int i,j, cnt=0;
    for(i=1; i<nodes; i++)
      for(j=i+1; j<=nodes; j++)
      {
        char buf[80];
        if( tsp->netMAIN[i][j]<=0 ) continue;
        sprintf( buf,"%2d:   C(%2d,%2d)     %d\r\n", ++cnt, i,j, tsp->netMAIN[i][j]);
        TextStr().ReplaceSel( buf );
      }
    return TRUE;
}
#endif

#ifdef SUPER_USER
//////////////////////////////////////////////////////////////////////
CSuper::CSuper(CWnd* pParent/*=NULL*/) : CDialog(CSuper::IDD, pParent)
{
    //{{AFX_DATA_INIT(CSuper)
    m_tir = "";
    m_per = "";
    m_fst = "";
    m_scd = "";
	//}}AFX_DATA_INIT
}

void CSuper::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CSuper)
    DDX_Text(pDX, IDC_NUMTIR, m_tir);
    DDX_Text(pDX, IDC_NUMPER, m_per);
    DDX_Text(pDX, IDC_NUMFST, m_fst);
    DDX_Text(pDX, IDC_NUMSCD, m_scd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSuper, CDialog)
    //{{AFX_MSG_MAP(CSuper)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#endif

