// progress.h : header file
//
#include <afxcmn.h>

class CMainDoc;
class TSP_random;

/////////////////////////////////////////////////////////////////////////////
// CMtxDlg dialog
class CMtxDlg : public CDialog
{
// Construction
public:
    CMtxDlg(TSP_random*, CWnd* pParent = NULL);   // standard constructor

public:
    CEdit& TextStr()  { return *(CEdit*)GetDlgItem(IDC_MTX_TEXT); }

// Dialog Data
	//{{AFX_DATA(CMtxDlg)
	enum { IDD = IDD_MTX_TEXT };
    TSP_random*   tsp;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMtxDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMtxDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CTest2Dlg dialog

class CTest2Dlg : public CDialog
{
// Construction
public:
    CTest2Dlg( TSP_random* _tsp, CWnd* pParent=NULL);

    CEdit& TextStr()   { return *(CEdit*)GetDlgItem(IDC_TEST2_TXT); }
    CEdit& ListTitle() { return *(CEdit*)GetDlgItem(IDC_NODES); }

// Dialog Data
	//{{AFX_DATA(CTest2Dlg)
	enum { IDD = IDD_PRIBAVKI };
	CString	m_text;
    int nodes;
    TSP_random* tsp;
    //}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTest2Dlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTest2Dlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////
#define  NO_UP    1
#define  NO_DOWN  2
#define  NO_LEFT  3
#define  NO_RIGHT 4
#define  NO_UP_LE 5
#define  NO_UP_RI 6
#define  NO_DN_LE 7
#define  NO_DN_RI 8

class CNumEdit : public CEdit
{
public:
    int  value, v0;
    int  lim1, lim2;
    char s[40];
    int  read_only;
    UINT idx;

    int  type;
    int  step;

    void assign(int v);
    void operator = (int v) { assign(v); }
    operator int() { return value; }

    int  flush();
    void mk_text();

public:
    CNumEdit();

    // subclassed construction
    BOOL SubclassEdit(UINT nID, CWnd* pParent, int step,
            int _v, int type, int _lim1, int _lim2);

// Overridables
	virtual void OnBadInput();

// Implementation
protected:
    //{{AFX_MSG(CNumEdit)
	afx_msg void OnChar(UINT, UINT, UINT); // for character validation
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
    afx_msg void OnKillFocus(CWnd* pNewWnd);
    afx_msg void OnLButtonDown( UINT nFlags, CPoint p);
    //}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

///////////////////////////////////////////////////////////
// above the range for normal EN_ messages
#define PEN_ILLEGALCHAR     0x8000
        // sent to parent when illegal character hit
        // return 0 if you want parsed edit to beep

///////////////////////////////////////////////////////////

class CMtxEditor : public CDialog
{
// Construction
public:
    CMtxEditor(int** _net, int _max2, int _who, CWnd* pParent=NULL);

// Dialog Data
    //{{AFX_DATA(CMtxEditor)
    enum { IDD = IDD_EDIT_NEW };
    CNumEdit e[9][12];

    int** net;
    int   max2;
    int   who;
    //}}AFX_DATA

    void reload();
    void SetLabels();


// Overrides
	// ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CMtxEditor)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog(void);
	//}}AFX_VIRTUAL

// Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CMtxEditor)
	afx_msg void OnDataChange();
	afx_msg void OnLoadTxt();
//    afx_msg void OnMouse();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

