#include "stdafx.h"
#include <mmsystem.h>
#include <io.h>
#include <math.h>

#include "mainfrm.h"
#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define DRAW_LIMIT  30

char* copyr="TSMP-1, ver.1.0, (c) 1998  I.I.G., Inc.";

char *IDS_NODES_INVALID="A number of the nodes is invalid.\nThe valid range: 4...%d";
char *IDS_AMPL_INVALID ="New amplitude value is invalid\nThe valid range: 0...%d";

#define M_PI  3.141592653589793
const double M_2PI = 2*M_PI;

static int r_height=0, r_width=0, DLTX_RND=0, DLTY_RND=0;
extern int resol, rx0,ry0;
extern BOOL only1set;

int was_error;

void msg_cycle( char *txt, int* gz, int MAX_2)
{
  char s[5000], s2[20];
  unsigned str_num=1, len0=strlen(txt);
  strcpy(s,txt);  strcat(s,"\n1");
  for(int i=2; i<=MAX_2; i++)  {
    sprintf(s2,"-%d", gz[i]);
    strcat( s, s2);
    if( strlen(s)-len0 > str_num*60 ) { strcat(s,"\n"); str_num++; }
  }
  ::MessageBox(NULL, s, "Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
}


/////////////////////////////////////////////////////////////////////////////
// CNetView
IMPLEMENT_DYNCREATE(CNetView, CView)

BEGIN_MESSAGE_MAP(CNetView, CView)
    //{{AFX_MSG_MAP(CNetView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNetView construction/destruction

CNetView::CNetView() {}

void CNetView::OnInitialUpdate()
{
//  CMainDoc* pD = GetDocument();

    memset(&logfont, 0, sizeof(logfont));
    logfont.lfHeight = 14;

    CString szFont;
    szFont.LoadString(IDS_FONT_NAME);       // TrueType font
    lstrcpy(logfont.lfFaceName, szFont);
    VERIFY( fnt.CreateFontIndirect(&logfont) );

    CView::OnInitialUpdate();
}


CNetView::~CNetView()
{
    DeleteObject(&fnt);
}

void CNetView::OnDraw(CDC* pDC)
{
    CMainDoc* pD = GetDocument();  //ASSERT_VALID(pD);

    int i;
    double j, StepA = M_2PI/pD->tsp.MAX_2;
    for(i=0,j=0.; i<pD->tsp.MAX_2; i++,j+=StepA)
    {
       Pnts[i].X=cos(j);
       Pnts[i].Y=sin(j);
    }
    DrawPoints( pDC );
}


void CNetView::get_xy(int i, int* x, int* y)  {
    *x = (int)(Rad+floor(Pnts[i].X*Rad2));
    *y = (int)(Rad+floor(Pnts[i].Y*Rad2));
}
////////////////////////////////////////
/*
    CPen* pOldPen  = dc->SelectObject(&penL);
    CBrush* pOldBrush= dc->SelectObject(&brushL);
//.................
    sprintf( s, "%d", num);
	CSize size = dc->GetTextExtent( s, strlen(s) );
    int cx = size.cx/2+4; 
    int cy = size.cy/2+2; 
    int dlt= 0;
    if(cy>cx)  {  dlt = (cy-cx)/2;  cx = cy; }
	dc->Ellipse( x-cx, y-cy, x+cx, y+cy);
    dc->TextOut( x-cx+4+dlt, y-(cy-2), s, strlen(s) );
//................
	DeleteObject( dc->SelectObject( pOldPen ));
	DeleteObject( dc->SelectObject( pOldBrush));
	dc->SetBkMode( OPAQUE );
*/
////////////////////////////////////////
BOOL CNetView::DrawPoints(CDC *dc)
{
    int  i,j,k, cX,cY, x,y;
    char s[20];

    CMainDoc* pD = GetDocument();
    int MAX_2 = pD->tsp.MAX_2;

    CRect rect;
    GetClientRect(rect);

    cX=rect.right/2;
    cY=rect.bottom/2;

    Rad = min(cY, cX);
    Rad2= Rad-20;

/////////////////////
    VERIFY( MemDC.CreateCompatibleDC( dc ) );
    CBitmap bitmap;  bitmap.CreateCompatibleBitmap(dc, Rad*2, Rad*2);
    CBitmap* oldBM = MemDC.SelectObject(&bitmap);

    MemDC.BitBlt( 0, 0, Rad*2, Rad*2, 0, 0, 0, WHITENESS);
/////////////////////
    oldfnt2  = dc->SelectObject( &fnt );
    pOldFont = MemDC.SelectObject( &fnt );
//-------------------
//  dc->SetBkMode( TRANSPARENT);
    MemDC.SetBkMode( TRANSPARENT);
    CPen penL;  penL.CreatePen( PS_SOLID, 0, Colors[0]);
    CBrush brushL;  brushL.CreateSolidBrush( Colors[14]);
    CPen* pOldPen;
    CBrush* pOldBrush;
//-------------------
    for(i=0; i<MAX_2; i++)
    {
      get_xy(i, &x, &y);

      for(j=i+1; j<MAX_2; j++)
      {
        COLORREF color = Colors[0];
        int      width = 0;
        CPen pen;

        if( pD->m_who==GRAPH_TEMP && pD->tsp.net[i+1][j+1]>0
            && !pD->tsp.isGZ(i+1,j+1) //???
        )
          continue;

        if( MAX_2>DRAW_LIMIT && !pD->tsp.isGZ(i+1,j+1) )  continue;

        if( pD->tsp.isGZ(i+1,j+1) )
        {
            color = Colors[12];
            ////width = 2;
        }

        pen.CreatePen(PS_SOLID, width, color);
        pOldPen = MemDC.SelectObject(&pen);

        MemDC.MoveTo( x, y);
        int x1,y1;
        get_xy( j, &x1, &y1);
        MemDC.LineTo( x1, y1);

        DeleteObject( MemDC.SelectObject( pOldPen ));
      }
      pOldPen  = MemDC.SelectObject(&penL);
      pOldBrush= MemDC.SelectObject(&brushL);
//    one_legend( &MemDC, i+1, x, y, Colors[14]);
      sprintf( s, "%d", i+1);
      CSize size = MemDC.GetTextExtent( s, strlen(s) );
      int cxx = size.cx/2+4;
      int cyy = size.cy/2+2;
      int dlt= 0;
      if(cyy>cxx)  {  dlt=(cyy-cxx)/2;  cxx=cyy; }
      MemDC.Ellipse( x-cxx, y-cyy, x+cxx, y+cyy);
      MemDC.TextOut( x-cxx+4+dlt, y-(cyy-2), s, strlen(s) );
      MemDC.SelectObject( pOldPen );
      MemDC.SelectObject( pOldBrush);
    }
    DeleteObject( &penL );
    DeleteObject( &brushL );
    MemDC.SetBkMode( OPAQUE );
//  dc->SetBkMode( OPAQUE );

    if( pD->m_ShowWeights && MAX_2<=DRAW_LIMIT )
    {
      int idx = pD->tsp.GZ[MAX_2];
      int x0,y0;
      get_xy( idx-1, &x0, &y0);

      for(i=0; i<MAX_2; i++)
      {
        idx = pD->tsp.GZ[i+1];
        get_xy( idx-1, &x, &y);
        pD->tsp.get_jk( i, &j,&k);
        int net_val = pD->tsp.net[j][k];
        if( pD->tsp.maxCycle && pD->tsp.working)  net_val *= -1;
        one_legend( &MemDC, net_val, (x0+x)/2, (y0+y)/2, Colors[15]);
        x0 = x;
        y0 = y;
      }
    }

    dc->BitBlt( cX-Rad, cY-Rad, Rad*2, Rad*2, &MemDC, 0, 0, SRCCOPY);

    dc->TextOut( rect.left+6, rect.bottom-16, copyr, strlen(copyr) );

//  DeleteObject( dc->SelectObject( oldfnt2 ) );
//  DeleteObject( MemDC.SelectObject( pOldFont ) );
    DeleteObject( MemDC.SelectObject( oldBM) );
    MemDC.DeleteDC();

    return TRUE;
}

/////////////////////////////////////////////////////////////////////
// CNetView diagnostics

#ifdef _DEBUG
void CNetView::AssertValid() const  { CView::AssertValid(); }
void CNetView::Dump(CDumpContext& dc) const { CView::Dump(dc); }
CMainDoc* CNetView::GetDocument() // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
    return (CMainDoc*)m_pDocument;
}
#endif //_DEBUG

#ifdef TSMP_DA ///////////////////////////////////////////////////////
//+++++++++++++++++++++++++++++++++++++++++++
IMPLEMENT_DYNCREATE(CInputView, CFormView)

CInputView::CInputView() : CFormView(CInputView::IDD)
{
	//{{AFX_DATA_INIT(CInputView)
	m_ShowWeights = TRUE;
	m_strData = "";
    m_strAmpl = "100";
    m_randStarts = _T("");
    m_randStarts2= _T("");
    m_maxCycle = FALSE;
    in_comparing = 0;
    cycle_flag = 0;
    hArrowCur = LoadCursor(0, IDC_ARROW);
    hWaitCur  = LoadCursor(0, IDC_WAIT);
    //}}AFX_DATA_INIT
}

CInputView::~CInputView()  {}

void CInputView::OnInitialUpdate()
{
    CMainDoc* pD = GetDocument();

    pD->tsp.tsp_who = RAND_TEMP;
    pD->tsp.parent = this;
    pD->misc_init( RAND_TEMP, 8 );
//..........
    if( pD->m_ReadOK==TRUE )  m_strAmpl = pD->m_strAmpl;
    else                      pD->m_strAmpl = m_strAmpl;
////////
    pD->tsp.ampl = atoi(m_strAmpl);  //in maindoc ampl=100

    if( pD->m_ReadOK==FALSE )  OnResetNet();

    int alr = pD->m_already;
    if( pD->m_ReadOK==TRUE )
    {
//??? Cycle0Str().SetWindowText( pD->cycle_str( pD->tsp.initGZ ) );
      m_cycle0 = pD->cycle_str(pD->tsp.initGZ);
      m_cycle_save = m_cycle0;
      if( alr )  {
        pD->ShowTime2( &FullTimeStr() );
        ShowCycle( 0 );
      }
    }
    else
      ShowCycle( 1 );

    pD->m_already = alr;
//!!if( pD->m_already )  ShowCycle( 0 );

    OnUpdate(this,0,NULL);
//////////////////
	CSplitterWnd *w = (CSplitterWnd*)GetParentFrame();

    if(resol!=1)  {
      if( !r_width )  {
        RECT r;  w->GetWindowRect(&r);
        if( !rx0 )  { rx0 = r.left; ry0 = r.top; }
        else {
          DLTX_RND = r.left-rx0;
          DLTY_RND = r.top-ry0;
        }
        Cycle0Str().GetWindowRect(&r);
        r_width = r.right+30-DLTX_RND;
        r_height= r.bottom-16-DLTY_RND;
      }
      w->SetWindowPos( NULL, 0,0, r_width, r_height, SWP_DRAWFRAME|SWP_NOMOVE);
    }
    else  w->ShowWindow(SW_SHOWMAXIMIZED);

    CFormView::OnInitialUpdate();
}

void CInputView::OnUpdate(CView*, LPARAM, CObject*)
{
    CMainDoc* pD = GetDocument();

    m_strData = pD->m_strData;
    m_strAmpl = pD->m_strAmpl;
    m_randStarts = pD->m_randStarts;
    m_randStarts2 = pD->m_randStarts2;
    m_ShowWeights = pD->m_ShowWeights;
    m_maxCycle = pD->tsp.maxCycle;

    UpdateData(FALSE);  // set the data into the controls
}

void CInputView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputView)
	DDX_Check(pDX, IDC_SHOW_WEIGHTS, m_ShowWeights);
    DDX_Text(pDX, IDC_NODES, m_strData);
	DDX_Text(pDX, IDC_AMPL, m_strAmpl);
	DDV_MaxChars(pDX, m_strAmpl, 5);
    DDX_Text(pDX, IDC_RAND_STARTS, m_randStarts);
    DDX_Text(pDX, IDC_RAND_STARTS2, m_randStarts2);
    DDX_Check(pDX, IDC_MAXI_CYCLE, m_maxCycle);
    DDX_Text(pDX, IDC_INITIAL_CYCLE, m_cycle0);
    DDV_MaxChars(pDX, m_cycle0, 5000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CInputView, CFormView)
	//{{AFX_MSG_MAP(CInputView)
    ON_EN_KILLFOCUS(IDC_NODES, OnDataChange)
	ON_BN_CLICKED(IDC_NET_EDITOR, OnNetEditor)
    ON_BN_CLICKED(IDC_IMPORT, OnImport)
	ON_BN_CLICKED(IDC_CM_TIME, OnGetFullTime)
	ON_BN_CLICKED(IDC_byIIG, OnGo)
	ON_BN_CLICKED(IDC_byCOMMON, OnCommon)
    ON_BN_CLICKED(IDC_MIN_INIT, OnMinInitial)
    ON_BN_CLICKED(IDC_RESET_NET, OnResetNet)
	ON_BN_CLICKED(IDC_TOGETHER, OnTogether)
	ON_BN_CLICKED(IDC_RAND_CYCLE0, OnRandCycle0)
	ON_BN_CLICKED(IDC_CONTINUOUS, OnContinuous)
	ON_BN_CLICKED(IDC_IF_ELSE, OnIfElse)
	ON_BN_CLICKED(IDC_TEST2, OnTest2)
    ON_BN_CLICKED(IDC_SHOW_WEIGHTS, OnDataChange)
	ON_EN_KILLFOCUS(IDC_AMPL, OnDataChange)
	ON_BN_CLICKED(IDC_MAXI_CYCLE, OnDataChange)
    ON_EN_KILLFOCUS(IDC_RAND_STARTS, OnDataChange)   //???
    ON_EN_KILLFOCUS(IDC_RAND_STARTS2, OnDataChange)
    ON_EN_KILLFOCUS(IDC_INITIAL_CYCLE, OnDataChange)
	ON_BN_CLICKED(IDC_SHOW_STAT, OnShowStat)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////
void CInputView::OnResetNet()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    pD->ResetNet();
    ShowCycle( 1 );    //->m_already=0;
}

void CInputView::OnDataChange()
{
    if (!UpdateData())  return;

    CMainDoc* pD = GetDocument();

///////////////////
    if( pD->tsp.working ) {
      m_strData = pD->m_strData;
      m_strAmpl = pD->m_strAmpl;
      m_randStarts2 = pD->m_randStarts2;
      m_randStarts  = pD->m_randStarts;
      m_ShowWeights = pD->m_ShowWeights;
      m_maxCycle = pD->tsp.maxCycle;
      UpdateData(FALSE);
      return;
    }
///////////////////

	BOOL bUpdate = FALSE;

    if (m_strData != pD->m_strData)
	{
        //check new MAX_2
        int newMAX_2 = atoi(m_strData);
        if( newMAX_2<4 || newMAX_2>=MAX2_LIMIT )
        {
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			char s[80];
            sprintf( s, IDS_NODES_INVALID, MAX2_LIMIT-1);
            MessageBox( s, "Error", MB_ICONEXCLAMATION | MB_OK);
            return;
        }

        if( !pD->tsp.ReAllocate( newMAX_2 ) )
		{
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			warn_me( IDS_USA_NO_MEMORY );

			pD->tsp.ReAllocate( atoi(m_strData) );
		}

        pD->m_strData = m_strData;
        OnResetNet();
        FullTimeStr().SetWindowText( "" ); //???
pD->m_already=0;
        bUpdate = TRUE;
    }

    if (m_strAmpl != pD->m_strAmpl)
	{
        int newAmpl = atoi(m_strAmpl);
        if( newAmpl<0/*1*/ || newAmpl>MAX_AMPL )
        {
            m_strAmpl = pD->m_strAmpl;
            UpdateData(FALSE);
			char s[80];
            sprintf( s, IDS_AMPL_INVALID, MAX_AMPL);
            MessageBox( s, "Error", MB_ICONEXCLAMATION | MB_OK);
//          warn_me( IDS_AMPL_INVALID );
            return;
        }
        pD->m_strAmpl = m_strAmpl;
        pD->tsp.ampl = newAmpl;
        OnResetNet();
pD->m_already=0;

        bUpdate = TRUE;
	}

    if (m_randStarts != pD->m_randStarts)
	{
        int tmp = atoi(m_randStarts);
        if( tmp<1 || tmp>SHRT_MAX )
        {
            m_randStarts = pD->m_randStarts;
            UpdateData(FALSE);
            return;
        }
        pD->m_randStarts = m_randStarts;
        m_randStarts2 = m_randStarts;
pD->m_already=0;
        UpdateData(FALSE);
	}

    if (m_randStarts2 != pD->m_randStarts2)
	{
        int tmp2= atoi(m_randStarts2);
        if( tmp2<0/*1*/ || tmp2>atoi(m_randStarts) )  {
            m_randStarts2 = pD->m_randStarts2;
            UpdateData(FALSE);
            return;
        }
        pD->m_randStarts2 = m_randStarts2;
pD->m_already=0;
	}

    if (m_ShowWeights != pD->m_ShowWeights)
	{
        pD->m_ShowWeights = m_ShowWeights;
		bUpdate = TRUE;
	}

    if( pD->tsp.maxCycle != m_maxCycle )
    {
        pD->m_already = 0;
        pD->tsp.maxCycle = m_maxCycle;
        bUpdate = TRUE;
pD->m_already=0;
    }

    if( m_cycle0 != m_cycle_save )
    {
       cycle_flag = 0;
       CheckCycle();
       if( cycle_flag )  {
         m_cycle0 = m_cycle_save;
         UpdateData(FALSE);
         cycle_flag = 0;
       }
       else   {
         pD->m_already = 0;
         m_cycle_save = m_cycle0;
       }
    }

    if (bUpdate) {
        //if doc stored data then we would call SetModifiedFlag here
//      pD->SetModifiedFlag();
        pD->UpdateAllViews(this);
    }
}

void CInputView::OnGetFullTime()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

#ifndef SUPER_USER
    pD->m_already = 0;

    pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );

    if( pD->tsp.MAX_2>=172 )  {
      char s[80], s2[80];
      FullTimeStr().GetWindowText( s, 79 );
      sprintf(s2,"> %s", s);
      FullTimeStr().SetWindowText( s2 );
    }
#else
    CSuper dlg;
    char str[80];
    sprintf(str, "%d", tirNUM);  dlg.m_tir = str;
    sprintf(str, "%d", perNUM);  dlg.m_per = str;
    sprintf(str, "%.3f",fstNUM); dlg.m_fst = str;
    sprintf(str, "%.3f",scdNUM); dlg.m_scd = str;

    if( dlg.DoModal() != IDOK )  return;

    tirNUM = atoi(dlg.m_tir);
    perNUM = atoi(dlg.m_per);
    fstNUM = atof(dlg.m_fst);
    scdNUM = atof(dlg.m_scd);
#endif
}

void CInputView::show_stat()
{
    CMainDoc* pD = GetDocument();
    pD->show_stat();
}

void CInputView::OnNetEditor() 
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
//  if( pD->ShowEditor() )  ShowCycle( 1 ); //->m_already=0;
////////////////
    for(int i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.netDC[i][j] = pD->tsp.net[i][j];

    CMtxEditor dlg(pD->tsp.netDC, pD->tsp.MAX_2, RAND_TEMP);
    if( dlg.DoModal() != IDOK )  return;

    for(i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.net[i][j] = pD->tsp.netDC[i][j];

	ShowCycle( 1 ); //->m_already=0;
////////////////
}

////////////////////////////////////////////////////////////////////
void CInputView::DoPolin()
{
    cycle_flag = 0;
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    CMainDoc* pD = GetDocument();
    pD->polyn_go( &FullTimeStr(), &CycleMinStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    ShowCycle( 0 );
}

void CInputView::OnGo() 
{
#ifdef DEBUG
    int fout=_lcreat("result.",0); _lclose(fout);
#endif

    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int randStarts = atoi(pD->m_randStarts);
    int randStarts2 = atoi(pD->m_randStarts2);
    if( !randStarts2 )  pD->tsp.D12orAX4 = D1_2;
    else                pD->tsp.D12orAX4 = AX4;

    if( !randStarts2)  randStarts2=1;

    int i,k, saveGZlast[MAX_1];

    DWORD save_polyn_time = 0;
    pD->all_time = timeGetTime();

    if( !pD->tsp.in_contin )
      pD->test_cnt = pD->bad_cnt = pD->bad_cnt2 = 0;

    pD->tsp.SUM000 = INT_MIN;

    was_error=0;

    if(randStarts==1 || in_comparing)  {
      pD->tsp.Form_Cycle0( 0 );  //return initial cycle
pD->tsp.elseFST=INT_MIN;
      DoPolin();
    }
    else
    {
      pD->m_already = 0;
      result = 1;

      DWORD the_start = timeGetTime();

      int povtor;

      int prev_sum, min_sum;

      pD->tsp.elseFST=INT_MIN;

      for(i=1; i<=randStarts; i++)
      {
        povtor = 0;
        pD->tsp.Form_Cycle0( 1, TRUE );

        if(i>1)
          pD->tsp.elseFST=min_sum;

        if( i>=randStarts2+1)
          pD->tsp.SUM000 = min_sum; //pD->tsp.sumGZ;

        ShowCycle( 1/*initOK*/ );
//????
        if( povtor ) povtor=1;

        if(was_error && pD->tsp.D12orAX4==D1_2)
          pD->tsp.SUM000 = INT_MIN;

        DoPolin();
        pD->tsp.SUM000 = INT_MIN;
//=============
        save_polyn_time += pD->pol_time;

        if( pD->m_already!=1 )  break;

        if(i==1 && !povtor)  {
          pD->tsp.save_min_cycle( 0/*save*/ );
          for(k=1; k<=pD->tsp.MAX_2; k++)  {
            pD->tsp.saveGZinit[k] = pD->tsp.initGZ[k];
            saveGZlast[k] = pD->tsp.GZmin[k];
          }
          prev_sum = min_sum = pD->tsp.sumGZ;
        }
        else if( !pD->tsp.save_min_cycle( 1/*compare*/ ) )
		{
          int sum2 = pD->tsp.cycle_length( pD->tsp.GZmin );
          int sum1 = pD->tsp.cycle_length( pD->tsp.saveGZmin );
          if(povtor) {k=1;}

          if( (pD->tsp.maxCycle && sum2>sum1) ||
             (!pD->tsp.maxCycle && sum2<sum1) )
          {
            min_sum = sum2;
            for(k=1; k<=pD->tsp.MAX_2; k++)  {
              pD->tsp.initGZ[k] = pD->tsp.saveGZinit[k];
              pD->tsp.GZmin[k] = saveGZlast[k];
            }
          }

//        if(pD->tsp.SUM000 != pD->tsp.sumGZ ) {
          if(prev_sum != pD->tsp.sumGZ ) {
            pD->bad_cnt++;
            was_error=1;
          }

          if(only1set || pD->tsp.D12orAX4==AX4) {
            result=0;
            break;
          }
        }

        prev_sum = pD->tsp.sumGZ;

        min_sum = pD->tsp.sumGZ;

      }

      pD->pol_time = save_polyn_time;
      pD->ShowRealTime( /*the_start*/pD->all_time, &FullTimeStr() );
    }

    if( pD->bad_cnt && result==0 )
    {
      if( pD->tsp.D12orAX4==AX4 )  warn_me( IDS_MISMATCH_ERR );
      else                         warn_me( IDS_MISMATCH_ATT );
    }

    if( pD->m_already!=1 && pD->m_already!=3 && !in_comparing && !pD->tsp.in_contin )
    {
      CycleMinStr().SetWindowText( pD->cycle_str( pD->tsp.GZ ) );
      warn_me(IDS_USER_ABORT);
    }
    if( !pD->tsp.in_contin && !in_comparing
     && m_bShowStat && pD->test_cnt )  show_stat( );
}


void CInputView::OnCommon() 
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int res = pD->init_exp( &FullTimeStr(), &CycleMinStr(), in_comparing );
    if( !res )  return;
    exp_time = timeGetTime();
//  HCURSOR curSav = SetCursor( LoadCursor( 0, IDC_WAIT) );
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    get_time_text( pD->tsp.exp_time, pD->get_time_in_sec()); //!!!

    int ret_val;
    pD->tsp.lookALL( 0, &ret_val );

    if( !ret_val )  pD->m_already += 2;

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    if( !pD->tsp.in_contin /*&& pD->m_already*/)
    {
      pD->test_cnt=1;
      exp_time = pD->ShowRealTime( exp_time, &FullTimeStr() );
      ShowCycle( 0 );
    }

    if( pD->m_already<2 && !in_comparing)  {
      warn_me(IDS_USER_ABORT); //???
    }
}

void CInputView::ShowCycle(int initOK)
{
  CMainDoc* pD = GetDocument();

  if( initOK )
  {
    m_cycle0 = pD->cycle_str(pD->tsp.GZ);
    m_cycle_save = m_cycle0;
//  Cycle0Str().SetWindowText( pD->cycle_str( pD->tsp.GZ ) );
    CycleMinStr().SetWindowText("");
    if( pD->tsp.in_contin && pD->test_cnt ) ;
    else
       FullTimeStr().SetWindowText("");

    pD->m_already = 0;  //!!!
    pD->was_calc = 0;
  }
  else if( pD->m_already )
    CycleMinStr().SetWindowText( pD->cycle_str( pD->tsp.GZ ) );

  UpdateData(FALSE);
  pD->UpdateAllViews(this);
}

void CInputView::OnMinInitial()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    if( !(pD->m_already) && !pD->was_calc )  {  warn_me( IDS_MIN_CYCLE_UNKNOWN );  return; }
    for(int i=0; i<=pD->tsp.MAX_2; i++)  pD->tsp.initGZ[i] = pD->tsp.GZ[i];
    ShowCycle( 1/*initOK*/ );
}

void CInputView::OnRandCycle0()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    pD->tsp.Form_Cycle0( 1, TRUE );
    ShowCycle( 1/*initOK*/ );
}

void CInputView::OnTogether() 
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int save_bad = pD->bad_cnt;
    int save_bad2= pD->bad_cnt2;
    int save_test= pD->test_cnt;
    pD->bad_cnt = pD->test_cnt= 0;

    in_comparing = 1;
    switch( pD->m_already )
    {
        case 0: //untested net
                OnCommon();
                if( pD->m_already!=2 )  goto THE_END;

                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();

                pD->ShowRealTime( pD->pol_time+exp_time, &FullTimeStr(), pD->pol_time );
                break;

        case 1: //IIG alg. test was completed. Common is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnCommon();
                if( pD->m_already!=3 )  goto THE_END;
                break;

        case 2: //Common alg. test was completed. IIG is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();
                break;

        case 3: info_me( IDS_ALREADY_COMPARED );
                pD->bad_cnt = save_bad;
                pD->bad_cnt2 = save_bad2;
                pD->test_cnt= save_test;
                in_comparing = 0;
                return;
    }
THE_END:
    in_comparing = 0;

    if( pD->m_already!=3 )
    {
       FullTimeStr().SetWindowText("");
       CycleMinStr().SetWindowText("");
       warn_me( IDS_USER_ABORT );
    }
    else  {
       result = pD->tsp.save_min_cycle( 1/*compare*/ );
       if( result )
         info_me( IDS_TIPTOP );
       else
       {
         pD->bad_cnt++;
         warn_me( IDS_MISMATCH_ERR );
       }
    }
}

void CInputView::OnContinuous()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int randStarts = atoi(pD->m_randStarts);
    int randStarts2 = atoi(pD->m_randStarts2);
    if( !randStarts )  randStarts =1;

    if( randStarts==1 && randStarts2)
    {
      int cnt =  pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );
      if( cnt>1 && MessageBox( time_msg[cnt], "Warning", MB_ICONQUESTION | MB_YESNO)!=IDYES )
        return;
	}

    DWORD the_start=timeGetTime(), total_pol_time=0;

    pD->test_cnt = pD->bad_cnt = pD->bad_cnt2 = 0;
    pD->m_already = 0;
    pD->cont_time = the_start;

    while( pD->test_cnt<INT_MAX )
    {
       OnResetNet();  //m_alre=0

       if( randStarts==1 && randStarts2)   {
         pD->tsp.in_contin = 1;
         OnCommon();
         pD->tsp.in_contin = 0;
         if( pD->m_already!=2 )  break;
         pD->tsp.save_min_cycle( 0/*save*/ );
       }

       pD->tsp.in_contin = 1;
       OnGo();
       total_pol_time += pD->pol_time;
       pD->tsp.in_contin = 0;

       if( (pD->m_already!=3 && randStarts==1 && randStarts2) ||
           (pD->m_already!=1 && randStarts> 1) )  break;

       if( pD->m_already!=1 && randStarts2==0 )  break;

       if( !result && randStarts>1 )  break;

       if(randStarts!=1 || !randStarts2 )   continue;

       result = pD->tsp.save_min_cycle( 1/*compare*/ );
       if( !result )  {
         pD->bad_cnt++;
         warn_me( IDS_MISMATCH_ERR );
         break;
       }
    } //main contin cycle (WHILE)

    pD->pol_time = total_pol_time;
    pD->show_final_time( the_start, &FullTimeStr());
//msgbox("%d,%d", pD->cont_time/1000, pD->pol_time/1000);
    if( pD->test_cnt ) {
      if( !pD->m_already )        pD->m_already=1;
      else if( pD->m_already==2 ) pD->m_already=3;
    }

    if( pD->test_cnt>1 && randStarts==1 && randStarts2) {
      char s[80];
      sprintf(s,"%d networks were succesfully tested.",
                pD->test_cnt - pD->bad_cnt );
      if( pD->bad_cnt )
        strcat(s,"\nThere was 1 different solution.");
      MessageBox(s, "Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
    }

    if( m_bShowStat && pD->test_cnt )
      show_stat( );

    if(pD->test_cnt==0) {
       FullTimeStr().SetWindowText("");
    }
    CycleMinStr().SetWindowText("");
}

/////////////////////////////////////////////////////////////////////////////
// CSplitterFrame
IMPLEMENT_DYNCREATE(CSplitterFrame, CMDIChildWnd)

CSplitterFrame::CSplitterFrame()  {}
CSplitterFrame::~CSplitterFrame() {}

BOOL CSplitterFrame::OnCreateClient(LPCREATESTRUCT,
	 CCreateContext* pContext)
{
    m_wndSplitter.CreateStatic(this,1,2); //splitter (1 row, 2 col)
    m_wndSplitter.CreateView(0,0, pContext->m_pNewViewClass, CSize( 130, 0), pContext);
    m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CInputView), CSize(0,0), pContext);
    m_wndSplitter.SetColumnInfo( 0, 232, 50);

    SetActiveView((CView*)m_wndSplitter.GetPane(0,1));

    ((CInputView*)(m_wndSplitter.GetPane(0,1)))->graph =
       (CView*)m_wndSplitter.GetPane(0,0);

	return TRUE;
}

BEGIN_MESSAGE_MAP(CSplitterFrame, CMDIChildWnd)
	//{{AFX_MSG_MAP(CSplitterFrame)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

////////////////////////////////////////////////////
int CInputView::Prepare_2_tests()
{
    CMainDoc* pD = GetDocument();

    in_comparing = 1; //!!!
    if(!pD->m_already || pD->m_already==2)
      OnGo(); //initial start
    in_comparing = 0;

    if(!pD->m_already || pD->m_already==2) {
      warn_me(IDS_USER_ABORT);
      return 0;
    }
    return 1;
}

void CInputView::OnIfElse()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    in_comparing = 1; //!!!
//  if(!pD->m_already || pD->m_already==2)  {
      pD->polyn_go( &FullTimeStr(), &CycleMinStr(), 1/*only init*/ );
      OnGo(); //initial start
//  }
    in_comparing = 0;

    if(!pD->m_already || pD->m_already==2) {
      FullTimeStr().SetWindowText("");
      CycleMinStr().SetWindowText("");
      warn_me(IDS_USER_ABORT);
      return;
    }

    OnMinInitial();
    pD->tsp.save_min_cycle( 0 );  //save

    BOOL tmp = m_bShowStat;
    m_bShowStat = FALSE;

//++++++++++++++++++++++++++++++++++++++++++++++
    pD->tsp.flag000 = 1;
    pD->tsp.sum000 = pD->tsp.sumGZ;
    for(int i=1; i<=pD->tsp.MAX_2; i++)
      pD->tsp.gz000[i] = pD->tsp.GZmin[i];

////OnGo(); ////////////////////////////////////
    pD->test_cnt = pD->bad_cnt=0;
    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    //DoPolin(); //............................
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    pD->polyn_go( &FullTimeStr(), &CycleMinStr(), 1/*only init*/ );
    int res = pD->tsp.TSPMain(1,1);
    if( !res )  {  pD->m_already += 1;  pD->test_cnt++;  }

    pD->pol_time = pD->ShowRealTime( pD->pol_time, &FullTimeStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );
////////////////////////////////////////////////
    pD->tsp.flag000 = 0;
//++++++++++++++++++++++++++
    m_bShowStat = tmp;

if( res )  {
  CycleMinStr().SetWindowText("");
  warn_me(IDS_USER_ABORT);
  return;
}
    int else_one=0;
    for(i=1; i<=pD->tsp.MAX_2; i++)
      if( pD->tsp.gz000/*saveGZmin*/[i] != pD->tsp.GZmin[i] )
      {
        else_one = 1;
        break;
      }
    pD->m_already = 1/*0*/;
    if(!else_one)
      info_me( m_maxCycle? IDS_NOELSE_MAX: IDS_NOELSE_MIN );
    else  {
      CycleMinStr().SetWindowText( pD->cycle_str(pD->tsp.GZ) );
      msg_cycle("The network has the second cycle with the same length:", pD->tsp.GZ, pD->tsp.MAX_2);
    }
}

void CInputView::OnTest2() 
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    DWORD all_time = timeGetTime();

    pD->polyn_go( &FullTimeStr(), &CycleMinStr(), 1/*only init*/ );

    if( !Prepare_2_tests() )  return;  //get min cycle

    for(int i=0; i<=pD->tsp.MAX_2; i++)  //set min to initial
        pD->tsp.initGZ[i] = pD->tsp.GZ[i];
    ShowCycle(1);

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    if( pD->m_already>=3 )  pD->m_already = 2;
    if( pD->m_already==1 )  pD->m_already = 0;

    pD->tsp.D12orAX4 = AX4;
	pD->tsp.SUM000 = INT_MIN;

////if( !(pD->tsp.TSPMain(1)) )  pD->m_already += 1; //repr1+maxCls
    if( !(pD->tsp.TSPCls()) )  pD->m_already += 1; //repr1+maxCls

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    pD->pol_time = pD->ShowRealTime( all_time/*pD->pol_time*/, &FullTimeStr() );
    ShowCycle( 0 );
/////////////////////////////////
    int popal=0;
    for(i=1; i<pD->tsp.MAX_2; i++)
      for(int j=i+1; j<=pD->tsp.MAX_2; j++)
        if( pD->tsp.netMAIN[i][j]>0 ) popal=1;

    if(pD->m_already==1 || pD->m_already==3)
    {
      if(popal) {
        CTest2Dlg dlg( &(pD->tsp) );
        dlg.DoModal();
      }
      else
        MessageBox( "There are no such edges.","Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
    }
    else
    {
      FullTimeStr().SetWindowText("");
      CycleMinStr().SetWindowText("");
      warn_me( IDS_USER_ABORT );
    }
}


void CInputView::OnShowStat() 
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    if( pD->m_already==1 || pD->m_already==3 )  show_stat();
}

void CInputView::CheckCycle()
{
    CMainDoc* pD = GetDocument();

    char s[5000];
	strcpy( s, m_cycle0);
    cycle_flag = pD->CheckInitial(s);

    if( cycle_flag )  return;

    ShowCycle( 1/*initOK*/ );
}


void CInputView::OnImport()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    pD->Import2();
	ShowCycle( 1 ); //->m_already=0;
}

#endif

