////////////////////////////////////////////////////////////
struct TRPoint { double X, Y; };

class CNetView : public CView
{
protected: // create from serialization only
    CNetView();
    DECLARE_DYNCREATE(CNetView)

// Attributes
public:
    CMainDoc* GetDocument();

    TRPoint Pnts[MAX_1];
    CDC MemDC;
    CFont *pOldFont, fnt, *oldfnt2;
    WORD Rad, Rad2;
    LOGFONT logfont;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CNetView)
	public:
    virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	protected:
    //}}AFX_VIRTUAL

// Implementation
public:
    virtual ~CNetView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

    void get_xy(int,int*,int*);
    BOOL DrawPoints(CDC*);

// Generated message map functions
protected:
	virtual void OnInitialUpdate();
    //{{AFX_MSG(CNetView)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in scribvw.cpp
inline CMainDoc* CNetView::GetDocument()  { return (CMainDoc*)m_pDocument; }
#endif

#ifdef TSMP_DA //////////////////////////////////////////////////////
/*
class CString2 : public CEdit
{
public:

// Implementation
protected:
    //{{AFX_MSG(CString2)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
//  afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};
*/
class CInputView : public CFormView
{
	DECLARE_DYNCREATE(CInputView)
protected:
    CInputView();   // protected constructor used by dynamic creation

public:
    void  ShowCycle( int );
    int   Prepare_2_tests();
    void  DoPolin();
    void  show_stat();
    void  CheckCycle();

    CEdit& FullTimeStr() { return *(CEdit*)GetDlgItem(IDC_TIME); }
    CEdit& Cycle0Str()   { return *(CEdit*)GetDlgItem(IDC_INITIAL_CYCLE); }
    CEdit& CycleMinStr() { return *(CEdit*)GetDlgItem(IDC_MIN_CYCLE); }
    CEdit& RandStart()   { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS); }
//    CString2& RandStart()   { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS); }
    CEdit& RandStart2()  { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS2); }
//    CString2& RandStart2()  { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS2); }

// Form Data
public:
	//{{AFX_DATA(CInputView)
	enum { IDD = IDD_INPUTFORM };
	BOOL	m_ShowWeights;
    CString m_strData;
    CString m_strAmpl;
    CString m_randStarts;
    CString m_randStarts2;
    CString m_cycle0;
    CString m_cycle_save;
    BOOL    m_maxCycle;
    int     in_comparing;
    int     result;
    int     cycle_flag;
    HCURSOR hArrowCur;
    HCURSOR hWaitCur;

    CView*  graph;
    DWORD   exp_time;
    //}}AFX_DATA

// Attributes
public:
    CMainDoc* GetDocument()  {
        ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
        return (CMainDoc*) m_pDocument;
    }

// Operations
public:

// Implementation
protected:
	virtual ~CInputView();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnInitialUpdate();

	// Generated message map functions
	//{{AFX_MSG(CInputView)
	afx_msg void OnDataChange();
	afx_msg void OnNetEditor();
    afx_msg void OnImport();
	afx_msg void OnGetFullTime();
	afx_msg void OnGo();
	afx_msg void OnCommon();
    afx_msg void OnMinInitial();
    afx_msg void OnResetNet();
	afx_msg void OnTogether();
	afx_msg void OnRandCycle0();
	afx_msg void OnContinuous();
	afx_msg void OnIfElse();
	afx_msg void OnTest2();
	afx_msg void OnShowStat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////////
class CSplitterFrame : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CSplitterFrame)
protected:
    CSplitterFrame();   // protected constructor used by dynamic creation

// Attributes
protected:
	CSplitterWnd m_wndSplitter;

// Implementation
public:
	virtual ~CSplitterFrame();
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);

	// Generated message map functions
	//{{AFX_MSG(CSplitterFrame)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif

#ifdef GRAPH_DA /////////////////////////////////////////////////////////
class CGraphView : public CFormView
{
    DECLARE_DYNCREATE(CGraphView)
protected:
    CGraphView();   // protected constructor used by dynamic creation

public:
    void  ShowCycle( int );
    void  DoPolin();
    void  show_stat();
    void  CheckCycle();
#ifdef SUPER_USER2
    void  InitRandom2(int nMaxDeg);
#endif
    CEdit& FullTimeStr() { return *(CEdit*)GetDlgItem(IDC_TIME); }
    CEdit& Cycle0Str()   { return *(CEdit*)GetDlgItem(IDC_INITIAL_CYCLE); }
    CEdit& CycleMinStr() { return *(CEdit*)GetDlgItem(IDC_MIN_CYCLE); }
    CEdit& RandStart()   { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS); }

// Form Data
public:
    //{{AFX_DATA(CGraphView)
    enum { IDD = IDD_GRAPH };
//  BOOL    m_ShowWeights;
	CString m_strData;
	CString	m_strAmpl;
    CString m_randStarts;
    int     in_comparing;
    int     result;
    CString m_cycle0;
    CString m_cycle_save;
    int     cycle_flag;
    HCURSOR hArrowCur;
    HCURSOR hWaitCur;

    CView*  graph;
    DWORD   exp_time;
    //}}AFX_DATA

// Attributes
public:
    CMainDoc* GetDocument()  {
        ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
        return (CMainDoc*) m_pDocument;
    }

// Operations
public:

// Implementation
protected:
    virtual ~CGraphView();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnInitialUpdate();

	// Generated message map functions
	//{{AFX_MSG(CInputView)
	afx_msg void OnDataChange();
	afx_msg void OnNetEditor();
    afx_msg void OnImport();
	afx_msg void OnGetFullTime();
	afx_msg void OnGo();
	afx_msg void OnCommon();
    afx_msg void OnMinInitial();
    afx_msg void OnResetNet();
#ifdef SUPER_USER2
    afx_msg void OnResetNet2();
#endif
    afx_msg void OnTogether();
	afx_msg void OnRandCycle0();
	afx_msg void OnContinuous();
	afx_msg void OnIfElse();
	afx_msg void OnShowStat();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

///////////////////////////////////////////////////////////////////////
class CSplitterFrame2 : public CMDIChildWnd
{
    DECLARE_DYNCREATE(CSplitterFrame2)
protected:
    CSplitterFrame2();

// Attributes
protected:
    CSplitterWnd m_wndSplitter;

// Implementation
public:
    virtual ~CSplitterFrame2();
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);

    //{{AFX_MSG(CSplitterFrame2)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif

#ifdef TMIN_DA ///////////////////////////////////////////////////////////
class CInputView3 : public CFormView
{
    DECLARE_DYNCREATE(CInputView3)
protected:
    CInputView3();

public:
    void  ShowCycle( int );
    void  DoPolin();
    void  CheckCycle();

    CEdit& FullTimeStr() { return *(CEdit*)GetDlgItem(IDC_TIME); }
    CEdit& CycleMinStr() { return *(CEdit*)GetDlgItem(IDC_MIN_CYCLE); }
    CEdit& Cycle0Str() { return *(CEdit*)GetDlgItem(IDC_INITIAL_CYCLE); }

// Form Data
public:
    //{{AFX_DATA(CInputView3)
	enum { IDD = IDD_CHECK_MIN };
	CString m_strData;
	CString	m_strAmpl;
    CString m_cycle0;
    CString m_cycle_save;
	BOOL	m_maxCycle;
    int     result;
    int     cycle_flag;
    HCURSOR hArrowCur;
    HCURSOR hWaitCur;

    CView*  graph;
    DWORD   exp_time;
    //}}AFX_DATA

// Attributes
public:
    CMainDoc* GetDocument()  {
        ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
        return (CMainDoc*) m_pDocument;
    }

// Operations
public:

// Implementation
protected:
    virtual ~CInputView3();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnInitialUpdate();

	// Generated message map functions
    //{{AFX_MSG(CInputView3)
	afx_msg void OnDataChange();
	afx_msg void OnNetEditor();
	afx_msg void OnGetFullTime();
	afx_msg void OnGo();
	afx_msg void OnCommon();
    afx_msg void OnResetNet();
	afx_msg void OnTogether();
    afx_msg void OnGetMin();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

///////////////////////////////////////////////////////////////////////
class CSplitterFrame3 : public CMDIChildWnd
{
    DECLARE_DYNCREATE(CSplitterFrame3)
protected:
    CSplitterFrame3();

// Attributes
protected:
    CSplitterWnd m_wndSplitter;

// Implementation
public:
    virtual ~CSplitterFrame3();
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);

    //{{AFX_MSG(CSplitterFrame3)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif

