#include "stdafx.h"
#include <mmsystem.h>
#include <io.h>
#include "mainfrm.h"

#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#ifdef TMIN_DA //////////////////////////////////////////////////////
void msg_cycle( char *txt, int* gz, int MAX_2);

extern char *IDS_NODES_INVALID;
extern char *IDS_AMPL_INVALID;

static int r_height=0, r_width=0, DLTX_MIN=0, DLTY_MIN=0;
extern int resol, rx0,ry0;

char *IS_NOT_MIN = "The given cycle is not a minimum one.";
char *IS_MIN =     "The given cycle is a minimum cycle.";
char *IS_NOT_MAX = "The given cycle is not a maximum one.";
char *IS_MAX =     "The given cycle is a maximum cycle.";

///////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CInputView3, CFormView)

CInputView3::CInputView3() : CFormView(CInputView3::IDD)
{
    //{{AFX_DATA_INIT(CInputView3)
	m_strData = "";
	m_maxCycle = FALSE;
    m_strAmpl = "100";
    cycle_flag = 0;
    hArrowCur = LoadCursor(0, IDC_ARROW);
    hWaitCur  = LoadCursor(0, IDC_WAIT);
    //}}AFX_DATA_INIT
}

CInputView3::~CInputView3() {}

void CInputView3::OnInitialUpdate()
{
    CMainDoc* pD = GetDocument();

    pD->tsp.tsp_who = TMIN_TEMP;
    pD->tsp.parent = this;
    pD->misc_init( TMIN_TEMP, 8 );

    if( pD->m_ReadOK==TRUE )  m_strAmpl = pD->m_strAmpl;
    else                      pD->m_strAmpl = m_strAmpl;

    pD->tsp.ampl = atoi(m_strAmpl);  //in maindoc ampl=100

    if( pD->m_ReadOK==FALSE )  OnResetNet();

    int alr = pD->m_already;  //save pD->alr
    if( pD->m_ReadOK==TRUE )
    {
      m_cycle0 = pD->cycle_str(pD->tsp.initGZ);
      m_cycle_save = m_cycle0;
      if( alr )  {
        pD->ShowTime2( &FullTimeStr() );
        ShowCycle( 0 );
      }
    }
    else
      ShowCycle( 1 );           //here pD->alr=0;

    pD->m_already = alr;      //return pD->alr

    OnUpdate(this,0,NULL);
//////////////////
    CSplitterWnd *w = (CSplitterWnd *)GetParentFrame();

    if(resol!=1)  {
      if( !r_width )  {
        RECT r;  w->GetWindowRect(&r);
        if( !rx0 )  {  rx0 = r.left;   ry0 = r.top; }
        else {
          DLTX_MIN = r.left-rx0;
          DLTY_MIN = r.top-ry0;
        }
        CycleMinStr().GetWindowRect(&r);
        r_width  = r.right + 30 - DLTX_MIN;
        r_height = r.bottom- 16 - DLTY_MIN;
      }
      w->SetWindowPos(NULL, 0,0, r_width, r_height, SWP_DRAWFRAME|SWP_NOMOVE);
    }
    else  w->ShowWindow(SW_SHOWMAXIMIZED);

    CFormView::OnInitialUpdate();
}

void CInputView3::OnUpdate(CView*, LPARAM, CObject*)
{
    CMainDoc* pD = GetDocument();

    m_strData = pD->m_strData;
    m_strAmpl = pD->m_strAmpl;
    m_maxCycle = pD->tsp.maxCycle;

    UpdateData(FALSE);  // set the data into the controls
}


void CInputView3::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CInputView3)
    DDX_Text(pDX, IDC_NODES, m_strData);
	DDX_Text(pDX, IDC_AMPL, m_strAmpl);
	DDV_MaxChars(pDX, m_strAmpl, 5);
    DDX_Check(pDX, IDC_MAXI_CYCLE, m_maxCycle);
    DDX_Text(pDX, IDC_INITIAL_CYCLE, m_cycle0);
    DDV_MaxChars(pDX, m_cycle0, 5000);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CInputView3, CFormView)
    //{{AFX_MSG_MAP(CInputView3)
    ON_EN_KILLFOCUS(IDC_NODES, OnDataChange)
	ON_BN_CLICKED(IDC_NET_EDITOR, OnNetEditor)
	ON_BN_CLICKED(IDC_CM_TIME, OnGetFullTime)
	ON_BN_CLICKED(IDC_byIIG, OnGo)
	ON_BN_CLICKED(IDC_byCOMMON, OnCommon)
    ON_BN_CLICKED(IDC_RESET_NET, OnResetNet)
	ON_BN_CLICKED(IDC_TOGETHER, OnTogether)
    ON_BN_CLICKED(IDC_GET_MIN, OnGetMin)
	ON_BN_CLICKED(IDC_MAXI_CYCLE, OnDataChange)
	ON_EN_KILLFOCUS(IDC_AMPL, OnDataChange)
    ON_EN_KILLFOCUS(IDC_INITIAL_CYCLE, OnDataChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////
void CInputView3::OnResetNet()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
    pD->ResetNet();
    ShowCycle( 1 );    //->m_already=0;
}

void CInputView3::OnDataChange()
{
    if (!UpdateData())  return;

    CMainDoc* pD = GetDocument();
///////////////////
    if( pD->tsp.working ) {
      m_strData = pD->m_strData;
      m_strAmpl = pD->m_strAmpl;
      m_maxCycle = pD->tsp.maxCycle;
      UpdateData(FALSE);
      return;
    }
///////////////////

	BOOL bUpdate = FALSE;

    if (m_strData != pD->m_strData)
	{
        //check new MAX_2
        int newMAX_2 = atoi(m_strData);
        if( newMAX_2<4 || newMAX_2>=MAX2_LIMIT )
        {
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			char s[80];
            sprintf( s, IDS_NODES_INVALID, MAX2_LIMIT-1);
            MessageBox( s, "Error", MB_ICONEXCLAMATION | MB_OK);
            return;
        }

        if( !pD->tsp.ReAllocate( newMAX_2 ) )
		{
            m_strData = pD->m_strData;
            UpdateData(FALSE);
			warn_me( IDS_USA_NO_MEMORY );

			pD->tsp.ReAllocate( atoi(m_strData) );
		}

        pD->m_strData = m_strData;
        OnResetNet();
        FullTimeStr().SetWindowText( "" ); //???
pD->m_already=0;

        bUpdate = TRUE;
    }

    if (m_strAmpl != pD->m_strAmpl)
	{
        int newAmpl = atoi(m_strAmpl);
        if( newAmpl<0/*1*/ || newAmpl>MAX_AMPL )
        {
            m_strAmpl = pD->m_strAmpl;
            UpdateData(FALSE);
            char s[80];
            sprintf( s, IDS_AMPL_INVALID, MAX_AMPL);
            MessageBox( s, "Error", MB_ICONEXCLAMATION | MB_OK);
            return;
        }
        pD->m_strAmpl = m_strAmpl;
        pD->tsp.ampl = newAmpl;
        OnResetNet();
pD->m_already=0;

        bUpdate = TRUE;
	}

    if( pD->tsp.maxCycle != m_maxCycle )
    {
        pD->m_already = 0;
        pD->tsp.maxCycle = m_maxCycle;
        bUpdate = TRUE;
    }

    if( m_cycle0 != m_cycle_save )
    {
       cycle_flag = 0;
       CheckCycle();
       if( cycle_flag )  {
         m_cycle0 = m_cycle_save;
         UpdateData(FALSE);
         cycle_flag = 0;
       }
       else   {
         pD->m_already = 0;
         m_cycle_save = m_cycle0;
       }
    }

    if (bUpdate)   pD->UpdateAllViews(this);
}

void CInputView3::OnGetFullTime()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    pD->m_already = 0;

    pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );

    if( pD->tsp.MAX_2>=172 )  {
      char s[80], s2[80];
      FullTimeStr().GetWindowText( s, 79 );
      sprintf(s2,"> %s", s);
      FullTimeStr().SetWindowText( s2 );
    }
}

void CInputView3::OnNetEditor()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;
//  if( pD->ShowEditor() )  ShowCycle( 1 );  //->m_already=0;
////////////////
    for(int i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.netDC[i][j] = pD->tsp.net[i][j];

    CMtxEditor dlg(pD->tsp.netDC, pD->tsp.MAX_2, TMIN_TEMP);
    if( dlg.DoModal() != IDOK )  return;

    for(i=0; i<=pD->tsp.MAX_2; i++)
      for(int j=0; j<=pD->tsp.MAX_2; j++)
        pD->tsp.net[i][j] = pD->tsp.netDC[i][j];

	ShowCycle( 1 ); //->m_already=0;
////////////////
}

////////////////////////////////////////////////////////////////////
void CInputView3::DoPolin()
{
    cycle_flag = 0;
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    CMainDoc* pD = GetDocument();

    pD->tsp.D12orAX4 = AX4;
    pD->tsp.SUM000 = INT_MIN;

    int save_sum = pD->tsp.cycle_length( pD->tsp.GZ );
    pD->polyn_go( &FullTimeStr(), &CycleMinStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );
//msgbox("alr=%d (%d,%d)", pD->m_already, pD->tsp.sumGZ, save_sum);
    if( pD->m_already==1 || pD->m_already==3)
    {
      if( (pD->tsp.sumGZ < save_sum && !m_maxCycle) ||
          (pD->tsp.sumGZ > save_sum && m_maxCycle) )
      {
//???
int alr = pD->m_already;
        pD->tsp.Form_Cycle0( 0 );  //return initial cycle
        ShowCycle( 1 );
pD->m_already=alr;

        CycleMinStr().SetWindowText(m_maxCycle? IS_NOT_MAX: IS_NOT_MIN);
        cycle_flag = 1;
      }
      else {
        CycleMinStr().SetWindowText(m_maxCycle? IS_MAX: IS_MIN);
        cycle_flag = 2;
      }
    }
    else
      CycleMinStr().SetWindowText("Testing aborted by user.");
}


void CInputView3::OnGo()
{
#ifdef DEBUG
    int fout=_lcreat("result.",0); _lclose(fout);
#endif

    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    CycleMinStr().SetWindowText("");
    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    ShowCycle( 1 );

    pD->all_time = timeGetTime();
    pD->test_cnt = pD->bad_cnt = pD->graph_cnt = 0;

    DoPolin();

    pD->test_cnt=1;
    pD->ShowRealTime( /*the_start*/pD->all_time, &FullTimeStr() );
}

void CInputView3::OnCommon()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int res = pD->init_exp( &FullTimeStr(), &CycleMinStr(), 0 );
    if( !res )  return;
    exp_time = timeGetTime();
    CycleMinStr().SetWindowText("");

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    cycle_flag = 0;
////
    get_time_text( pD->tsp.exp_time, pD->get_time_in_sec()); //!!!

    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    ShowCycle( 1 );

    int save_sum = pD->tsp.cycle_length( pD->tsp.GZ ); //???

    int ret_val;
    int sum2 = pD->tsp.lookALL( 0, &ret_val );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    pD->test_cnt=1;

    exp_time = pD->ShowRealTime( exp_time, &FullTimeStr() );

    if( !ret_val )  pD->m_already += 2;
    else
    {
pD->test_cnt=0;
      CycleMinStr().SetWindowText("");
      FullTimeStr().SetWindowText("");
      warn_me(IDS_USER_ABORT);
      return;
    }

    if( (sum2 < save_sum && !m_maxCycle) ||
        (sum2 > save_sum && m_maxCycle) )
    {
      int alr = pD->m_already;
      pD->tsp.Form_Cycle0( 0 );  //return initial cycle
      ShowCycle( 1 );
      pD->m_already=alr;

      CycleMinStr().SetWindowText(m_maxCycle? IS_NOT_MAX: IS_NOT_MIN);
      cycle_flag = 1;
    }
    else  {
      CycleMinStr().SetWindowText(m_maxCycle? IS_MAX: IS_MIN);
      cycle_flag = 2;
    }

}

void CInputView3::ShowCycle(int initOK)
{
  CMainDoc* pD = GetDocument();

  if( initOK )
  {
    m_cycle0 = pD->cycle_str(pD->tsp.GZ);
    m_cycle_save = m_cycle0;
    CycleMinStr().SetWindowText("");
    FullTimeStr().SetWindowText("");
    pD->m_already = 0;  //!!!
  }
  else
    CycleMinStr().SetWindowText( pD->cycle_str(pD->tsp.GZ) );

  UpdateData(FALSE);
  pD->UpdateAllViews(this);
}

void CInputView3::OnTogether()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    pD->bad_cnt = pD->test_cnt = 0;

    if( pD->m_already==3 )  {
      info_me( IDS_ALREADY_COMPARED );
      return;
    }

    pD->m_already = 0; //???

    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    ShowCycle( 1 );

    OnCommon();
    int save_flag = cycle_flag;
//msgbox("alr(2)=%d", pD->m_already);
    if( pD->m_already!=2 )  return;

    if( pD->m_already==2 )
    {
      OnGo();
      if( pD->m_already==1 ) pD->m_already=3;
      pD->ShowRealTime( pD->pol_time+exp_time, &FullTimeStr(), pD->pol_time );
    }

    if( pD->m_already!=3 )
    {
       CycleMinStr().SetWindowText("");
       FullTimeStr().SetWindowText("");
       warn_me( IDS_USER_ABORT );
    }
    else  {
       if( cycle_flag==save_flag )
         info_me( IDS_TMIN_BOTH_YES );
       else
       {
         pD->bad_cnt++;
         warn_me( IDS_TMIN_BOTH_NO );
       }
    }
}

void CInputView3::CheckCycle()   //check edit string
{
    CMainDoc* pD = GetDocument();

    char s[5000];
	strcpy( s, m_cycle0);
    cycle_flag = pD->CheckInitial(s);

    if( cycle_flag )  return;

    ShowCycle( 1/*initOK*/ );
}

void CInputView3::OnGetMin()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

////pD->polyn_go( &FullTimeStr(), &CycleMinStr() );
    pD->m_already = 0;

    pD->tsp.Form_Cycle0( 0 );  //return initial cycle
    ShowCycle( 1 );

    pD->tsp.timeF = &FullTimeStr();
    pD->tsp.cycleF = &CycleMinStr();
    pD->pol_time = timeGetTime();
    pD->tsp.start_time = pD->tsp.current_time = pD->pol_time;
    strcpy( pD->tsp.exp_time, "");

    CycleMinStr().SetWindowText("Searching for a final cycle...");

    pD->tsp.D12orAX4 = AX4;

    int res = pD->tsp.TSPMain(-2);
//---------------
    pD->pol_time = pD->ShowRealTime( pD->pol_time, &FullTimeStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    if(res) {
      CycleMinStr().SetWindowText("");
      MessageBox( "Searching for a final cycle is aborted by user.", "Warning", MB_ICONEXCLAMATION | MB_OK);
      return;
    }

    pD->m_already += 1;
    pD->test_cnt++;  //??

    for(int i=0; i<=pD->tsp.MAX_2; i++)
      pD->tsp.initGZ[i] = pD->tsp.GZ[i] = pD->tsp.GZmin[i];

    ShowCycle( 1/*initOK*/ );
}

/////////////////////////////////////////////////////////////////////
// CSplitterFrame3
IMPLEMENT_DYNCREATE(CSplitterFrame3, CMDIChildWnd)

CSplitterFrame3::CSplitterFrame3()  {}
CSplitterFrame3::~CSplitterFrame3() {}

BOOL CSplitterFrame3::OnCreateClient(LPCREATESTRUCT,CCreateContext* pContext)
{
    m_wndSplitter.CreateStatic(this,1,2); //splitter (1 row, 2 col)
    m_wndSplitter.CreateView(0,0, pContext->m_pNewViewClass, CSize( 130, 0), pContext);
    m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CInputView3), CSize(0,0), pContext);
    m_wndSplitter.SetColumnInfo( 0, 232, 50);

    SetActiveView((CView*)m_wndSplitter.GetPane(0,1));

    ((CInputView3*)(m_wndSplitter.GetPane(0,1)))->graph =
       (CView*)m_wndSplitter.GetPane(0,0);

	return TRUE;
}

BEGIN_MESSAGE_MAP(CSplitterFrame3, CMDIChildWnd)
    //{{AFX_MSG_MAP(CSplitterFrame3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#endif

