#include "stdafx.h"
#include "mainfrm.h"
#include "g_lib.h"

#include "tsmp_doc.h"
#include "rand_vw.h"
#include "usadlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

int resol=2;

#ifdef HASP_OK
  int CheckLocalKey(void);
int pass1, pass2, SeedCode=100, pass12=500, haspOK;
int CheckLocalKey(void)  { unsigned int p1,p2,p3,p4;
  hasp( 1/*IS_HASP*/, SeedCode, 0/*LptNum*/, pass1,pass2, &p1,&p2,&p3,&p4);
  if(!p1)  return 0; //HASP_NOT_FOUND;
  return 1;
}
#endif

/////////////////////////////////////////////////////////////
// CIIGApp

BEGIN_MESSAGE_MAP(CIIGApp, CWinApp)
    //{{AFX_MSG_MAP(CIIGApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_ACKNOW, OnAcknow)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
    ON_COMMAND(ID_USA_DEMO, OnUSA)
#ifdef TSMP_DA
    ON_COMMAND(ID_NEW_TSMP, OnTSMP)
#endif
#ifdef GRAPH_DA
    ON_COMMAND(ID_NEW_GRPH, OnGRPH)
#endif
#ifdef TMIN_DA
    ON_COMMAND(ID_NEW_TMIN, OnTMIN)
#endif
    //}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
CIIGApp::CIIGApp()
{
#ifdef HASP_OK
#ifdef HASP_TIME
  pass1 = 37*pass12;//1 GXBZT in USA to Semen (July 1997), TIME 1
  pass2 = 17*pass12;//p1=18807 (37*500+307), p2=8799=(17*500+299)
#elif defined HASP_KOIIG
  pass1 = 16*pass12;//5 KOIIG in USA to Semen (July 1997), memo 1
  pass2 = 33*pass12;//p1=8479 (16*500+479), p2=16885=(33*500+385)
#else
//pass1 = 48*pass12;//WOZCY
//pass2 =  4*pass12;//p1=24033 (48*500+33), p2=2273=( 4*500+273)
#endif
#endif
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CIIGApp object

CIIGApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CIIGApp initialization

BOOL CIIGApp::InitInstance()
{
//    afxtrace = TRUE;
    int scrX = GetSystemMetrics(SM_CXSCREEN);
    if( scrX<700 )  resol=1;
//  else if(scrX>1000) resol=3;

#ifdef HASP_OK
#ifdef HASP_TIME
    pass1 += 307;//1 GXBZT in USA to Semen (July 1997), TIME 1
    pass2 += 299;//p1=18807, p2=8799
#elif defined HASP_KOIIG
    pass1 += 479;//5 KOIIG in USA to Semen (July 1997), memo 1
    pass2 += 385;//p1=8479, p2=16885
#endif
//  pass1 +=  33;//WOZCY
//  pass2 += 273;//p1=24033, p2=2273

    haspOK = CheckLocalKey();
//msgbox("%d, %u,%u", haspOK, pass1, pass2);
#endif

    Enable3dControls();

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)
#ifdef TSMP_DA
    AddDocTemplate( new CMultiDocTemplate( IDR_RANDOM,
		RUNTIME_CLASS(CMainDoc),
        RUNTIME_CLASS(CSplitterFrame),
		RUNTIME_CLASS(CNetView)));
#endif
#ifdef GRAPH_DA
    AddDocTemplate( new CMultiDocTemplate( IDR_GRAPH,
		RUNTIME_CLASS(CMainDoc),
        RUNTIME_CLASS(CSplitterFrame2),
		RUNTIME_CLASS(CNetView)));
#endif
#ifdef TMIN_DA
    AddDocTemplate( new CMultiDocTemplate( IDR_CHECK_MIN,
		RUNTIME_CLASS(CMainDoc),
        RUNTIME_CLASS(CSplitterFrame3),
		RUNTIME_CLASS(CNetView)));
#endif
    AddDocTemplate( new CMultiDocTemplate( IDR_USA_DEMO,
		RUNTIME_CLASS(CMainDoc),
        RUNTIME_CLASS(CMDIChildWnd),
        RUNTIME_CLASS(CUSADemo)));
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;

    m_pMainWnd = pMainFrame;

#ifdef HASP_OK
    if(!haspOK) {
      haspOK = CheckLocalKey();
      if(!haspOK) {
        haspOK = CheckLocalKey();
        if(!haspOK) {  pass1 = pass2/0; exit(0); }
      }
    }
#endif

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes();

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow( SW_SHOWMAXIMIZED/*m_nCmdShow*/);
	pMainFrame->UpdateWindow();

#ifndef SUPER_USER
    OnAcknow();
#else
    OnFileNew();
#endif
    return TRUE;
}

//////////////////////////////////////////////////////////////////////
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
//  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CIIGApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

///////////////////////////////////////////////////////////////////
class CAcknowDlg : public CDialog
{
// Construction
public:
	CAcknowDlg(CWnd* pParent = NULL);   // standard constructor

    CEdit& TextStr()  { return *(CEdit*)GetDlgItem(IDC_EDIT1); }

// Dialog Data
	//{{AFX_DATA(CAcknowDlg)
	enum { IDD = IDD_ACKNOW };
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAcknowDlg)
//  protected:
//  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CAcknowDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CIIGApp::OnAcknow()
{
    CAcknowDlg dlg;
    dlg.DoModal();
}

CAcknowDlg::CAcknowDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcknowDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcknowDlg)
	//}}AFX_DATA_INIT
}

BEGIN_MESSAGE_MAP(CAcknowDlg, CDialog)
	//{{AFX_MSG_MAP(CAcknowDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////
// CAcknowDlg message handlers
char *ackno_txt =
"Dear Friend:\r\n\r\n\
I am proud to introduce to you our new software program that, I am sure, will pleasantly\r\n\
surprise you.  It is without doubt one of the most remarkable  achievements of human\r\n\
thought and activity in the field of computer-related technology.\r\n\
\r\n\
This creation has only become possible due to an outstanding discovery in mathematics\r\n\
made by my father, Ivan I. Goray, who is one of the most modest  scientists I know. As\r\n\
he says himself,  it was nothing but his unawareness  of the number of obstacles to be\r\n\
faced while  working on the development of such a mathematical base  for many years,\r\n\
that made it possible to successfully complete the work.  His talent and patience, which\r\n\
have served to make nature share its secrets with man, can only be admired.\r\n\
\r\n\
I hope that hundreds and thousands of future computer programs and other developments\r\n\
based on my father's discovery will, along with the program you are about to run, be the\r\n\
reward he really deserves, having worked as hard as he did for such a very long time.\r\n\
\r\n\
Sincerely yours,\r\n\r\n\
Leonid Goray,\r\n\
The President of  International Intellectual Group, Inc.";


BOOL CAcknowDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
    TextStr().ReplaceSel( ackno_txt );
    return TRUE;
}

//////////////////////////////////////////////////
//CNewTypeDlg(CPtrList* pList) : CDialog(CNewTypeDlg::IDD)
void CIIGApp::OnUSA()
{
    CDocTemplate* pTemplate;
//    = (CDocTemplate*)(m_pDocManager->m_templateList.GetHead());
//////////////////////////////////
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
	int cnt=0;
    while (pos != NULL)  {
      /*CDocTemplate**/ pTemplate =
        (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
      ASSERT_KINDOF(CDocTemplate, pTemplate);

//    CString strTypeName;
//    if (pTemplate->GetDocString(strTypeName,CDocTemplate::fileNewName))
//      msgbox( "%s", strTypeName );
//if(cnt++==2) break;
	}
    ASSERT(pTemplate != NULL);
    pTemplate->OpenDocumentFile(NULL);
}

#ifdef TEST_A
void CIIGApp::OnTSMP()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
void CIIGApp::OnGRPH()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
                  pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
void CIIGApp::OnTMIN()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
                  pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
                  pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
#elif defined TEST_B
void CIIGApp::OnGRPH()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
void CIIGApp::OnTMIN()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
                  pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
#else
void CIIGApp::OnTMIN()
{
    POSITION pos = m_pDocManager->GetFirstDocTemplatePosition();
    CDocTemplate* pTemplate = (CDocTemplate*)(m_pDocManager->GetNextDocTemplate(pos));
    ASSERT(pTemplate != NULL);
	ASSERT_KINDOF(CDocTemplate, pTemplate);
    pTemplate->OpenDocumentFile(NULL);
}
#endif

