#include "stdafx.h"
#include <mmsystem.h>
#include "mainfrm.h"

#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"
#include "usadlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern char* copyr;
BOOL m_saveTxt=FALSE, m_bShowStat=TRUE, only1set=FALSE;

//////////////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CMainDoc, CDocument)

BEGIN_MESSAGE_MAP(CMainDoc, CDocument)
    //{{AFX_MSG_MAP(CMainDoc)
	ON_UPDATE_COMMAND_UI(ID_SHOW_STAT, OnUpdateShowStat)
	ON_COMMAND(ID_SHOW_STAT, OnShowStat)
	ON_COMMAND(ID_SAVE_TXT, OnSaveTxt)
	ON_UPDATE_COMMAND_UI(ID_SAVE_TXT, OnUpdateSaveTxt)
    ON_COMMAND(ID_PRINT_NET, OnPrintNet)
    ON_COMMAND(ID_RECALC_BAD, OnRecBad)
    ON_UPDATE_COMMAND_UI(ID_RECALC_BAD, OnUpdateRecBad)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
CMainDoc::CMainDoc()
{
    was_calc = 0;
#ifdef HASP_OK
    extern int pass1,pass2;
    unsigned int p1,p2,p3,p4;
    hasp( 2/*GET_HASP_CODE*/, 10, 0/*LptNum*/, pass1,pass2, &p1,&p2,&p3,&p4);

    //////////////////////////
    //seed=10 !!!
#ifdef HASP_TIME
    if(p1!=33088 || p4!=33355)  exit(0); // 1 GXBZT
#elif defined HASP_KOIIG
    if(p1!=30682 || p4!=51263)  exit(0); // 5 KOIIG
#endif
#endif
}

CMainDoc::~CMainDoc()
{
///////////////////////////////
#ifdef SUPER_USER
    HFILE fout = _lcreat( "params.dat", 0);
    double d[8];
    d[0]=perNUM+0.001;
    d[1]=tirNUM+0.001;
    d[2]=perUSA+0.001;
    d[3]=tirUSA+0.001;
    d[4]=fstNUM;
    d[5]=scdNUM;
    d[6]=fstUSA;
    d[7]=scdUSA;
   _lwrite( fout, (char*)(&d[0]), sizeof(double)*8 );
   _lclose(fout);
#endif
///////////////////////////////
    tsp.FreeMemory();
    if( tsp.working ) exit(0);
}

BOOL CMainDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())  return FALSE;

    m_strData = "8";
    m_strAmpl = "100";
    m_randStarts = "1";
    m_randStarts2= "1";
    m_ShowWeights = TRUE;

	m_ReadOK = FALSE;
    m_already = 0;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainDoc serialization
//IMPLEMENT_SERIAL(CMainDoc, CDocument, 321)
extern char *IS_NOT_MIN, *IS_MIN, *IS_NOT_MAX, *IS_MAX;

void out_file(int fout, char* buf, int to_prn, int passN)
{
if(passN)  {
  char s1[5000];
  if( to_prn && strlen(buf)>81 )  {
    if(passN==1)  buf[81]=0;
    if(passN>=2/*==2*/)  {
      strcpy( s1, "\r\n");
      if( strlen(buf)>(passN-1)*80+1 )  {
        strcat( s1, &buf[(passN-1)*80+1] );
        strcpy( buf, s1 );
        buf[ passN*80+1 ] = 0;
      }
      else
        strcpy( buf, "\r\n");
    }
  }
  else if( to_prn )
    strcpy( buf, "\r\n");
}
 _lwrite( fout, buf, strlen(buf));
}

void CMainDoc::save_to_file(char* filename)
{
  int  i,j;
  char s1[5000];
  int  to_prn=0;
  if( !strcmp(filename,"PRN") ) to_prn=1;

  int  passN=0;
  if( tsp.MAX_2>15 )  passN=1;

  int fout = _lcreat( filename, 0);
 _lwrite( fout, "\r\n", 2);

  strcpy( s1, copyr);
  switch( m_who )  {
    case RAND_TEMP:  strcat(s1, " (TSMP Test)");  break;
    case GRAPH_TEMP: strcat(s1, " (Graph Test)");  break;
    case USA_TEMP:   strcat(s1, " (USA Map)");  break;
    case TMIN_TEMP:  strcat(s1, " (Check the Given Cycle)");  break;
  }
 _lwrite( fout, s1, strlen(s1));


POVTOR:
  strcpy( buf, "\r\nNode");
  for(i=1; i<=tsp.MAX_2; i++)  {
    sprintf( s1," %*d", (m_who==GRAPH_TEMP? 3:CHAR_QNT), i);
    strcat( buf, s1);
  }
///////
  out_file(fout, buf, to_prn, passN);

  for(i=1; i<=tsp.MAX_2; i++)  {
    sprintf( buf,"\r\n%2d: ", i);
    for(j=1; j<=tsp.MAX_2; j++)  {
      sprintf(s1," %*d", (m_who==GRAPH_TEMP? 3:CHAR_QNT), tsp.net[i][j]);
      strcat( buf, s1);
    }
    out_file(fout, buf, to_prn, passN);
  }

 _lwrite( fout, "\r\n", 2);

if(passN<2) {
 _lwrite(fout, "\r\nNodes: ", 9);
  sprintf(buf, "%d", tsp.MAX_2);
 _lwrite(fout, buf, strlen(buf) );

  if( m_who==USA_TEMP )    _lwrite(fout, "\r\n", 2);
  else {
    if( m_who!=GRAPH_TEMP )  _lwrite(fout, "\r\nAmplitude: ", 13);
    else                     _lwrite(fout, "\r\nMax.Degree: ",14);
   _lwrite(fout, m_strAmpl, strlen(m_strAmpl) );
  }
}
else
 _lwrite(fout, "\r\n\r\n", 4);

  strcpy( s1,"\r\nInitial Cycle  : ");
  cycle_str( tsp.initGZ );
  strcat(s1, buf);
  strcpy(buf, s1);
  out_file(fout, buf, to_prn, passN);

  switch( m_already )  {
    case 3: strcpy(buf,"\r\nBy Both Methods:");  break;
    case 2: strcpy(buf,"\r\nBy Exp. Method:");   break;
    case 1: strcpy(buf,"\r\nBy Polyn. Method:"); break;
    case 0: break;
  }

  if( m_already )
  {
    if( passN<2 )
     _lwrite(fout, buf, strlen(buf) );
    else
     _lwrite(fout, "\r\n", 2);

    if( tsp.sumGZ==0 || m_who!=GRAPH_TEMP )  {
      if( m_who!=TMIN_TEMP ) {
        sprintf( s1,"\r\n%s Cycle  : ",(!tsp.maxCycle? "Minimum":"Maximum"));
        cycle_str( tsp.GZmin );
        strcat(s1, buf);
        strcpy(buf, s1);
      }
      else {
        strcpy(buf,"\r\n");
        if( !tsp.maxCycle )  {
          if( tsp.cycle_length(tsp.initGZ) > tsp.cycle_length(tsp.GZmin))
            strcat( buf, IS_NOT_MIN );
          else
            strcat( buf, IS_MIN );

        }
        else {
//msgbox("%d,%d", tsp.cycle_length(tsp.initGZ), tsp.cycle_length(tsp.GZmin));
          if( tsp.cycle_length(tsp.initGZ) < tsp.cycle_length(tsp.GZmin))
            strcat( buf, IS_NOT_MAX);
          else
            strcat( buf, IS_MAX );
        }
      }
    }
    else
      strcpy( buf, "\r\nCycle does not exist");

    out_file(fout, buf, to_prn, passN);

    if( passN<2 ) {
     _lwrite( fout, "\r\n\r\n", 4 );

      if( m_already!=2 && m_who!=TMIN_TEMP ) {
        show_stat(0/*without box*/);
       _lwrite( fout, buf, strlen(buf) );
      }
    }
  }

  if( to_prn && passN==1 ) {
    passN=2;
   _lwrite( fout, "\f\r\n", 3);
    goto POVTOR;
  }
  if( to_prn && passN==2 && tsp.MAX_2>30 ) {
    passN=3;
   _lwrite( fout, "\f\r\n", 3);
    goto POVTOR;
  }
  if( to_prn && passN==3 && tsp.MAX_2>45 ) {
    passN=4;
   _lwrite( fout, "\f\r\n", 3);
    goto POVTOR;
  }

  if( to_prn ) {
    sprintf(buf,"\f");
   _lwrite( fout, buf, 1);
  }
 _lclose(fout);
}

void CMainDoc::Serialize(CArchive& ar)
{
	int i,j;
	long w;

    if (ar.IsStoring()) //write to file
	{
        w = tsp.MAX_2;  ar << w;
        w = m_who;      ar << w;

        for(i=0; i<=tsp.MAX_2; i++)
		{
            w=tsp.initGZ[i];
        	ar << w;
		}
		for(i=0; i<=tsp.MAX_2; i++)
 			for(j=0; j<=tsp.MAX_2; j++)
			{
				w=tsp.net[i][j];
        		ar << w;
			}

        ar << m_strAmpl;
        w = m_ShowWeights;  ar << w;
        w = tsp.maxCycle;   ar << w;

        w = m_already;  ar << w;
		for(i=0; i<=tsp.MAX_2; i++)
		{
            if(m_already) w=tsp.GZmin[i];
            else          w=tsp.GZ[i];
        	ar << w;
		}
        ar << m_randStarts;
        ar << test_cnt;
        ar << bad_cnt;
        ar << graph_cnt;
        ar << pol_time;
        ar << all_time;
        ar << cont_time;

        if( m_who==USA_TEMP )
        {
          for( i=1; i<MAX_USA; i++ )
          {
            w = tsp.active_state[i];
            ar << w;
          }
          w = tsp.useKm;
          ar << w;
        }

        /////////////////////////////////////////
        if( m_saveTxt )
        {
          char *s;
		  CFile* f = ar.GetFile();
		  strcpy( buf, f->GetFilePath() );
          s = strchr( buf, '.');
		  if( s==NULL )  strcat(buf,".txt");
          else  {
            if( strcmp(s,".txt") )  strcpy( s, ".txt");
            else                    strcpy( s, ".tx");
          }
          save_to_file( buf );
      }
    }
    else ////////////read///////////////////////////////
	{
		//at first let's get MAX_2, then do reallocate

        ar >> w;  int newMAX_2 = (int)w;
        ar >> w;  m_who = (int)w;
tsp.tsp_who = m_who;

        if( m_who!=USA_TEMP )
          m_strData = itoa(newMAX_2, buf, 10);

        tsp.m_ReadOK=1;
        tsp.ReAllocate( newMAX_2 );
        tsp.m_ReadOK=0;

        for(i=0; i<=tsp.MAX_2; i++)
		{
        	ar >> w;
            tsp.initGZ[i]=(int)w;
            tsp.GZ[i] = (int)w;
        }

        for(i=0; i<=tsp.MAX_2; i++)
            for(j=0; j<=tsp.MAX_2; j++)
			{
        		ar >> w;
                tsp.net[i][j] = (int)w;
            }

        ar >> m_strAmpl;
        ar >> w;  m_ShowWeights = (int)w;
        ar >> w;  tsp.maxCycle = (int)w;
        ar >> w;  m_already = (int)w;

        for(i=0; i<=tsp.MAX_2; i++)
        {
            ar >> w;
            if(m_already)  tsp.GZmin[i] = tsp.GZ[i] = (int)w;
            else           tsp.GZmin[i] = tsp.GZ[i] = tsp.initGZ[i];
//          else           tsp.GZ[i] = (int)w;
        }
        ar >> m_randStarts;
        m_randStarts = "1";
        m_randStarts2 = "1";
        ar >> test_cnt;
        ar >> bad_cnt;
        ar >> graph_cnt;
        ar >> pol_time;
        ar >> all_time;
        ar >> cont_time;

        if( m_who==USA_TEMP )
        {
          for( i=1; i<MAX_USA; i++ )
          {
            ar >> w;
            tsp.active_state[i] = (int)w;
          }
          ar >> w;
          tsp.useKm = (int)w;
///////////////////////////
          for(i=1,j=1; j<=tsp.MAX_2, i<MAX_USA; i++)
          {
            if( !tsp.active_state[i] )  continue;
            strcpy( tsp.capits[j], arr_states[i].capital );
            strcpy( tsp.states[j], arr_states[i].usa_state );
            j++;
          }
///////////////////////////
        }

        tsp.ampl = atoi(m_strAmpl);

        if( !m_already ) {
          test_cnt=bad_cnt=graph_cnt=bad_cnt2=0;
          pol_time=all_time=cont_time=0;
        }

//???   m_saveTxt = FALSE;
    }
}

/////////////////////////////////////////////////////////////////////////////
// CMainDoc diagnostics

#ifdef _DEBUG
void CMainDoc::AssertValid() const { CDocument::AssertValid(); }
void CMainDoc::Dump(CDumpContext& dc) const { CDocument::Dump(dc); }
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainDoc commands

BOOL CMainDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	m_ReadOK = TRUE;

    return TRUE;
}

//////////////////////////////////////////////////////
void CMainDoc::ResetNet()
{
    if( tsp.working ) return;

    tsp.Form_Matrix();
    if( m_who==GRAPH_TEMP )  DoBinaryMtx();
    tsp.Form_Cycle0( 1/*initOK*/ );
}

void CMainDoc::DoBinaryMtx()
{
    int i,j, nS, MAX_2=tsp.MAX_2;

    srand( (unsigned)timeGetTime() );
/////////////
    if( !tsp.ampl ) {
      for(i=1;i<=MAX_2;i++)
        for(j=i+1; j<=MAX_2; j++)  tsp.net[i][j] = random(2);
      return;
    }
/////////////
    for(i=1; i<=MAX_2; i++)
        for(j=1; j<=MAX_2; j++)   tsp.net[i][j] = (j>i);

    for(nS=1; nS<=MAX_2; nS++)
    {
      int k, val, cnt = MAX_2-1;
      int gz[MAX2_LIMIT_G+1], gz2[MAX2_LIMIT_G];

      for(i=1; i<=MAX2_LIMIT_G; i++)  gz[i]=i;

      for(i=2; i<=MAX_2; i++)   {
        val = random( cnt )+2;  //+2 :to avoid ZERO & 1
        j=1;
        for(k=2; k<=MAX_2; k++) {  if(gz[k]) j++;  if(j==val) break;  }
        gz2[i] = gz[ k ];
        gz[ k ]=0;
        cnt--;
      }
      gz2[1]=1;
      val = random(MAX_2-1)+1;
      for( i=val; i<=MAX_2; i++)  gz[i-val+1] = gz2[i];
      for( i=1; i<val; i++)  gz[i+MAX_2-val+1] = gz2[i];

      //calc: how much already
      k=0;
      for(i=1; i<=MAX_2; i++)
        for(j=i+1; j<=MAX_2; j++)
          if((i==nS || j==nS) && tsp.net[i][j]==0) ++k;

      cnt=0;
      for(i=1; i<=MAX_2; i++)
      {
        if( cnt==tsp.ampl-k) break;
        if( gz[i]<=nS )  continue;  //<=
        if( tsp.net[min(gz[i],nS)][max(gz[i],nS)]==0)  continue;

        //test qnt edges of gz[i] node
        int x,y,k2=0;
        for(x=1; x<=MAX_2; x++)
          for(y=x+1; y<=MAX_2; y++)
            if((x==gz[i] || y==gz[i]) && tsp.net[x][y]==0) ++k2;
        if(k2 >= tsp.ampl) continue;

        tsp.net[min(gz[i],nS)][max(gz[i],nS)] = 0;
        cnt++;
      }
    }
}

double CMainDoc::get_time_in_sec()
{
    DWORD the_start = timeGetTime();      //time in millisec
    int qnt;

    qnt = tsp.lookALL( 1 );

    DWORD the_time = timeGetTime() - the_start;      //the_time of qnt cycles

    if( tsp.MAX_2<172 )
      return factorial(tsp.MAX_2)*the_time/(1000.*qnt);  //1000->to sec
    else
      return factorial(171)*the_time/(1000.*qnt);
}


void CMainDoc::OnUpdateShowStat(CCmdUI* pCmdUI) { pCmdUI->SetCheck( m_bShowStat); }
void CMainDoc::OnUpdateSaveTxt(CCmdUI* pCmdUI) { pCmdUI->SetCheck( m_saveTxt ); }
void CMainDoc::OnShowStat() { m_bShowStat = !m_bShowStat; }
void CMainDoc::OnSaveTxt()  { m_saveTxt = !m_saveTxt; }
void CMainDoc::OnUpdateRecBad(CCmdUI* pCmdUI) { pCmdUI->SetCheck( only1set ); }
void CMainDoc::OnRecBad() { only1set = !only1set; }

void CMainDoc::OnPrintNet()  {  save_to_file("PRN"); }

void CMainDoc::show_stat(int show_box)
{
  char s2[80];

  int randStarts = atoi(m_randStarts);

  if( m_already==3 && randStarts!=1 ) test_cnt=randStarts;

  sprintf( buf, "Number of random tests: %d\r\n", test_cnt);

//if( randStarts>1 )  {
    int cnt1 = test_cnt/randStarts;
    int cnt2 = test_cnt%randStarts;

    if( !cnt2 )
      sprintf( s2, "(%d %s(s) with %d random starts)\r\n",
          cnt1, (m_who==GRAPH_TEMP? "graph":"network"), randStarts);
    else
      sprintf( s2, "(%d %s(s) with %d random starts\n and 1 %s with %d random start(s))\r\n",
      cnt1, (m_who==GRAPH_TEMP? "graph":"network"), randStarts,
            (m_who==GRAPH_TEMP? "graph":"network"), cnt2);

    strcat( buf, s2 );

    if( m_who==RAND_TEMP || m_who==USA_TEMP)  {
      int randStarts2 = atoi(m_randStarts2);
//if(randStarts2==0) randStarts2=1;
      if( randStarts2 && randStarts2<=randStarts ) {
        int tmp = cnt1*randStarts2;
        if( cnt2 ) {
          if( cnt2>=randStarts2 )  tmp+=randStarts2;
          else                     tmp+=cnt2;
        }
        sprintf(s2, "Full tests: %d, shorten tests: %d\r\n", tmp, test_cnt-tmp);
        strcat( buf, s2 );
      }
      else if( !randStarts2 )  {
        if( test_cnt && cnt1==0 ) cnt1=1;
          sprintf(s2, "Short tests: %d, shorten tests: %d\r\n", cnt1, test_cnt-cnt1);
        strcat( buf, s2 );
      }
    }


  if( m_who==GRAPH_TEMP && test_cnt>1 )  {
    sprintf( s2, "Cycle  was  found  in  %d  graph(s).\r\n", graph_cnt);
    strcat( buf, s2 );
  }

  if( m_already!=2 ) {
    sprintf( s2,"Average time of polyn.method: %.3f sec\r\n",
               1.*pol_time/(1000.*test_cnt) );
    strcat( buf, s2 );

    get_time_text( s2, pol_time/1000. );
  }
  else
    get_time_text( s2, all_time/1000. );

  strcat( buf,"Total time of polyn.method: ");
  strcat( buf, s2);

  if( bad_cnt )  {
    sprintf( s2, "\r\nDifferent solutions were found %d times.", bad_cnt);
    strcat( buf, s2);
  }

  if(show_box)
    ::MessageBox(NULL, buf, "Information", MB_OK | MB_ICONINFORMATION | MB_TASKMODAL);
}

char* CMainDoc::cycle_str(int* gz)
{
  char   s2[20];
  sprintf( buf, "( %d) 1", tsp.cycle_length( gz ));

  for(int i=1; i<=tsp.MAX_2; i++)
  {
    sprintf( s2, "-%d", gz[i]);
    if(i!=1)  strcat( buf, s2);
    if( strlen(buf)>4990 ) break;
  }
  strcat( buf, "-1");

  return buf;
}

int CMainDoc::CalcFullTime( double full_time_sec, CEdit* timeF )
{
    char s[80]/*, s2[80]*/;
    int mode = get_time_text( s, full_time_sec);

    if( !tsp.in_contin )  {
//    if(m_who==GRAPH_TEMP) { sprintf(s2,"<=%s",s); timeF->SetWindowText(s); }
//    else
        timeF->SetWindowText( s );
    }
	return mode;
}

void CMainDoc::ShowTime2( CEdit* timeF )
{
    char s[80];
    get_time_text( s, pol_time/1000. );
    if( test_cnt ) {
      char s2[40];
      sprintf(s2, ", %d test(s)", test_cnt );
      strcat( s, s2 );
    }
    timeF->SetWindowText( s );
}

DWORD CMainDoc::ShowRealTime( DWORD the_start, CEdit* timeF, DWORD polyn_time )
{
    DWORD the_time = timeGetTime() - the_start;

    if( polyn_time )  CalcFullTime( the_start/1000., timeF);  //in sec
    else              CalcFullTime( the_time/1000., timeF );

//all_time = the_time;
//if(polyn_time)  all_time = the_start;

    char s[80], s2[40];
    timeF->GetWindowText( s, 79 );

    if( polyn_time && m_already==3 )  { //show polyn.method time
      get_time_text( s2, polyn_time/1000. );
      strcat( s, " (");
      strcat( s, s2);
      strcat( s, ")");
    }

    if( tsp.in_contin )  return the_time;

    strcat( s, "*");

//////////
//  if( test_cnt ) {
      if(m_already!=2) sprintf(s2, ", %d test(s)", test_cnt );
      else             sprintf(s2, ", 1 test(s)");
      strcat( s, s2 );
//  }
//////////

    timeF->SetWindowText( s );
    return the_time;
}

void CMainDoc::show_final_time( DWORD the_start, CEdit* timeF )
{
    char s[80], s2[40];
    DWORD the_end = timeGetTime() - the_start;
//???
all_time = the_end;
    CalcFullTime( the_end/1000., timeF );  //in sec
    timeF->GetWindowText( s, 79 );

//  if( m_already== 3 ) {
    int randStarts = atoi(m_randStarts);
    if( randStarts==1 ) {
      get_time_text( s2, pol_time/1000. );
      strcat( s, " (");
      strcat( s, s2);
      strcat( s, ")");
    }
    sprintf( s2,", %d test(s)", test_cnt);
    strcat( s, s2);
    timeF->SetWindowText( s );
}

void CMainDoc::misc_init( int who, int max_2 )
{
    tsp.working = 0;
    tsp.cycleExist = (who==GRAPH_TEMP);
    tsp.elseFST = INT_MIN;

    if( !m_ReadOK )  {
      tsp.initTSP( max_2, (who==USA_TEMP));
      m_who = who;
    }
    else   tsp.USA_OK = (who==USA_TEMP);

    tsp.without_graph = 0;
    tsp.in_contin = 0;
/////////////
    switch( who ) {
      case RAND_TEMP:
      case GRAPH_TEMP:  tsp.IN_RANDOM=1;  break;

      case USA_TEMP:    tsp.IN_RANDOM=0;  break;

      case TMIN_TEMP:   tsp.IN_RANDOM=-1;
                        tsp.without_graph = 1;
    }
}

void mes2(char *fmt ...);
void CMainDoc::polyn_go( CEdit* timeF, CEdit* cycleF, int only_init )
{
    if( m_already>=3 )  m_already = 2;
    if( m_already==1 )  m_already = 0;

    tsp.timeF = timeF;
    tsp.cycleF = cycleF;
    pol_time = timeGetTime();
///////////
    tsp.start_time = pol_time;
    tsp.current_time = pol_time;
    strcpy( tsp.exp_time, "");

    if( only_init ) return; //!!!
	/////////////////---------------
    int res;
    switch( m_who ) {
      case RAND_TEMP:  res = tsp.TSPMain(1);  break;
      case USA_TEMP:   res = tsp.TSPMain(0);  break;
#ifdef GRAPH_DA
      case GRAPH_TEMP: res = tsp.TSPMain_g(); break;
#endif
      case TMIN_TEMP:  res = tsp.TSPMain(-1/*,1*/); break;
    }

    if( !res )  {  m_already += 1;  test_cnt++;  }
//---------------
    pol_time = ShowRealTime( pol_time, timeF );
    was_calc = 1;
}


BOOL CMainDoc::CanCloseFrame( CFrameWnd* p)
{
    if( tsp.working )  return FALSE;
    return CDocument::CanCloseFrame(p);
}

int CMainDoc::init_exp( CEdit* timeF, CEdit* cycleF, int in_compar )
{
    if( m_already>=3 )  m_already = 1;
    if( m_already==2 )  m_already = 0;

    int res = CalcFullTime( get_time_in_sec(), timeF );
    if( !tsp.in_contin && res>1 )
    { 
        if( ::MessageBox( NULL, time_msg[res], "Warning", MB_ICONQUESTION | MB_YESNO)!=IDYES )
        {
          timeF->SetWindowText("");
          if( m_who!= USA_TEMP) cycleF->SetWindowText("");
          return 0;
        }
    }

    if( !in_compar && !tsp.in_contin )
      test_cnt=bad_cnt=bad_cnt2=graph_cnt=0;

    DWORD exp_time = timeGetTime();
    tsp.start_time = exp_time;
    tsp.current_time = exp_time;
    tsp.timeF = timeF;
    tsp.cycleF = cycleF;
    was_calc = 1;
    return 1;
}

int CMainDoc::CheckInitial( char* cycle_txt )
{
    char s[5000], s2[5000], *ptr;
    int i, len, cnt=1, gz_uz[MAX_1], gz2[MAX_1];
    for(i=0; i<=tsp.MAX_2; i++)  gz_uz[i] = gz2[i] = 0;

    strcpy( s, cycle_txt );

    len = strlen(s);
    if( s[len-1]!='1' ) strcat(s,"-1");
    TRACE("%s, %c, %c", s, s[len-1], s[len-2]);

    ptr = strstr( s, "1-");
    if( !ptr )  {
      info_me( IDS_TMIN_ERR1 );
      return 1;
    }
    ptr++;
    len = strlen(ptr);
    strcpy( s2, "1");
    int cnt_s2=1;
    for(i=0; i<len; i++) {
      if(ptr[i]=='-' || (i==len-1 && s2 && atoi(s2)!=1))
      {
        i++;  //miss '-'

        s2[cnt_s2] = 0;
        int uz = atoi( s2 );

        if( uz<1 || uz>tsp.MAX_2 ) {
          info_me( IDS_TMIN_ERR2 );
          return 2;
        }
        if( gz2[ uz ] ) {
          info_me( IDS_TMIN_ERR3 );
          return 3;
        }

        gz2[uz] = cnt;
        gz_uz[cnt] = uz;
//msgbox("uz=%d, cnt=%d (ptr[%d]=%s)", uz, cnt, i, &ptr[i]);
        cnt_s2 = 0;
        cnt++;
      }
      s2[cnt_s2] = ptr[i];
      cnt_s2++;
    }

    cnt--;
    if( cnt!=tsp.MAX_2 ) {
      info_me( IDS_TMIN_NODES_INVALID );
      return 4;
    }

    for(i=1; i<=tsp.MAX_2; i++)   tsp.GZ[i] = gz_uz[i];
    tsp.do_forma1();
    for(i=1; i<=tsp.MAX_2; i++)   tsp.initGZ[i] = tsp.GZ[i];

    return 0;
}

////////////////////////////////////////////////////////////
void LoadTextFile(FILE* fout, int MAX_2, int** net, int who)
{
        int i,j;

        for(i=1; i<=MAX_2; i++)
          for(j=1; j<=MAX_2; j++)  net[i][j]=0;

        char s[5000], *ss, *p;
		i=0;
        while( fgets( s, 5000, fout)!= NULL)
        {
           p = strchr( s, ':');
           if(p==NULL)  continue;
           p++;
           ss = p;
		   i++;
           for(j=1;j<=MAX_2;j++)
           {
             int tmp = (int)strtod( p, &ss);
             net[i][j] = (tmp > SHRT_MAX ? SHRT_MAX: tmp);
             if(tmp < SHRT_MIN) net[i][j] = SHRT_MIN;

if(who==GRAPH_TEMP) {
  if( net[i][j]>0 ) net[i][j]=1;
  else              net[i][j]=0;
}
             p = ss;
           }
           if(i==MAX_2) break;
        }
}

void CMainDoc::Import2()
{
    CFileDialog *dlg = new CFileDialog( TRUE, "txt", "*.txt");

    if( dlg->DoModal()==IDOK )
    {
        FILE* fout = fopen( dlg->GetPathName(), "rt");

///////////////////////////////////
        LoadTextFile( fout, tsp.MAX_2, tsp.net, m_who);
///////////////////////////////////

        fclose(fout);

        tsp.Form_Cycle0( 1/*initOK*/ ); //!!!
    }
}

