#include "stdafx.h"
#include "mainfrm.h"
#include "g_lib.h"
#include "tsmp_doc.h"
#include "rand_vw.h"
#include "usadlg.h"

#include <math.h>
#include <mmsystem.h>

int Round( double nmb )
{
  return (int)( nmb-floor(nmb)>=0.5 ? ceil(nmb) : floor(nmb) );
}

//////////////////////////////////////////////////////////////////
STATES arr_states[] = {
{   0,  "", "", 0, 0 },                                  // 0
{   1,  "Albany",       "New York",     477,    101 },   // 1
{   2,  "Annapolis",    "Maryland",     460,    148 },   // 2
{   3,  "Atlanta",      "Georgia",      392,    224 },   // 3
{   4,  "Augusta",      "Maine",        503,    69 },    // 4
{   5,  "Austin",       "Texas",        259,    277 },   // 5
{   6,  "Baton Rouge",  "Louisiana",    324,    276 },   // 6
{   7,  "Bismarck",     "North Dakota", 232,    73 },    // 7
{   8,  "Boise",        "Idaho",        94,     87 },    // 8
{   9,  "Boston",       "Massachusetts",498,    93 },    // 9
{   10, "Carson City",  "Nevada",       46,     135 },   //10
{   11, "Charleston",   "West Virginia",417,    164 },   //11
{   12, "Cheyenne",     "Wyoming",      189,    135 },   //12
{   13, "Columbia",     "South Carolina",424,   218 },   //13
{   14, "Columbus",     "Ohio",         396,    147 },   //14
{   15, "Concord",      "New Hampshire",496,    85 },    //15
{   16, "Denver",       "Colorado",     181,    154 },   //16
{   17, "Des Moines",   "Iowa",         294,    135 },   //17
{   18, "Dover",        "Delaware",     473,    149 },   //18
{   19, "Frankfort",    "Kentucky",     381,    171 },   //19
{   20, "Harrisburg",   "Pennsylvania", 457,    132 },   //20
{   21, "Hartford",     "Connecticut",  488,    105 },   //21
{   22, "Helena",       "Montana",      136,    57 },    //22
{   23, "Honolulu",     "Hawaii",         1,    215 },   //23
{   24, "Indianapolis", "Indiana",      367,    155 },   //24
{   25, "Jackson",      "Mississippi",  335,    250 },   //25
{   26, "Jefferson City","Missouri",    308,    175 },   //26
{   27, "Juneau",       "Alaska",        13,    1 },     //27
{   28, "Lansing",      "Michigan",     375,    117 },   //28
{   29, "Lincoln",      "Nebraska",     269,    148 },   //29
{   30, "Little Rock",  "Arkansas",     314,    225 },   //30
{   31, "Madison",      "Wisconsin",    331,    117 },   //31
{   32, "Montgomery",   "Alabama",      379,    242 },   //32
{   33, "Montpelier",   "Vermont",      480,    73 },    //33
{   34, "Nashville",    "Tennessee",    367,    197 },   //34
{   35, "Oklahoma City","Oklahoma",     258,    207 },   //35
{   36, "Olympia",      "Washington",   51,     28 },    //36
{   37, "Phoenix",      "Arizona",      107,    223 },   //37
{   38, "Pierre",       "South_Dakota", 239,    98 },    //38
{   39, "Providence",   "Rhode Island", 500,    104 },   //39
{   40, "Raleigh",      "North Carolina",451,   188 },   //40
{   41, "Richmond",     "Virginia",     456,    168 },   //41
{   42, "Sacramento",   "California",   27,     138 },   //42
{   43, "Salem",        "Oregon",       41,     55  },   //43
{   44, "Salt Lake City","Utah",        129,    132 },   //44
{   45, "Santa Fe",     "New Mexico",   175,    204 },   //45
{   46, "Springfield",  "Illinois",     331,    155 },   //46
{   47, "St.Paul",      "Minnesota",    298,    88 },    //47
{   48, "Tallahassee",  "Florida",      401,    266 },   //48
{   49, "Topeka",       "Kansas",       277,    165 },   //49
{   50, "Trenton",      "New Jersey",   475,    129 },   //50
{   51, "Washington",  "Washington, DC",454,    147 }   //51
};

int net_usa[MAX_USA][MAX_USA] = {
//1  2   3    4    5    6    7    8    9   10   11   12   13   14   15   16   17   18   19   20   21   22   23   24   25   26   27   28   29   30   31   32   33   34   35   36   37   38   39   40   41   42   43   44   45   46   47   48   49   50   51
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
0,0,290,840,230,1573,1273,1348,2114, 141,2382, 507,1590, 713, 513, 120,1624,1013, 257, 658, 225,  85,1878,4939, 672,1143,1001,2759, 596,1182,1134, 787, 986, 127, 826,1361,2383,2153,1328, 133, 546, 401,2484,2421,1953,1776, 844, 975,1025,1166, 173, 308,
0,0, 0,568, 503,1346,1016,1337,2065, 366,2298, 281,1499, 425, 356, 389,1517, 916,  53, 456,  92, 276,1858,4855, 518, 893, 843,2845, 539,1075, 920, 726, 716, 417, 598,1180,2372,2004,1280, 330, 256, 110,2399,2392,1870,1627, 704, 949, 738,1028, 129,  27,
0,0, 0,  0,1066, 819, 456,1246,1833, 933,1989, 354,1228, 194, 437, 951,1211, 738, 617, 307, 615, 843,1693,4492, 426, 349, 549,2839, 624, 832, 456, 697, 147, 962, 217, 757,2196,1587,1124, 898, 351, 470,2083,2180,1582,1229, 510, 906, 229, 726, 696, 544,
0,0, 0,  0,   0,1803,1503,1500,2277, 149,2561, 737,1778, 928, 740, 114,1820,1213, 460, 888, 451, 228,2028,5110, 895,1373,1220,2826, 796,1383,1363, 979,1213, 136,1056,1583,2521,2362,1500, 189, 755, 611,2664,2570,2135,1986,1061,1146,1241,1378, 375, 525,
0,0, 0,  0,   0,   0, 394,1154,1366,1693,1385,1073, 846,1013,1065,1693, 769, 814,1399, 915,1364,1601,1358,3746, 925, 470, 653,2590,1092, 729, 441, 996, 690,1678, 750, 357,1767, 865, 983,1662,1166,1266,1461,1700,1071, 601, 801,1046, 802, 615,1465,1319,
0,0, 0,  0,   0,   0,   0,1240,1641,1378,1720, 767,1059, 641, 798,1389,1007, 777,1067, 640,1052,1286,1572,4135, 698, 139, 559,2790, 900, 776, 297, 874, 312,1389, 464, 504,2034,1239,1081,1344, 807, 923,1805,1988,1358, 926, 649,1008, 408, 642,1142, 991,
0,0, 0,  0,   0,   0,   0,   0, 780,1486,1091,1130, 441,1361,1005,1441, 533, 508,1375,1004,1276,1425, 530,3612, 881,1148, 720,1593, 797, 463, 948, 616,1257,1370,1029, 803,1038,1093, 170,1481,1375,1348,1192,1072, 694, 815, 739, 388,1434, 597,1376,1317,
0,0, 0,  0,   0,   0,   0,   0,   0,2254, 359,1823, 604,1991,1714,2213, 636,1155,2109,1668,2017,2188, 288,2833,1564,1608,1295,1277,1536,1015,1415,1343,1790,2145,1630,1139, 401, 735, 789,2246,2051,2056, 446, 349, 296, 773,1388,1139,1964,1107,2123,2042,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,2523, 620,1731, 787, 642,  65,1765,1154, 319, 781, 329,  92,2016,5080, 805,1252,1136,2874, 737,1322,1257, 928,1081, 153, 942,1493,2519,2291,1468,  39, 612, 471,2625,2559,2094,1913, 980,1115,1101,1304, 237, 389,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,2038, 799,2164,1942,2487, 788,1383,2346,1871,2261,2450, 645,2559,1782,1716,1480,1474,1789,1224,1543,1596,1921,2426,1803,1244, 566, 580,1061,2511,2249,2274, 102, 433, 429, 794,1599,1415,2085,1287,2370,2273,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,1241, 305, 133, 624,1252, 668, 334, 175, 291, 527,1634,4589, 259, 636, 568,2689, 363, 816, 641, 516, 491, 622, 322, 899,2149,1725,1050, 589, 248, 236,2138,2158,1611,1348, 439, 748, 569, 756, 393, 254,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1390,1143,1698,  96, 584,1546,1078,1462,1655, 518,3358, 984,1011, 694,1749, 994, 425, 814, 803,1186,1642,1028, 555, 981, 659, 320,1717,1459,1477, 900, 953, 370, 381, 802, 646,1362, 504,1571,1474,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 428, 814,1380, 862, 468, 361, 492, 700,1834,4680, 489, 543, 696,2945, 652, 979, 645, 771, 328, 840, 362, 944,2344,1777,1254, 749, 176, 316,2260,2336,1750,1416, 624, 997, 313, 885, 553, 405,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 633,1161, 561, 404, 158, 329, 554,1516,4499, 166, 661, 497,2558, 230, 719, 624, 390, 557, 612, 334, 850,2031,1659, 933, 617, 380, 344,2043,2045,1514,1281, 350, 620, 663, 676, 440, 331,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1735,1126, 347, 778, 337, 116,1971,5042, 791,1260,1120,2814, 707,1295,1254, 896,1098,  88, 944,1481,2470,2269,1429,  95, 642, 498,2590,2513,2059,1892, 962,1075,1127,1283, 261, 410,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 611,1565,1084,1485,1686, 589,3338, 998, 971, 692,1821,1028, 444, 781, 840,1157,1683,1018, 503,1026, 582, 399,1749,1460,1488, 886, 985, 371, 285, 814, 703,1330, 499,1595,1491,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 963, 517, 878,1075, 974,3942, 408, 666, 222,2102, 418, 169, 480, 238, 751,1076, 521, 473,1487,1152, 392,1138, 900, 901,1484,1491, 953, 781, 239, 237, 927, 208, 987, 892,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 508, 103, 232,1898,4903, 568, 946, 894,2871, 578,1122, 973, 767, 765, 384, 651,1233,2411,2056,1322, 282, 294, 151,2447,2433,1916,1678, 753, 987, 781,1078,  86,  80,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 455, 690,1491,4418, 128, 502, 395,2584, 316, 654, 476, 411, 410, 764, 175, 724,2005,1550, 907, 752, 383, 407,1971,2006,1447,1173, 279, 635, 536, 585, 562, 428,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 236,1802,4820, 496, 924, 827,2767, 482,1041, 930, 674, 761, 349, 613,1176,2314,1989,1229, 298, 333, 191,2363,2339,1831,1610, 679, 890, 801,1005, 110,  96,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1955,5009, 717,1159,1049,2845, 661,1243,1166, 853, 990, 174, 850,1404,2461,2207,1400,  63, 527, 383,2552,2497,2021,1829, 895,1049,1014,1220, 147, 299,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,3093,1377,1515,1147,1232,1319, 860,1314,1131,1672,1899,1481,1072, 515, 904, 584,2012,1873,1861, 735, 542, 403, 815,1213, 911,1851, 975,1903,1836,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,4337,4175,4023,2814,4349,3780,4036,4155,4397,4977,4330,3735,2637,2907,3612,5069,4786,4825,2458,2560,2989,3263,4152,3966,4538,3833,4930,4830,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 559, 332,2458, 208, 559, 484, 282, 510, 763, 250, 689,1892,1493, 792, 781, 496, 493,1883,1899,1355,1114, 185, 508, 652, 510, 606, 493,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 443,2718, 761, 687, 203, 743, 224,1257, 326, 474,1993,1268, 996,1219, 699, 805,1805,1957,1334, 931, 518, 889, 370, 556,1018, 867,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,2309, 450, 286, 266, 344, 538,1086, 336, 365,1651,1162, 583,1113, 768, 802,1578,1640,1059, 784, 160, 448, 716, 192, 937, 817,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,2330,2034,2514,2177,2848,2728,2622,2298, 912,2002,1727,2885,2938,2884,1482,1041,1561,2028,2330,1949,3026,2163,2846,2831,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 587, 662, 193, 717, 659, 458, 814,1833,1566, 747, 722, 610, 557,1891,1856,1360,1191, 292, 409, 852, 586, 586, 519,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 486, 406, 817,1246, 621, 372,1365, 983, 308,1306,1037,1052,1324,1357, 796, 614, 376, 339, 996, 134,1151,1050,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 599, 378,1237, 323, 302,1796,1132, 794,1228, 771, 850,1635,1764,1148, 774, 382, 713, 549, 353,1034, 893,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 757, 842, 495, 683,1646,1390, 554, 915, 764, 733,1698,1665,1167,1019, 225, 231, 916, 431, 780, 705,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1107, 264, 677,2165,1490,1121,1046, 495, 617,2012,2139,1526,1144, 547, 946, 178, 697, 844, 691,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 936,1450,2396,2225,1366, 177, 674, 528,2529,2441,2000,1850, 927,1011,1150,1242, 298, 434,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 602,1987,1438, 908, 911, 458, 527,1900,1975,1388,1068, 295, 694, 422, 523, 715, 571,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1530, 836, 633,1468,1059,1123,1335,1486, 860, 472, 526, 698, 841, 267,1285,1153,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1094,1099,2516,2387,2376, 591, 145, 697,1173,1726,1424,2342,1472,2414,2351,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 978,2271,1896,1955, 632, 983, 501, 378,1312,1280,1634, 987,2099,1977,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1459,1288,1278,1163,1112, 640, 670, 631, 354,1300, 440,1344,1257,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 574, 433,2613,2554,2082,1892, 959,1107,1063,1284, 201, 354,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 145,2347,2390,1827,1526, 663, 995, 489, 961, 380, 240,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,2374,2389,1848,1580, 675, 961, 630, 992, 236,  96,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 449, 531, 878,1699,1518,2175,1386,2472,2374,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 632,1100,1727,1451,2313,1454,2442,2369,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 476,1172, 991,1697, 867,1940,1845,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 933, 929,1301, 609,1721,1600,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 400, 714, 326, 789, 678,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1115, 432, 991, 928,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 876, 866, 718,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,1116,1002,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 152,
0,0, 0,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0
};


//---------------------------------------------------------------
//᫥ - 㧫   (.. - ࠭ த)
void TSP_random::calcMAX_2()  //only if USA_OK
{
	MAX_2 = 0;
    for(int i=1; i<MAX_USA; i++)
	{
		if( active_state[i] )  
            MAX_2++; //quantity of active nodes (i.e. MAX_2)
	}
	if( MAX_2==0 ) MAX_2 = 20;
}


TSP_random::TSP_random()  { m_ReadOK=0; }

//砫쭮 ।    ६
void TSP_random::initTSP(int initMAX_2, int _usa_ok )
{
  USA_OK = _usa_ok;

  if( USA_OK )  {
    useKm = 0;
    for(int i=0; i<MAX_USA; i++) active_state[i] = i;
    MAX_2 = initMAX_2; //calcMAX_2();
  }
  else  {
    MAX_2 = initMAX_2; //8
    ampl = 100;
  }
  if( matrix_alloc() )  FreeMemory();
}

//Reallocate memory
int  TSP::ReAllocate( int new_size )
{
//////////
    HCURSOR ArrowCur;
    HCURSOR WaitCur;

if( !m_ReadOK ) {
    switch( tsp_who )
    {
#ifdef TMIN_DA
      case TMIN_TEMP:
           ArrowCur= ((CInputView3*)parent)->hArrowCur;
           WaitCur = ((CInputView3*)parent)->hWaitCur;
           break;
#endif
#ifdef GRAPH_DA
      case GRAPH_TEMP:
           ArrowCur= ((CGraphView*)parent)->hArrowCur;
           WaitCur = ((CGraphView*)parent)->hWaitCur;
           break;
#endif
#ifdef TSMP_DA
      case RAND_TEMP:
           ArrowCur= ((CInputView*)parent)->hArrowCur;
           WaitCur = ((CInputView*)parent)->hWaitCur;
           break;
#endif
      case USA_TEMP:
           ArrowCur= ((CUSADemo*)parent)->hArrowCur;
           WaitCur = ((CUSADemo*)parent)->hWaitCur;
           break;
    }

      SetClassLong( parent->m_hWnd, GCL_HCURSOR, LONG( WaitCur ));
      SetCursor( WaitCur );
}
else
  WaitCur = SetCursor( LoadCursor( 0, IDC_WAIT) );
//////////
    FreeMemory();         //old MAX_2!

	MAX_2 = new_size;
    int ret=1;
	if( matrix_alloc() )  //new MAX_2!
	{
		FreeMemory();
        ret=0;
	}
//////////
    if( !m_ReadOK ) {
      SetClassLong( parent->m_hWnd, GCL_HCURSOR, LONG( ArrowCur ));
      SetCursor( ArrowCur );
    }
    else
      SetCursor(WaitCur);

//////////
    return ret;
}

// ᯨ᪠ "⨢" த
void TSP_random::READ_USA_DATA(int kmOK)
{
  int i,j, x,y;

  useKm = kmOK;
  for(i=1,x=1; x<=MAX_2, i<MAX_USA; i++)
  {
    if( !active_state[i] )  continue;

    strcpy( capits[x], arr_states[i].capital );
    strcpy( states[x], arr_states[i].usa_state );

    for(j=1,y=1; y<=MAX_2, j<MAX_USA; j++)
    {
      if( !active_state[j] ) continue;

      net[x][y] = (useKm? Round( 1.609344*net_usa[i][j] ) : net_usa[i][j] );
      y++;
    }
    x++;
  }
}

/////////////////////////////////////////////////////////////
//ନ஢ 室  ᥢ砩 ᯮᮡ
//ਬ砭:  㭪 ࠡ⠥   ,  ᫮, 
//⥯ 設  

void TSP_random::Form_Matrix()
{
  int i,j;

  srand( (unsigned)timeGetTime() );

  for(i=0;i<=MAX_2;i++)
    for(j=0;j<=MAX_2;j++) net[i][j]=0;

  Form_Cycle0( 1 );

  for(i=1;i<=MAX_2;i++)
    for(j=i+1; j<=MAX_2; j++)
      if( ampl>0 )
      {
        long a = 2*ampl+1;
        net[i][j] = random(a) - ampl;
        if(ampl>20000)
          net[i][j] = 2*random(ampl)+1 - ampl;
      }
      else
        net[i][j] = random(2);

  return;
}

/////////////////////////////////////////////////////////////
//:  ॡ (x,y)  稭 d
//    ,  ஬ ⮣
//뢠 ⠡ ⥩ (  - ⮢)

void TSP::recalc_kotC(int x, int y, int d, int with_netnew)
{
  int i,j;

  if(with_netnew) netnew[x][y]  -= d;
  else            netMAIN[x][y] -= d;

  for(i=1; i<=MAX_2; i++)
    if(x!=i && y!=i) kotC[x][y][i] -= d;

  for(i=1; i<MAX_2; i++)
    for(j=i+1; j<=MAX_2; j++)
    {
      if(i==y || j==y)  kotC[i][j][x] += d;
      if(i==x || j==x)  kotC[i][j][y] += d;
    }
}

//TSP:  ॡ (x,y)  稭 d
//    ,  ஬ ⮣
//뢠 ⠡ ⥩ ( TSP - 楫.)

void TSP::recalc_kotI(int x, int y, int d, int with_netnew)
{
  int i,j;

  if(with_netnew) netnew[x][y]  -= d;
  else            netMAIN[x][y] -= d;

  for(i=1; i<=MAX_2; i++)
    if(x!=i && y!=i)  kotI[x][y][i] -= d;

  for(i=1; i<MAX_2; i++)
    for(j=i+1; j<=MAX_2; j++)
    {
      if(i==y || j==y)  kotI[i][j][x] += d;
      if(i==x || j==x)  kotI[i][j][y] += d;
    }
}

/////////////////////////////////////////////////////////////
//᫥ 2- ᨬ㬮 ( 1- ᫨ maxGZ_OK=1)  nS-.
//   ᨢ maxC1  maxC2 (. g_lib.h)

void TSP::max12(int nS, int maxGZ_OK)
{
    int i,j;

    maxC1[2]=maxC2[2]=INT_MIN;

if( tsp_who==GRAPH_TEMP )  {
    for(i=1; i<MAX_2; i++)  {
      if( i==nS )   continue;
      for(j=i+1; j<=MAX_2; j++)
        if( kotC[i][j][nS]>maxC1[2] && nS!=j )  {
           maxC1[0]=i;
           maxC1[1]=j;
           maxC1[2]=kotC[i][j][nS];
        }
  	}

    if( maxGZ_OK )  { maxGZ(nS); return; }  //for time SAVING

    for(i=1; i<MAX_2; i++)  {
      if( i==nS )   continue;
      for(j=i+1; j<=MAX_2; j++)  {
        if( kotC[i][j][nS]>maxC2[2] && nS!=j )  {
          if( i==maxC1[0] && j==maxC1[1])   continue;
          maxC2[0]=i;
          maxC2[1]=j;
          maxC2[2]=kotC[i][j][nS];
        }
      }
	}
}
else  {
    for(i=1; i<MAX_2; i++)  {
      if( i==nS )   continue;
      for(j=i+1; j<=MAX_2; j++)
        if( kotI[i][j][nS]>maxC1[2] && nS!=j )  {
           maxC1[0]=i;
           maxC1[1]=j;
           maxC1[2]=kotI[i][j][nS];
        }
  	}

    if( maxGZ_OK )  { maxGZ(nS); return; }  //for time SAVING

    for(i=1; i<MAX_2; i++)  {
      if( i==nS )   continue;
      for(j=i+1; j<=MAX_2; j++)  {
        if( kotI[i][j][nS]>maxC2[2] && nS!=j )  {
          if( i==maxC1[0] && j==maxC1[1])   continue;
          maxC2[0]=i;
          maxC2[1]=j;
          maxC2[2]=kotI[i][j][nS];
        }
      }
	}
}

}

//। ᨬ쭮 ॡ  横  nS-
//   maxC2 (. g_lib.h)
int TSP::maxGZ( int nS )
{
  int s,i,j;

  maxC2[2] = INT_MIN;

  for(s=0; s<MAX_2; s++)
  {
//  get_jk( s, &i,&j);
    if( s==0 ) {
      i=min(GZ[1],GZ[MAX_2]);
      j=max(GZ[1],GZ[MAX_2]);
    }
    else {
      i=min(GZ[s],GZ[s+1]);
      j=max(GZ[s],GZ[s+1]);
    }

    if(nS==i || nS==j )  continue;

    if( tsp_who==GRAPH_TEMP ) {
      if(kotC[i][j][nS]>maxC2[2])  {
        maxC2[0]=i;
        maxC2[1]=j;
        maxC2[2]=kotC[i][j][nS];
      }
    }
    else  {
      if(kotI[i][j][nS]>maxC2[2])  {
        maxC2[0]=i;
        maxC2[1]=j;
        maxC2[2]=kotI[i][j][nS];
      }
    }
  }

  return maxC2[2];
}

//। ᮢ 饣 ॡ  - 㧫, 筥
//㧫, 饣  -⮬  横
//頥 祭  ॡ  ⠡ ⥩
// -> otl1, otl2
int TSP::getCKL(int k)
{
  //k - the subnet's number
  int i = (k!=1? GZ[k-1]: GZ[MAX_2]);
  int j = (k!=MAX_2? GZ[k+1]: GZ[1]);

  otl1 = min(i,j);
  otl2 = max(i,j);

  int ret;
  if( tsp_who==GRAPH_TEMP )  ret = kotC[ otl1 ][ otl2 ][ GZ[k] ];
  else                       ret = kotI[ otl1 ][ otl2 ][ GZ[k] ];

  return ret;
}

//। ᮢ 饣 ॡ  - 㧫
int TSP::getCKL2(int nS)
{
  for(int i=1;i<=MAX_2;i++)
    if(GZ[i]==nS)
      return getCKL(i);

  return 0;
}


//The function adds the current changes to the matrix that
//stores the total changes and then cleares "netnew"
void TSP::delC_dbl_zero()
{
  for(int i=1; i<MAX_2; i++)
    for(int j=i+1; j<=MAX_2; j++)
    {
      netMAIN[i][j] += netnew[i][j];
      netnew[i][j]=0;
    }
}


//  Algorithm "Equality"
//  --------------------
//  By means of algorithm "Equality" the initial net is represented
//  by a family of N subnets (GN-(i), i=1..N), each having the
//  weights of the edges incident to one of the nodes equal between
//  themselves and equal to zero (C'ij=0, j=1..N, i!=j).

void TSP::DO_EQUALITY(void)
{
  int i,j,k;

  for(k=1; k<=MAX_2; k++)
  {
    Equality( k );

    for(i=1; i<MAX_2; i++)
      for(j=i+1; j<=MAX_2; j++)
        if( tsp_who==GRAPH_TEMP )  kotC[i][j][k]=(char)netnew[i][j];
        else                       kotI[i][j][k]=netnew[i][j];
  }
}

//ᯮ⥫  ⬠ 
void TSP::Equality(int i1)
{
  int f,h;

  for(f=1; f<MAX_2; f++)       //make a copy of the net
    for(h=f+1; h<=MAX_2; h++)
      netnew[f][h] = net[f][h];

  for(f=i1+1; f<i1+MAX_2; f++)
    for(h=1; h<=MAX_2; h++)
    {
      int i=f;
      if(f>MAX_2)  i-=MAX_2;
      int j=h;
      int _i1=i1, _i=i;

      if(i!=j && _i1!=_i)
      {
        if(_i>_i1)  {  int z=_i;  _i=_i1;  _i1=z;  }
        if (i> j)   {  int z= i;   i= j;    j =z;  }

        netnew[i][j] -= net[_i][_i1];
      }
    }
}

// The function moveNODE places node nS between nodes mC20 and mC21
void TSP::moveNODE(int nS, int mC20, int mC21)
{
  int j, cnt_sav=0, cnt=1, gz3[MAX_1+1];

  for(j=1; j<=MAX_2; j++)
  {
    if(cnt==MAX_2+1)  {  gz3[j]=GZ[cnt_sav];  break;  }

    if(GZ[cnt]==nS)
    {
      cnt_sav=cnt;
      cnt++;
    }
    gz3[j] = GZ[cnt];

    if     (GZ[cnt]==mC21 && GZ[cnt-1]==mC20) {  gz3[j]=nS;  gz3[++j]=mC21; }
    else if(GZ[cnt]==mC20 && GZ[cnt-1]==mC21) {  gz3[j]=nS;  gz3[++j]=mC20; }

    cnt++;
  }

  for(j=1; j<=MAX_2; j++)  GZ[j]=gz3[j];
  do_forma1(); //???
}


//do_forma1 transforms each cycle into the form: 1-x-...-y, where x<y

void TSP::do_forma1()
{
  int i,k,gz[MAX_1+1];

  for(k=1; k<=MAX_2; k++)
    if(GZ[k]==1)
      break;

  for(i=1; i<=MAX_2; i++)
    if(i+k-1<=MAX_2)
      gz[i] = GZ[i+k-1];
    else
      gz[i] = GZ[i+k-1-MAX_2];

  GZ[1]=1;

  for(k=2; k<=MAX_2; k++)
    if(gz[2]<gz[MAX_2])  GZ[k]=gz[k];
    else                 GZ[k]=gz[MAX_2+2-k];
}

////////////////////////////////////////////////
// ⮡ 横  ᨢ GZ 稭  i- 㧫
//(筮 横 稭  1, ଥ ᫨ 横 ᠭ
// ᨢ GZ  1- : 1-3-5-2-4-1,  ᫥ do_forma2(5)
//  ᠭ          5-2-4-1-3-5
void TSP::do_forma2(int i)
{
  int d, i2;

  for(d=1;  d<=MAX_2; d++)
    if(GZ[d]==i)
      break; //remember d

  for(i2=1; i2<=MAX_2; i2++)
    if(i2+d-1<=MAX_2)  GZ2[i2] = GZ[i2+d-1];
    else               GZ2[i2] = GZ[i2+d-1-MAX_2];

  GZ[1]=i;

  for(d=2; d<=MAX_2; d++)   GZ[d]=GZ2[d];
}

//  横 ( ந⥫⢥ 2) ।⢮ ࠧ뢠
//2 ॡ. ਬ: 1-2-3-4-5-1, ࠧ뢠 1-5  3-4
//         - : 1-2-3-5-4-1
// ⨣ ᪮: make_cycle(3,5)  make_cycle(1,4)

void TSP::make_cycle(int i, int x)
{
  int d=1, i2=MAX_2;

  do_forma2(i);
  while( GZ2[d]!=x )
  {
    GZ[d]=GZ2[d];
    d++;
  }

  while(d<=MAX_2)
  {
    GZ[d]=GZ2[i2];
    d++;
    i2--;
  }
  do_forma1();
}

#ifdef DEBUG
//뢮 ⠡ ⥩   txt
void TSP::PRINT(char *txt)
{
  if(MAX_2>20) return;

  msg( txt );

  for(int i=1; i<MAX_2; i++)
    for(int j=i+1; j<=MAX_2; j++)
    {
      msg("\r\nC");

      if(isGZ(i,j)) msg("^");
      else          msg(" ");

      msg("%2d,%2d,", i,j);

      for(int k=1; k<=MAX_2; k++)
      {
        getCKL2(k);

        if(i==k || j==k)  msg("     ");
        else   {
          if( tsp_who==GRAPH_TEMP )  msg("%5d",kotC[i][j][k]);
          else                       msg("%5d",kotI[i][j][k]);
        }

        if(i==otl1 && j==otl2)  msg(".");
        else                    msg(" ");
      }
    }
}

//Print the following matrices:
//mode = 0: the matrix of current changes,
//mode = 1: the matrix of current values,
//mode = 2: the initial matrix,
//mode = 3: the matrix of total changes, excluding PreTrans changes,
//mode = 4: the matrix of total changes,

void TSP::printMTX(int mode)
{
  int i,j,d;

  if(MAX_2>30) return;

  switch( mode ) {
    case 0: mes2("\r\nnetnew");     break;
    case 1: mes2("\r\nnetnew+net"); break;
    case 2: mes2("\r\nnet");        break;
    case 3: mes2("\r\nnetMAIN");    break;
    case 5: mes2("\r\nnetDC");      break;
    case 6: mes2("\r\nnetX");       break;
    case 7: mes2("\r\nnetY");       break;
  }

  mes2("\r\n");  for(i=1; i<=MAX_2; i++)   mes2("%4d ", i);

  mes2("\r\n");
  for(i=1; i<=MAX_2;  i++)
  {
    for(j=1; j<=MAX_2; j++)
    {
      d=netnew[i][j];    //current changes
      switch( mode )
      {
        case 1: d+=net[i][j];      break;
        case 2: d =net[i][j];      break;
        case 3: d =netMAIN[i][j];  break;
        case 5: d =netDC[i][j];    break;
        case 6: d =netx[i][j];     break;
        case 7: d =nety[i][j];     break;
      }
      mes2("%4d,",d);
    }
    mes2(" //%2d\r\n", i);
  }
  mes2("\r\n");
}

//뢮 ᯨ᪠ ஥ 横
void TSP::Print_List2()
{
  int i,j, gz_print_list[MAX_1+1];

  if(MAX_2>30) return;

  for(j=0; j<=MAX_2; j++)   gz_print_list[j] = GZ[j];

  for(i=0; i<MAX_LIST; i++)
  {
    if( listGZ2[i][1]==0 )  break;

    for(j=0; j<=MAX_2; j++)  GZ[j] = listGZ2[i][j];
    printGZ2(".");
    msg("  :");
    for(j=0; j<7; j++) msg("-%d", listu2[i][j]);
  }
  for(j=0; j<=MAX_2; j++)  GZ[j]=gz_print_list[j];
}

#endif

//⮤   (  - ⥪ ⬮)
int TSP::lookALL(int onlyTIME, int* res)
{
  int  i,n,j,k,ii, gz[MAX_1+1], kk, minG, cnt=0;

  working = 1;

  if( res )  *res = 0;

  if( maxCycle==TRUE )  invert_net(/*1*/);

  for(i=1;i<MAX_2;i++)
    for(j=i+1; j<=MAX_2; j++)  net[j][i]=net[i][j];

  for(i=0;i<MAX_2;i++) GZmin[i+1] = gz[i]=i+1;  //make a list of cycles

  minG/*kk*/=0;
  for(ii=0;ii<MAX_2;ii++)
  {
    if(ii<MAX_2-1) { j=gz[ii]; k=gz[ii+1]; }
    else           { j=gz[0];  k=gz[MAX_2-1]; }
    minG += net[j][k];
  }

  for(;;)
  {
//R1:
    for(i=MAX_2-2; i>=0; --i)
      if(gz[i]<gz[i+1])
        goto R;

    goto FINAL;

R:  n=gz[i];
    j=MAX_2-1;
    while(n >= gz[j] && j>i)
      j--;
    gz[i]=gz[j];
    gz[j]=n;

    for(k=1;i+k<MAX_2-k;k++)
    {
      n=gz[i+k];
      gz[i+k]=gz[MAX_2-k];
      gz[MAX_2-k]=n;
    }

	cnt++;
    if(onlyTIME && cnt>20000L) //for time determination
      goto FINAL;

    if( !onlyTIME && cnt==20000L )
    {
       cnt = 0;
       if( was_stop( parent->m_hWnd, 1) )
       {
           if( res )
               *res = 1;
           goto FINAL;
       }
    }

    if(gz[0]>1)
      goto FINAL;

    kk=0;
    for(ii=0;ii<MAX_2-1;ii++)
      kk += net[ gz[ii] ][ gz[ii+1] ];

    kk += net[ gz[0] ][ gz[MAX_2-1] ];

    if(kk<minG)
    {
      minG=kk;
	  if( !onlyTIME )
	  {
        GZ[0]=GZmin[0]=0;
        for(int cc=0;cc<MAX_2;cc++)  GZ[cc+1]=GZmin[cc+1]=gz[cc];
//////////////
        sumGZ = minG;
        show_min();
//////////////
      }
    }
  }

FINAL: ;

  if( maxCycle==TRUE )  {
    invert_net(/*0*/);
    sumGZ *= -1;
    minG *= -1;
  }

  for(i=1;i<MAX_2;i++)  //????
    for(j=i+1; j<=MAX_2; j++)  net[j][i] = 0;

  working = 0;

  return (onlyTIME? cnt: minG);
}

//ਠ ⮤    थ ६
//ࠡ ⮣ ⮤.

int TSP::lookALL_2(int onlyTIME, int* res)
{
  int  i,n,j,k,ii, gz[MAX_1+1], minG, cnt=0;

  working = 1;

  if(res)  *res = 0;

  for(i=1;i<MAX_2;i++)
    for(j=i+1; j<=MAX_2; j++)  net[j][i]=net[i][j];

  for(i=0;i<MAX_2;i++)  gz[i]=GZmin[i+1]=i+1;  //make a list of cycles

  minG=1/*0*/;
  for(ii=0;ii<MAX_2;ii++)  {
    if(ii<MAX_2-1) { j=gz[ii]; k=gz[ii+1];    }
    else           { j=gz[0];  k=gz[MAX_2-1]; }

    if( net[j][k] )  break;
    else             minG = 0;
  }

  for(;;)  {
R1:
    for(i=MAX_2-2; i>=0; --i)
      if(gz[i]<gz[i+1])  goto R;

    goto FINAL;

R:  n=gz[i];
    j=MAX_2-1;
    while(n >= gz[j] && j>i)  j--;
    gz[i]=gz[j];
    gz[j]=n;

    for(k=1;i+k<MAX_2-k;k++) {
      n=gz[i+k];
      gz[i+k]=gz[MAX_2-k];
      gz[MAX_2-k]=n;
    }

    cnt++;  if(onlyTIME && cnt>20000)  goto FINAL; //time determination

    if( !onlyTIME && cnt==20000 )  {
       cnt = 0;
       if( was_stop( parent->m_hWnd, 1) )
       {
           if( res )  *res = 1;
           goto FINAL;
       }
    }

    if(gz[0]>1)
      goto FINAL;

    for(ii=0;ii<MAX_2-1;ii++)
      if( net[ gz[ii] ][ gz[ii+1] ] )  goto R1;

    if( !net[ gz[0] ][ gz[MAX_2-1] ] )  {
      minG=0;
      if( !onlyTIME ) {
        GZ[0]=GZmin[0]=0;
        for(int cc=0;cc<MAX_2;cc++)  GZ[cc+1]=GZmin[cc+1]=gz[cc];
	  }
      goto FINAL;
    }
  }

FINAL: ;
  for(i=1;i<MAX_2;i++)
    for(j=i+1; j<=MAX_2; j++)  net[j][i] = 0;

  working = 0;

  return (onlyTIME? cnt: minG);
}

//஢ , ᯮ  ᪥ . 横
void TSP::invert_net( /*int firstOK*/ )
{
  int i,k;
  for(k=1; k<=MAX_2; k++)
    for(i=1; i<=MAX_2; i++)  net[i][k] *= -1;
}

// ⥪饣  横  saveGZmin 
//ࠢ ⥪饣  横  saveGZmin
int TSP::save_min_cycle( int compareOK )
{
    for(int i=1; i<=MAX_2; i++)
    {
      if( compareOK )
      {
        if( saveGZmin[i] != GZmin[i] )
        {
          //in this case compare both lengths
          int sum1 = cycle_length( GZmin );
          int sum2 = cycle_length( saveGZmin );
          if( sum1==sum2 )
            return 1;
          return 0;
        }
      }
      else
        saveGZmin[i] = GZmin[i];
    }
    return 1;
}

//ନ஢ 砫쭮 横
//initOK=0: 砫->⥪騩
//randStart=0:  砫 = 1-2-3-4-5-...-1
//randStart=1:  砫 横  ᥢ砩

void TSP::Form_Cycle0( int initOK, int randStart )
{
  int i;

  if( !initOK )
  {
    for(i=0; i<=MAX_2+1; i++)  //return initial cycle
      GZ[i]=initGZ[i];
    return;
  }

  //initOK
  for(i=0; i<=MAX_2; i++)
    GZ[i]=i;
  GZ[MAX_2+1]=1;

  if( randStart )
  {
    int j,k, val, cnt = MAX_2-1;
	srand( (unsigned)timeGetTime() );
	for(i=2; i<=MAX_2; i++)
	{
        val = random( cnt )+2;  //+2 :to avoid ZERO & 1

        j=1;
		for(k=2; k<=MAX_2; k++)
		{
            if( GZ[k] ) j++;
			if( j == val) break;
		}
        initGZ[i] = GZ[ k ];
        GZ[ k ]=0;
        cnt--;
	}

    for(i=0; i<=MAX_2+1; i++)  //Form_Cycle0( 0/*gz=initgz*/ );
      GZ[i]=initGZ[i];
    do_forma1();  //now GZ is OK
  }

  for(i=0; i<=MAX_2+1; i++)  //save initial cycle
    initGZ[i] = GZ[i];
}

//।  横 cycle
int TSP::cycle_length( int* cycle )
{
  int sum=0, i,j,k, gz_tmp[MAX_1];

  for(i=1;i<=MAX_2;i++)
  {
     gz_tmp[i] = GZ[i];
     GZ[i] = cycle[i];
  }

  for(i=1;i<=MAX_2;i++)
  {
    get_jk( i, &j,&k);
    sum += net[j][k];

    if( tsp_who==GRAPH_TEMP && net[j][i]==VZVE)  sum-=(VZVE-1);
//  if( tsp_who==GRAPH_TEMP && net[j][i]==3)  sum-=2;
  }

  for(i=1;i<=MAX_2;i++)   GZ[i] = gz_tmp[i];

  return sum;
}

//ࠢ 2 横: GZ  saveGZmin
int TSP::compare_cycs(int** net0)
{
    int i,j,k,z,x,y,edges_replaced=0;

    for(i=1; i<=MAX_2; i++)
    {
        get_jk( i, &j,&k);  //get edge of new minGZ

        int found=0;

        for(z=1; z<=MAX_2; z++)
        {
          x = saveGZmin[z];     //get edge of old minGZ
          if(z==MAX_2)  y = saveGZmin[1];
          else          y = saveGZmin[z+1];

          if( j==min(x,y) && k==max(x,y) )
            found=1;
          else if( net[j][k]==net0[j][k] )
            found=1;
        }

        if( !found )         //i-th edge of old cycle does not
          edges_replaced++;  //belong to a new one
    }

    return  edges_replaced;
}

///////////////////////////////////////////////////////////
TSP::TSP()  {
  parent = NULL;
  timeF  = NULL;
  cycleF = NULL;
  maxCycle  = cycleExist = FALSE;
  mem_status=0;

  SUM000 = sum000 = INT_MIN;
  flag000 = 0;

  in_contin = 0;
}

TSP::~TSP() {}

void TSP::FreeMemory()
{
  int i, dim = MAX_2+1;

  if( mem_status==0 )  return;

  if( tsp_who==GRAPH_TEMP )  do_deleteG(kotC, dim);
  else                       do_delete( kotI, dim);

  do_delete2( netMAIN, dim);
  do_delete2( netnew, dim);
  do_delete2( net, dim);

#ifdef WITH_LIST
  for(i=0; i<MAX_LIST; i++)  {
    if(listGZ2[i])  free(listGZ2[i]);
    listGZ2[i]=NULL;
  } if(listGZ2)  free(listGZ2);
#endif

  for(i=0; i<MAX_LIST; i++)  {
    if(listu2[i]) free(listu2[i]);
    listu2[i]=NULL;
  }
  if(listu2) free(listu2);

  do_delete2( netDC, dim);

/////////////
  do_delete2( netx, dim);
  do_delete2( nety, dim);
/////////////

  mem_status = 0;
}

int TSP::matrix_alloc()
{
  int k, dim = MAX_2+1;

  mem_status = 0;

  if( tsp_who==GRAPH_TEMP )  {
    kotC = (char***)calloc( dim, sizeof(char**));
    if( !do_allocG( kotC, dim) )   return 1;
  }
  else  {
    kotI = (int***)calloc( dim, sizeof(int**));
    if( !do_alloc( kotI, dim) )   return 1;
  }

  if(( netMAIN=(int**)calloc( dim, sizeof(int*)))==NULL)  return 1;
  if( !do_alloc2(netMAIN, dim) )  return 1;

  if(( netnew =(int**)calloc( dim, sizeof(int*)))==NULL)  return 1;
  if( !do_alloc2(netnew, dim) )   return 1;

  if(( net =(int**)calloc( dim, sizeof(int*)))==NULL)   return 1;
  if( !do_alloc2(net, dim) )  return 1;

#ifdef WITH_LIST
  if(( listGZ2 =(int**)calloc(MAX_LIST,sizeof(int*)))==NULL)  return 1;
  for(k=0; k<MAX_LIST; k++)
    if((listGZ2[k]=(int*)calloc( dim, sizeof(int)) )==NULL)  return 1;
#endif

  if(( listu2  =(int**)calloc(MAX_LIST,sizeof(int*)))==NULL) return 1;
  for(k=0; k<MAX_LIST; k++)
    if((listu2[k]=(int*)calloc( (UZ_DIM+1), sizeof(int)) )==NULL)   return 1;

  if(( netDC  =(int**)calloc( dim, sizeof(int*)))==NULL)  return 1;
  if( !do_alloc2(netDC, dim) )  return 1;

//////////////////
  if(( netx=(int**)calloc( dim, sizeof(int*)))==NULL)   return 1;
  if( !do_alloc2(netx, dim) )  return 1;
  if(( nety=(int**)calloc( dim, sizeof(int*)))==NULL)   return 1;
  if( !do_alloc2(nety, dim) )  return 1;
//////////////////

  mem_status = 1;

  in_contin = 0;

  return 0;
}

////////////////////////////////////////////////////////////
//Print the current cycle (GZ), return the length of GZ
//頥 ᮫  横 GZ, ࠬ ret_s2
//ᢠ 祭 ⭮⥫쭮  GZ

int TSP::printGZ2(char* txt, int *ret_s2)
{
  int sum=0, sum_2=0, i,j,k;

#ifdef DEBUG
  int q_iz=0, s_iz=0;
  if( txt )  msg("\r\n%s", txt);
#endif

  GZ[MAX_2+1]=1;

  for(i=1;i<=MAX_2;i++)
  {
    j = min(GZ[i],GZ[i+1]);
    k = max(GZ[i],GZ[i+1]);

    sum += net[j][k];
    if( netMAIN[j][k]<0 )
      sum += netMAIN[j][k]; //!!!???

    sum_2 += net[j][k];
    if(tsp_who==GRAPH_TEMP && net[j][k]==VZVE) sum_2-=(VZVE-1);

#ifdef DEBUG
    if( get_izm(j,k)<0 ) {
      q_iz++;
      s_iz += get_izm(j,k);
    }
#endif
  }

#ifdef DEBUG
  if( MAX_2<=30 || sum_2<sumGZ )  {
    for(i=1;i<=MAX_2;i++)
      if( txt!=NULL /*&& i<15*/)  msg("-%d",GZ[i]);
    if( txt )  msg(" {%d,%d}, changes=%d, sum=%d", sum,sum_2, q_iz, s_iz);
  }
#endif

  if( ret_s2 )  *ret_s2 = sum;
  return sum_2;
}

//᫥   GZ
int TSP::printGZ(char* txt)
{
  int sum=0, i,j,k;

  GZ[MAX_2+1]=1;

  for(i=1;i<=MAX_2;i++)
  {
    j = min(GZ[i],GZ[i+1]);
    k = max(GZ[i],GZ[i+1]);

    sum += net[j][k];
    if(tsp_who==GRAPH_TEMP && net[j][k]==VZVE) sum-=(VZVE-1);
  }
#ifdef DEBUG
  if( txt )  msg("\r\n%s", txt);
  if( MAX_2<=30 || sum<sumGZ )  {
    for(i=1;i<=MAX_2;i++)  if( txt!=NULL /*&& i<15*/)  msg("-%d",GZ[i]);
    if( txt )  msg(" {%d}", sum);
  }
#endif
  return sum;
}

////////////////////////////////////
//離 ⬮    ( .)
void TSP::do_equal_pp()
{
  int i,j,k,d;

  for(i=0; i<=MAX_2; i++)
    for(j=0; j<=MAX_2; j++)
    {
      netnew[i][j] = netMAIN[i][j] = 0;
      for(k=0; k<=MAX_2; k++)
        if( tsp_who==GRAPH_TEMP )  kotC[i][j][k] = 0;
        else                       kotI[i][j][k] = 0;
    }

//////////////////////////////
  DO_EQUALITY();

  for(i=0; i<=MAX_2; i++)
    for(j=0; j<=MAX_2; j++)   netnew[i][j] = 0;

//////////////////////////////
  PreTransAll();

  for(k=0; k<=MAX_2; k++)
    for(i=0; i<=MAX_2; i++) {
      netMAIN[i][k]=netnew[i][k];
      netnew[i][k]=0;
    }

//----------------------------------------------------------
  sumGZ = printGZ("Z");
  for(d=1;d<=MAX_2;d++)  GZmin[d]=GZ[d];
  PRINT("\r\n000\r\n");
}

//  Algorithm "Preliminary Transformation"
void TSP::PreTransAll()
{
  int cnt=0, k=0, d, i,j, x,y, max1, max2;

  while(cnt!=MAX_2)
  {
    k++;

    if(k==MAX_2+1)  {
      if( was_stop( parent->m_hWnd ) ) {  WAS_STOP=1; return; }
      k=1;
    }

////max12(k);//////////////////////////
    max1=max2=INT_MIN;

    if( tsp_who==GRAPH_TEMP )  {
      for(i=1; i<MAX_2; i++)  {
        if( i==k )   continue;
        for(j=i+1; j<=MAX_2; j++) {
          if( j==k )  continue;
          if( kotC[i][j][k]>max1 ) {  x=i;  y=j;  max1=kotC[i][j][k]; }
        }
      }
      for(i=1; i<MAX_2; i++)  {
        if( i==k )   continue;
        for(j=i+1; j<=MAX_2; j++)  {
          if( j==k )  continue;
          if( kotC[i][j][k]>max2 )  {
            if( i==x && j==y)   continue;
            max2=kotC[i][j][k];
          }
        }
      }
    }
    else  {
      for(i=1; i<MAX_2; i++)  {
        if( i==k )   continue;
        for(j=i+1; j<=MAX_2; j++) {
          if( j==k )  continue;
          if( kotI[i][j][k]>max1 ) {  x=i;  y=j;  max1=kotI[i][j][k]; }
        }
      }
      for(i=1; i<MAX_2; i++)  {
        if( i==k )   continue;
        for(j=i+1; j<=MAX_2; j++)  {
          if( j==k )  continue;
          if( kotI[i][j][k]>max2 )  {
            if( i==x && j==y)   continue;
            max2=kotI[i][j][k];
          }
        }
      }
    }
//////////////////////////
    if( (d=max1-max2)<=0 )
    {
      if(d==0) cnt++;
      continue;
    }
    cnt=0;

    if( tsp_who==GRAPH_TEMP )  recalc_kotC( x, y, d, 1);
    else                       recalc_kotI( x, y, d, 1);

msg("\r\nPP(%d): C(%d,%d) on %d", k,x,y,d);
  }
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++
int TSP::compare_mins()
{
   for(int i=1; i<=MAX_2; i++)
     if( GZmin[i] != gz000[i] ) return 1;

   return 0;
}


