#include "stdafx.h"

#include <mmsystem.h>
#include "mainfrm.h"
#include "g_lib.h"
#include "tsmp_doc.h"
#include "usadlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern int resol;
int was_error2;
int  rx0=0,ry0=0;
static int r_height2=0, r_width2=0, DLTX_USA=0, DLTY_USA=0;
extern BOOL only1set;

void msg_cycle( char *txt, int* gz, int MAX_2);
//////////////////////////////////////////////////////////////
IMPLEMENT_DYNCREATE(CUSADemo, CFormView)

CUSADemo::CUSADemo() : CFormView(resol==1? IDD_USA_DEMO2: IDD_USA_DEMO)
{
    //{{AFX_DATA_INIT(CUSADemo)
	m_bUseKm = FALSE;
    m_randStarts = _T("");
    m_randStarts2= _T("");
    in_comparing = 0;
    hArrowCur = LoadCursor(0, IDC_ARROW);
    hWaitCur  = LoadCursor(0, IDC_WAIT);
	//}}AFX_DATA_INIT
}

//////////////////////////////////////////////////////////////////
void CUSADemo::OnInitialUpdate()
{
    CMainDoc* pD = GetDocument();

    pD->tsp.tsp_who = USA_TEMP;
    pD->tsp.parent = this;
    pD->misc_init( USA_TEMP, 51 );

    m_MapWnd.LoadMapImage( &(pD->tsp) );

    CMDIChildWnd *w = (CMDIChildWnd *)GetParentFrame();

CFormView::OnInitialUpdate();

    if(resol!=1)  {
      if( !r_width2 )  {
        RECT r;  w->GetWindowRect(&r);
        if( !rx0 )  { rx0 = r.left;   ry0 = r.top; }
        else {
          DLTX_USA = r.left-rx0;
          DLTY_USA = r.top-ry0;
        }
        RandStr().GetWindowRect(&r);
        RECT r3;  m_lbCapList.GetWindowRect(&r3);

        r_width2 = r.right+50-DLTX_USA;
        r_height2= r3.bottom-DLTY_USA-20;
      }
      w->SetWindowPos( NULL, 0,0, r_width2, r_height2, SWP_DRAWFRAME|SWP_NOMOVE);
    }
    else  w->ShowWindow(SW_SHOWMAXIMIZED);

    if( pD->m_ReadOK==FALSE /*|| pD->m_already*/ )  //???
      FormList();
    else {
      FormResultList();  //only after FormC0
	  char buf[20];
      NodeStr().SetWindowText( itoa(pD->tsp.MAX_2, buf, 10) );
      ShowCycleLength();
      if( pD->m_already )
        pD->ShowTime2( &FullTimeStr() );
      Invalidate( TRUE );
    }
    m_lbCapList.SetCurSel(0);
}


void CUSADemo::OnUpdate(CView*, LPARAM, CObject*)
{
    CMainDoc* pD = GetDocument();
    m_randStarts = pD->m_randStarts;
    m_randStarts2 = pD->m_randStarts2;
    UpdateData(FALSE);  // set the data into the controls
}

void CUSADemo::DoDataExchange(CDataExchange* pDX)
{
    CFormView::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CUSADemo)
    DDX_Control(pDX, IDC_USA_MAP, m_MapWnd );
    DDX_Control(pDX, IDC_STATES_LIST, m_lbCapList );
    DDX_Text(pDX, IDC_RAND_STARTS, m_randStarts);
    DDX_Text(pDX, IDC_RAND_STARTS2, m_randStarts2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSADemo, CFormView)
    //{{AFX_MSG_MAP(CUSADemo)
    ON_EN_KILLFOCUS(IDC_RAND_STARTS, OnDataChange)
    ON_EN_KILLFOCUS(IDC_RAND_STARTS2, OnDataChange)
	ON_BN_CLICKED(IDC_MAP_OPTIONS, OnMapOptions)
	ON_BN_CLICKED(IDC_GO, OnGo)
    ON_BN_CLICKED(IDC_SHOW_MATRIX, OnShowMatrix)
	ON_BN_CLICKED(IDC_RESET_SET, OnResetList)
	ON_BN_CLICKED(IDC_SET_OK, OnSetList)
	ON_BN_CLICKED(IDC_GET_FULL_TIME, OnGetFullTime)
	ON_BN_CLICKED(IDC_TRIANGLE, OnTriangle)
	ON_BN_CLICKED(IDC_COMMON_METHOD, OnCommonMethod)
	ON_BN_CLICKED(IDC_TEST_BOTH, OnTestBoth)
	ON_BN_CLICKED(IDC_RAND_CYCLE0, OnRandCycle0)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CUSADemo::OnDataChange()
{
    if (!UpdateData())  return;

    CMainDoc* pD = GetDocument();
///////////////////
    if( pD->tsp.working ) {
      m_randStarts2 = pD->m_randStarts2;
      m_randStarts  = pD->m_randStarts;
      UpdateData(FALSE);
      return;
    }
///////////////////

    if (m_randStarts != pD->m_randStarts)
	{
        int tmp = atoi(m_randStarts);
        if( tmp<1 || tmp>SHRT_MAX )
        {
            m_randStarts = pD->m_randStarts;
            UpdateData(FALSE);
            return;
        }
        pD->m_randStarts = m_randStarts;
        m_randStarts2 = m_randStarts;
pD->m_already=0;
        UpdateData(FALSE);
	}

    if (m_randStarts2 != pD->m_randStarts2)
	{
        int tmp2= atoi(m_randStarts2);
        if( tmp2<0/*1*/ || tmp2>atoi(m_randStarts) )  {
            m_randStarts2 = pD->m_randStarts2;
            UpdateData(FALSE);
            return;
        }
        pD->m_randStarts2 = m_randStarts2;
pD->m_already=0;
        UpdateData(FALSE);
	}
}

void CUSADemo::OnMapOptions()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    CMapOptDlg dlg;
    dlg.m_bShowMiles= m_MapWnd.m_bShowMiles;
    dlg.m_maxCycle  = pD->tsp.maxCycle;
	BOOL oldUseKm = dlg.m_bUseKm = m_bUseKm;

    if( dlg.DoModal() != IDOK )  return;

    m_MapWnd.m_bShowMiles = dlg.m_bShowMiles;
    m_bUseKm = dlg.m_bUseKm;

    if( pD->tsp.maxCycle != dlg.m_maxCycle )
    {
        pD->m_already = 0;
        pD->tsp.maxCycle = dlg.m_maxCycle;
    }

    if( oldUseKm != m_bUseKm )
	{
        pD->tsp.READ_USA_DATA( m_bUseKm );
        ShowCycleLength();
	}
    Invalidate(TRUE);
}


void CUSADemo::FormResultList()
{
	m_lbCapList.ResetContent();		

    CMainDoc* pD = GetDocument();

    for( int i=1; i<=pD->tsp.MAX_2; i++)
        for( int j=1; j<MAX_USA; j++ )
            if( pD->tsp.active_state[j]==pD->tsp.GZ[i] )
			{
				char s[256];
				sprintf( s,"%2d:%s (%s)", i, arr_states[j].capital,
						 		    	  	 arr_states[j].usa_state);
				m_lbCapList.AddString( s );
			}	
}

void CUSADemo::FormList(BOOL rand_start)
{
	TCHAR buf[256];

    CMainDoc* pD = GetDocument();

    pD->m_already = 0;

    int oldMAX_2 = pD->tsp.MAX_2;  //save previous MAX_2

    pD->tsp.calcMAX_2();           //calc new MAX_2
    int newMAX_2 = pD->tsp.MAX_2;  //and save it
    pD->tsp.MAX_2 = oldMAX_2;      //return old

    int allocOK = pD->tsp.ReAllocate( newMAX_2 );

    if( !allocOK ) {
      warn_me( IDS_USA_NO_MEMORY );
      pD->tsp.ReAllocate( oldMAX_2 );
    }

    pD->tsp.READ_USA_DATA( m_bUseKm );
    pD->tsp.Form_Cycle0( 1/*initOK*/, rand_start );

    FormResultList();  //only after FormC0
	
    NodeStr().SetWindowText( itoa(newMAX_2, buf, 10) );
	ShowCycleLength();

    FullTimeStr().SetWindowText( "" );

	Invalidate( TRUE );
}


void CUSADemo::OnResetList()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    for(int i=1; i<MAX_USA; i++)   pD->tsp.active_state[i] = i;

	FormList();
}

void CUSADemo::OnRandCycle0()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    FormList( TRUE/*rand*/);  //ShowCycle( 1/*initOK*/ );
}

void CUSADemo::OnSetList()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int i, arr[MAX_USA];
    int how_much = m_lbCapList.GetSelItems( MAX_USA, arr);

	if( how_much<4 )
	{
        warn_me( IDS_MIN_4STATES );
		return;
	}

    int act_st[MAX_USA];
    for( i=1; i<MAX_USA; i++ )   act_st[i] = pD->tsp.active_state[i];
    for( i=1; i<MAX_USA; i++ )   pD->tsp.active_state[i] = 0;

/////////////////////
    int cnt=0, cnt2=0;
    for( i=1; i<MAX_USA; i++ )
    {
      if( !act_st[i] )  continue;

      if( cnt==arr[cnt2] )
      {
        int num=0;
		for(int d=0; d<=MAX_USA; d++)
          if( act_st[d]==pD->tsp.GZ[ arr[cnt2]+1 ] )
          {
             num=d;  break;
          }
        pD->tsp.active_state[ num ] = cnt2+1;
        cnt2++;
        if(cnt2==how_much) break;
      }
      cnt++;
    }

    cnt=0;
    for(i=1; i<MAX_USA; i++)  {
      if( !pD->tsp.active_state[i] ) continue;
      cnt++;
      pD->tsp.active_state[i] = cnt;
    }

	FormList();
}

////////////////////////////////////////////////////////////////////
void CUSADemo::DoPolin()
{
    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );

    CMainDoc* pD = GetDocument();
    pD->polyn_go( &FullTimeStr(), &CycleLengthStr() );

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );
}


void CUSADemo::OnGo()
{
#ifdef DEBUG
    int fout=_lcreat("result.",0); _lclose(fout);
#endif

    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int randStarts = atoi(pD->m_randStarts);
    int randStarts2 = atoi(pD->m_randStarts2);
    if( !randStarts2 )  pD->tsp.D12orAX4 = D1_2;
    else                pD->tsp.D12orAX4 = AX4;

    if( !randStarts2)  randStarts2=1;

    int i, k, saveGZlast[MAX_1];

    DWORD save_polyn_time = 0;
    pD->all_time = timeGetTime();

    pD->test_cnt = pD->bad_cnt=0;

    pD->tsp.SUM000 = INT_MIN;

    was_error2=0;

    if(randStarts==1 || in_comparing)  {
      pD->tsp.Form_Cycle0( 0 );  //return initial cycle

      pD->tsp.elseFST=INT_MIN;

      FormResultList();  //only after FormC0
      DoPolin();
    }
    else
    {
      pD->m_already = 0;
      result = 1;
      DWORD the_start = timeGetTime();

      int povtor;

      int prev_sum, min_sum;

      pD->tsp.elseFST=INT_MIN;

      for(i=1; i<=randStarts; i++)
      {
        povtor = 0;
        pD->tsp.Form_Cycle0( 1, TRUE );
////////
        FormResultList();  //only after FormC0
        ShowCycleLength();
        ShowCycle( 1/*initOK*/ );
        Invalidate( TRUE );
/////////

        if(i>1)
          pD->tsp.elseFST=min_sum;

        if( i>=randStarts2+1)
          pD->tsp.SUM000 = min_sum; //pD->tsp.sumGZ;

        if( povtor ) povtor=1;

        if(was_error2 && pD->tsp.D12orAX4==D1_2)
          pD->tsp.SUM000 = INT_MIN;

        DoPolin();
        pD->tsp.SUM000 = INT_MIN;

        save_polyn_time += pD->pol_time;

        if( pD->m_already!=1 )  break;

        if(i==1 && !povtor)  {
          pD->tsp.save_min_cycle( 0/*save*/ );
          for(k=1; k<=pD->tsp.MAX_2; k++) {
            pD->tsp.saveGZinit[k] = pD->tsp.initGZ[k];
            saveGZlast[k] = pD->tsp.GZmin[k];
          }
          prev_sum = min_sum = pD->tsp.sumGZ;
        }
        else if( !pD->tsp.save_min_cycle( 1/*compare*/ ) )
		{
          int sum2 = pD->tsp.cycle_length( pD->tsp.GZmin );
          int sum1 = pD->tsp.cycle_length( pD->tsp.saveGZmin );
//msgbox("map: sumGZ=%d, saveGZ=%d, min=%d, prev=%d", sum2, sum1, min_sum, prev_sum);
          if(povtor) {k=1;}

          if( (pD->tsp.maxCycle && sum2>sum1) ||
             (!pD->tsp.maxCycle && sum2<sum1) )
          {
            min_sum = sum2;
            for(k=1; k<=pD->tsp.MAX_2; k++)  {
              pD->tsp.initGZ[k] = pD->tsp.saveGZinit[k];
              pD->tsp.GZmin[k] = saveGZlast[k];
            }
          }

          if(prev_sum != pD->tsp.sumGZ ) {
            pD->bad_cnt++;
            was_error2=1;
          }

          if(only1set || pD->tsp.D12orAX4==AX4) {
            result=0;
            break;
          }
        }

        prev_sum = pD->tsp.sumGZ;

        min_sum = pD->tsp.sumGZ;

      } //end FOR

      pD->pol_time = save_polyn_time;
      pD->ShowRealTime( /*the_start*/pD->all_time, &FullTimeStr() );
    }

    FormResultList();
    ShowCycleLength();  //???

    if( pD->bad_cnt && result==0 )
    {
      if( pD->tsp.D12orAX4==AX4 )  warn_me( IDS_MISMATCH_ERR );
      else                         warn_me( IDS_MISMATCH_ATT );
    }

    if( pD->m_already!=1 && pD->m_already!=3 && !in_comparing)
    {
      warn_me(IDS_USER_ABORT); //???
    }

    if( !pD->tsp.in_contin && !in_comparing && pD->test_cnt && m_bShowStat)
		pD->show_stat();

    Invalidate( TRUE );
}

void CUSADemo::ShowCycle(int initOK)
{
  CMainDoc* pD = GetDocument();

  if( initOK )
  {
    CycleLengthStr().SetWindowText("");
    FullTimeStr().SetWindowText("");
    pD->m_already = 0;  //!!!
  }
  else
    ShowCycleLength();

  pD->UpdateAllViews(this);
}

void CUSADemo::OnShowMatrix()
{
    CMtxDlg dlg( &(GetDocument()->tsp) );
    dlg.DoModal();

    Invalidate(TRUE);
}


void CUSADemo::ShowCycleLength()
{
	char s[80];
    sprintf( s, "%d ", GetDocument()->tsp.printGZ2(NULL));
    strcat( s, ( m_bUseKm? "km" : "ml") );
    CycleLengthStr().SetWindowText( s );
}

double factorial(int MAX_2)
{
    double CNT=2.;  
    for( int i=3; i<MAX_2; i++ )  //(n-1) factorial of cycles
		CNT *= (1.*i);
    return CNT;
}

void CUSADemo::OnGetFullTime()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

#ifndef SUPER_USER
    pD->m_already = 0;

    pD->CalcFullTime( pD->get_time_in_sec(), &FullTimeStr() );
#else
    CSuper dlg;
    char str[80];
    sprintf(str, "%d", tirUSA);  dlg.m_tir = str;
    sprintf(str, "%d", perUSA);  dlg.m_per = str;
    sprintf(str, "%.3f",fstUSA); dlg.m_fst = str;
    sprintf(str, "%.3f",scdUSA); dlg.m_scd = str;

    if( dlg.DoModal() != IDOK )  return;

    tirUSA = atoi(dlg.m_tir);
    perUSA = atoi(dlg.m_per);
    fstUSA = atof(dlg.m_fst);
    scdUSA = atof(dlg.m_scd);
#endif
}

void CUSADemo::OnTriangle()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    CTriangleDlg dlg( &(pD->tsp) );

    dlg.DoModal();

    Invalidate(TRUE);
}

void CUSADemo::OnCommonMethod()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int res = pD->init_exp( &FullTimeStr(), &CycleLengthStr(), in_comparing );
    if( !res )  return;
    exp_time = timeGetTime();

    SetClassLong(m_hWnd, GCL_HCURSOR, LONG( hWaitCur ));
    SetCursor( hWaitCur );
////
    get_time_text( pD->tsp.exp_time, pD->get_time_in_sec()); //!!!

    int ret_val;
    pD->tsp.lookALL( 0, &ret_val );

    if( !ret_val )  pD->m_already += 2;

    SetClassLong( m_hWnd, GCL_HCURSOR, LONG( hArrowCur ));
    SetCursor( hArrowCur );

    pD->test_cnt=1;

    exp_time = pD->ShowRealTime( exp_time, &FullTimeStr() );
	ShowCycleLength();
    FormResultList();
//msgbox("%d", pD->test_cnt);
    if( pD->m_already<2 && !in_comparing)  {
      warn_me(IDS_USER_ABORT);
    }

    Invalidate( TRUE );
}

void CUSADemo::OnTestBoth()
{
    CMainDoc* pD = GetDocument();
    if( pD->tsp.working ) return;

    int save_bad = pD->bad_cnt;
    int save_test= pD->test_cnt;
    pD->bad_cnt = pD->test_cnt= 0;

    in_comparing = 1;
    switch( pD->m_already )
    {
        case 0: //untested net
                OnCommonMethod();
                if( pD->m_already!=2 )  goto THE_END;
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();

                pD->ShowRealTime( pD->pol_time+exp_time, &FullTimeStr(), pD->pol_time );
                break;

        case 1: //IIG alg. test was completed. Common is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnCommonMethod();
                if( pD->m_already!=3 )  goto THE_END;
                break;

        case 2: //Common alg. test was completed. IIG is needed
                pD->tsp.save_min_cycle( 0/*save*/ );
                OnGo();
                break;

        case 3: info_me( IDS_ALREADY_COMPARED );
                pD->bad_cnt = save_bad;
                pD->test_cnt= save_test;
                in_comparing = 0;
                return;
    }
THE_END:
    in_comparing = 0;

    if( pD->m_already!=3 )
    {
       FullTimeStr().SetWindowText("");
       warn_me( IDS_USER_ABORT );
    }
    else  {
       result = pD->tsp.save_min_cycle( 1/*compare*/ );
       if( result )
         info_me( IDS_TIPTOP );
       else
       {
         pD->bad_cnt++;
         warn_me( IDS_MISMATCH_ERR );
       }
    }
}

//////////////////////////////////////////////////////////////////////
// CMapOptDlg dialog

CMapOptDlg::CMapOptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMapOptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapOptDlg)
	m_bShowMiles = FALSE;
	m_bUseKm = FALSE;
	m_maxCycle = FALSE;
	//}}AFX_DATA_INIT
}

void CMapOptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapOptDlg)
	DDX_Check(pDX, IDC_SHOW_MILES, m_bShowMiles);
	DDX_Check(pDX, IDC_KM_OR_MILES, m_bUseKm);
	DDX_Check(pDX, IDC_MAX_CYCLE, m_maxCycle);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMapOptDlg, CDialog)
	//{{AFX_MSG_MAP(CMapOptDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


//////////////////////////////////////////////////////////////
// CTriangleDlg dialog

CTriangleDlg::CTriangleDlg(TSP_random* _tsp, CWnd* pParent /*=NULL*/)
	: CDialog(CTriangleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTriangleDlg)
    tsp = _tsp;
	//}}AFX_DATA_INIT
}

void CTriangleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTriangleDlg)
    DDX_Control(pDX, IDC_TRIADS_LIST, m_lbTriadsList );
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTriangleDlg, CDialog)
	//{{AFX_MSG_MAP(CTriangleDlg)
    ON_BN_CLICKED(IDC_DO_TEST, OnDoTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CTriangleDlg message handlers

char *GetCapital( int idx, int* act_state )
{
    for(int i=1; i<MAX_USA; i++)
		if( act_state[i]==idx )  
			return arr_states[ i ].capital;

	return NULL;
}

void CTriangleDlg::OnDoTest() 
{
  int  x1,y1, x2,y2, x3,y3, cnt = 0;
  char s[255];

  int znak = 1;
  if(tsp->maxCycle && tsp->working) znak=-1;
  int MAX_2 = tsp->MAX_2;
//mesg("\r\n%d (%d)", znak, tsp->net[1][2]);
  m_lbTriadsList.ResetContent();

  for(x1=1; x1<=MAX_2-2; x1++)
    for(y1=x1+1; y1<=MAX_2; y1++)
    {
      //fix the first distance
      int d1 = znak * tsp->net[x1][y1];

      for(x2=1; x2<=MAX_2-1; x2++)
        for(y2=x2+1; y2<=MAX_2; y2++)
        {
          //fix the second distance
          int d2 = znak * tsp->net[x2][y2];
          if( x2<x1 || (x2==x1 && y2<=y1) )
            continue;

		  if( x1!=x2 && y1!=y2 && x1!=y2 && x2!=y1)
		  	continue;

          for(x3=1; x3<MAX_2; x3++)
            for(y3=x3+1; y3<=MAX_2; y3++)
            {
          	  if( x3<x2 || (x3==x2 && y3<=y2) )
                continue;

			  if( x1==x2 && (y1==x3 || y1==y3) && (y2==x3 || y2==y3) )
			  	;
			  else
			    continue;

              //fix the third distance
              int d3 = znak * tsp->net[x3][y3];
              int d_max = max( d1, max( d2,d3 ) );
              if( d_max==d1 && d1>d2+d3
               || d_max==d2 && d2>d1+d3
               || d_max==d3 && d3>d1+d2 )
              {
				 cnt++;

                 sprintf( s,"%4d:%s-%s-", cnt, GetCapital(x1,tsp->active_state),
                                               GetCapital(y1,tsp->active_state) );
				 if( x2!=x1 && x2!=y1 )
				 	d2 = x2;
				 else
				 	d2 = y2;
				 strcat( s, GetCapital(d2,tsp->active_state) );

				 m_lbTriadsList.AddString( s );
              }
            } //for(x3,y3)
        } //for(x2,y2)
    } //for(x1,y1)

	if( !cnt )
        m_lbTriadsList.AddString("No violation of the triangle inequality has been found.");
}

////////////////////////////////////////////////////////////////////
BOOL CTriangleDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
//  if( tsp->maxCycle )
//    ListTitle().SetWindowText("Triangle Inequality is not violated for:");

    CenterWindow();
    ShowWindow(SW_SHOW);

    OnDoTest();
    
    return TRUE;
}

///////////////////////////////////////////////////////////////////
CMapWnd::CMapWnd()
{
    m_bShowMiles = FALSE;
}

CMapWnd::~CMapWnd()
{
}

BEGIN_MESSAGE_MAP(CMapWnd, CStatic)
	//{{AFX_MSG_MAP(CMapWnd)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CMapWnd message handlers

void CMapWnd::OnPaint() 
{
    CPaintDC dc(this); // device context for painting
	
	// Do not call CStatic::OnPaint() for painting messages
	PaintUsaMap( &dc );
}

void CMapWnd::LoadMapImage( TSP_random* _tsp )
{
    tsp = _tsp;

    int idx;
    switch( resol ) {
      case 1: idx = IDB_USA_MAP2; break;
      case 2: idx = IDB_USA_MAP;  break;
//    case 3: idx = IDB_USA_MAP3; break;
    }
    VERIFY( m_Bitmap.LoadBitmap( idx ) );
}

int CMapWnd::GetX( int idx )
{
double mn=1.;
if(resol==1) mn=0.8;
if(resol==3) mn=1.25;
    for(int i=1; i<MAX_USA; i++)
        if( tsp->active_state[i]==idx )   return (int)(mn*arr_states[ i ].x);
	return 0;
}

int CMapWnd::GetY( int idx )
{
double mn=1.;
if(resol==1) mn=0.8;
if(resol==3) mn=1.25;
    for(int i=1; i<MAX_USA; i++)
        if( tsp->active_state[i]==idx )   return (int)(mn*arr_states[ i ].y);
	return 0;
}

void CMapWnd::PaintUsaMap( CDC* pDC )
{
	if( m_Bitmap.m_hObject == NULL )  return;
	
	BITMAP bm;
	m_Bitmap.GetObject( sizeof(BITMAP), &bm );
	CSize size = CSize( bm.bmWidth, bm.bmHeight );

	CDC dc;
	VERIFY( dc.CreateCompatibleDC( pDC ) );
	CBitmap* pOldBitmap = dc.SelectObject( &m_Bitmap );
	pDC->BitBlt( 0,0,size.cx,size.cy, &dc, 0,0, SRCCOPY );
	dc.SelectObject( pOldBitmap );

	CPen pen;
	pen.CreatePen( PS_SOLID, 1, RGB(255,0,0) );
	CPen* pOldPen = pDC->SelectObject( &pen );

   	CFont *pOldFont;
	if( m_bShowMiles )
	{
   		CFont fnt;
    	LOGFONT logfont;
		memset(&logfont, 0, sizeof(logfont));
    	logfont.lfHeight = 12; //logfont.lfWeight = FW_BOLD;
		CString szFont;
		szFont.LoadString(IDS_FONT_NAME);       // TrueType font
		lstrcpy(logfont.lfFaceName, szFont);
    	VERIFY( fnt.CreateFontIndirect(&logfont) );
        pOldFont = pDC->SelectObject( &fnt );
	}

	CPoint pt;
    int i,j,k, x,y, x1,y1;
	
    int uz = (tsp->working)? tsp->GZmin[1]: tsp->GZ[1];
    pt.x = x = GetX( uz );
    pt.y = y = GetY( uz );

    for(i=2; i<=tsp->MAX_2; i++)
	{
        x1 = pt.x;
        y1 = pt.y;

        pDC->MoveTo( pt );

        uz = (tsp->working)? tsp->GZmin[i]: tsp->GZ[i];
        pt.x = GetX( uz );
        pt.y = GetY( uz );
        pDC->LineTo( pt );

        if( m_bShowMiles )
        {
            x1 = (x1+pt.x)/2;
            y1 = (y1+pt.y)/2;

            tsp->get_jk( i-1, &j,&k); //-1!!!
            int net_val = tsp->net[j][k];
            if( tsp->maxCycle && tsp->working )  net_val *= -1;
            one_legend( pDC, net_val, x1,y1, Colors[15]);
        }
	}

    x1 = (pt.x+x)/2;
    y1 = (pt.y+y)/2;
    
	pDC->MoveTo( pt );
    pt.x = x; 
    pt.y = y; 
    pDC->LineTo( pt );

	if( m_bShowMiles )
	{
        tsp->get_jk( tsp->MAX_2, &j,&k);
        int net_val = tsp->net[j][k];
        if( tsp->maxCycle && tsp->working )  net_val *= -1;
        one_legend( pDC, net_val, x1,y1, Colors[15]);
		DeleteObject( pDC->SelectObject( pOldFont ) );
	}
	DeleteObject( pDC->SelectObject( pOldBitmap ) );
	DeleteObject( pDC->SelectObject( pOldPen ) );
}

