/////////////////////////////////////////////////////////////////
class CMapWnd : public CStatic
{
// Construction
public:
	CMapWnd();

// Attributes
public:
    BOOL    m_bShowMiles;
    TSP_random *tsp;
    int GetX(int idx);
    int GetY(int idx);
    CBitmap  m_Bitmap;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMapWnd();

    void LoadMapImage(TSP_random *);
	void PaintUsaMap( CDC* pDC=NULL );

	// Generated message map functions
protected:
	//{{AFX_MSG(CMapWnd)
	afx_msg void OnPaint();
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////
class CUSADemo : public CFormView
{
    DECLARE_DYNCREATE(CUSADemo)
// Construction
protected:
    CUSADemo();

public:
    void FormList( BOOL rand_start=FALSE );
	void FormResultList();
	void ShowCycleLength();
    void DoPolin();
    void  ShowCycle( int );

    CEdit& NodeStr()		{ return *(CEdit*)GetDlgItem(IDC_NODES); }
    CEdit& CycleLengthStr()	{ return *(CEdit*)GetDlgItem(IDC_CYCLE_LENGTH); }
    CEdit& FullTimeStr()	{ return *(CEdit*)GetDlgItem(IDC_FULL_TIME); }
    CEdit& RandStr()        { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS); }
    CEdit& RandStart2()     { return *(CEdit*)GetDlgItem(IDC_RAND_STARTS2); }

// Dialog Data
    //{{AFX_DATA(CUSADemo)
	enum { IDD = IDD_USA_DEMO };
    BOOL     m_bUseKm;
    CString  m_randStarts;
    CString m_randStarts2;
    CMapWnd  m_MapWnd;
    CListBox m_lbCapList;
    HCURSOR  hArrowCur;
    HCURSOR  hWaitCur;
    CFont    fnt;
    int      in_comparing;
    int      result;
    DWORD    exp_time;
    //}}AFX_DATA

// Attributes
public:
    CMainDoc* GetDocument()  {
        ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMainDoc)));
        return (CMainDoc*) m_pDocument;
    }

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
    virtual void OnInitialUpdate();

	// Generated message map functions
    //{{AFX_MSG(CUSADemo)
	afx_msg void OnDataChange();
	afx_msg void OnMapOptions();
	afx_msg void OnGo();
	afx_msg void OnShowMatrix();
	afx_msg void OnResetList();
	afx_msg void OnSetList();
    afx_msg void OnGetFullTime();
	afx_msg void OnTriangle();
    afx_msg void OnCommonMethod();
	afx_msg void OnTestBoth();
	afx_msg void OnRandCycle0();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

////////////////////////////////////////////////////////////////
class CMapOptDlg : public CDialog
{
// Construction
public:
	CMapOptDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CMapOptDlg)
	enum { IDD = IDD_MAP_OPTIONS };
    BOOL    m_bShowMiles;
    BOOL    m_bUseKm;
	BOOL	m_maxCycle;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapOptDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CMapOptDlg)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////
class CTriangleDlg : public CDialog
{
// Construction
public:
    CTriangleDlg(TSP_random*, CWnd* pParent = NULL);

// Dialog Data
	//{{AFX_DATA(CTriangleDlg)
	enum { IDD = IDD_TRIANGLE };
	CListBox	m_lbTriadsList;
    TSP_random* tsp;
	//}}AFX_DATA

    CEdit& ListTitle()  { return *(CEdit*)GetDlgItem(IDC_NODES/*STATIC*/); }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTriangleDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTriangleDlg)
    afx_msg void OnDoTest();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

